var flexygo;
(function (flexygo) {
    var pda;
    (function (pda) {
        var articulo;
        (function (articulo) {
            //Recupera el tipo de unidad 
            articulo.TipoUnidad = (IdArticulo, IdEmbalaje) => {
                let promesa = new Promise(function (resolve, reject) {
                    //ASÍNCRONO: Cargar tipos de unidades
                    let proc = new flexygo.Process('SGA_PDA_dll_DameTiposUnidades', null, null);
                    let params = [
                        { 'Key': 'IdArticulo', 'Value': IdArticulo },
                        { 'Key': 'IdEmbalaje', 'Value': IdEmbalaje }
                    ];
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                            }
                            if (response.LastException && response.LastException.Message) {
                                return reject(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                return reject(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                return resolve(response.Data.TipoCantidad);
                            }
                        }
                    });
                });
                return promesa;
            };
            //Busca un artículo por campo de búsqueda y devuelve datos para mostrar/ocultar campos de lotes, propiedades, etc
            articulo.Buscar = (CampoBusqueda) => {
                let promesa = new Promise(function (resolve, reject) {
                    let proc = new flexygo.Process('SGA_PDA_dll_BuscaArticulo', null, null);
                    let params = [{ "Key": "CampoBusqueda", "Value": CampoBusqueda }];
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                return resolve();
                            }
                            if (response.LastException && response.LastException.Message) {
                                return reject(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                return reject(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                return resolve(response.Data);
                            }
                        }
                    });
                });
                return promesa;
            };
            //Convierte entre unidades
            articulo.ConvertirUnidades = (IdArticulo, NumLote, IdEmbalaje, UnidadLectura, CantidadLectura) => {
                let promesa = new Promise(function (resolve, reject) {
                    //ASÍNCRONO: Cargar tipos de unidades
                    let proc = new flexygo.Process('SGA_PDA_dll_DameStockUnidades', null, null);
                    let params = [
                        { 'Key': 'IdArticulo', 'Value': IdArticulo },
                        { 'Key': 'NumLote', 'Value': NumLote },
                        { 'Key': 'IdEmbalaje', 'Value': IdEmbalaje },
                        { 'Key': 'Unidad_Leida', 'Value': UnidadLectura },
                        { 'Key': 'Cantidad_Leida', 'Value': CantidadLectura }
                    ];
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                return resolve();
                            }
                            if (response.LastException && response.LastException.Message) {
                                return reject(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                return reject(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                return resolve(response.Data);
                            }
                        }
                    });
                });
                return promesa;
            };
        })(articulo = pda.articulo || (pda.articulo = {}));
    })(pda = flexygo.pda || (flexygo.pda = {}));
})(flexygo || (flexygo = {}));
//# sourceMappingURL=articulo.js.map