/**
 * @namespace flexygo.pda.aviso
 */
var flexygo;
(function (flexygo) {
    var pda;
    (function (pda) {
        var aviso;
        (function (aviso_1) {
            aviso_1.loadParametroAviso = () => {
                let parametroEnt = new flexygo.obj.Entity(`SGA_PDA_Configuracion`, `Parametro = 'Avisos_Activar'`);
                parametroEnt.read();
                if (parametroEnt.data.Valor.Value == "ON") {
                    flexygo.pda.aviso.loadAvisos();
                }
            };
            let interval;
            aviso_1.loadAvisos = () => {
                clearInterval(interval);
                let parametroIntervalEnt = new flexygo.obj.Entity(`SGA_PDA_Configuracion`, `Parametro = 'Avisos_Intervalo'`);
                parametroIntervalEnt.read();
                let AvisosEnt = new flexygo.obj.Entity(`SGA_PDA_Aviso`);
                AvisosEnt.read();
                interval = setInterval(function () {
                    let conexion = flexygo.pda.OnlineCheck();
                    conexion.then(function () {
                        let numAvisos = AvisosEnt.getViewCount("SGA_PDA_v_AvisosUsuario", `IdEmpleado = ${flexygo.context.currentReference} AND Leido = 0`);
                        if (numAvisos > 0) {
                            let avisos = AvisosEnt.getView("SGA_PDA_v_AvisosUsuario", 0, 100, `IdEmpleado = ${flexygo.context.currentReference} AND Leido = 0`, "", null);
                            flexygo.pda.aviso.createDialogAvisos(avisos);
                        }
                        else {
                            if ($("#dialogAvisos")) {
                                $("#dialogAvisos").remove();
                            }
                        }
                    });
                    conexion.catch(function () { console.log("Error OnlineCheck Avisos"); });
                }, parametroIntervalEnt.data.Valor.Value * 1000);
            };
            aviso_1.createDialogAvisos = (avisos) => {
                if ($("#dialogAvisos")) {
                    $("#dialogAvisos").remove();
                }
                $("body").append(`<div class='d-none customDialog' id='dialogAvisos' title='Avisos'><div id="contAvisos"></div></div>`);
                $('#dialogAvisos').switchClass("d-none", "d-block");
                $('#dialogAvisos').dialog({
                    minWidth: 300,
                    width: $("#mainContent").width(),
                    position: ['center', 20],
                    maxHeight: $("#mainContent").height()
                });
                avisos.map((aviso) => {
                    $("#contAvisos")[0].insertAdjacentHTML('beforeend', flexygo.pda.aviso.createAviso(aviso));
                });
            };
            aviso_1.createAviso = (aviso) => {
                return `<div class="row col-12 row-line listDetailPDA" onclick="flexygo.pda.aviso.openAviso(${aviso.IdAviso})" class="col-12" id="Aviso_${aviso.IdAviso}">
                    <div class="col-12">
                        <b><i class="flx-icon icon-employees margin-right-m txt-outstanding"></i> ${aviso.Nombre} ${aviso.Apellidos}</b>
                    </div>
                    <div class="col-12">
                        <i class="flx-icon icon-calendar-7 margin-right-m txt-outstanding"></i>
                        ${flexygo.pda.convertDate(aviso.FechaCreacion)}
                    </div>
                    <div class="col-12">
                        <i class="flx-icon icon-text-1 margin-right-m txt-outstanding"></i> ${aviso.Descrip}
                    </div>
                </div>`;
            };
            aviso_1.openAviso = (IdAviso) => {
                if ($("#dialogAviso")) {
                    $("#dialogAviso").remove();
                }
                $("body").append(`<div class='d-none customDialog' id='dialogAviso' title='Aviso'><div id="contAviso"></div></div>`);
                $('#dialogAviso').switchClass("d-none", "d-block");
                $('#dialogAviso').dialog({
                    minWidth: 300,
                    width: $("#mainContent").width(),
                    position: ['center', 20],
                    maxHeight: $("#mainContent").height()
                });
                $("#contAviso")[0].insertAdjacentHTML('beforeend', flexygo.pda.aviso.createAvisoVisualizacion(IdAviso));
            };
            aviso_1.createAvisoVisualizacion = (IdAviso) => {
                var avisoEnt = new flexygo.obj.Entity('SGA_PDA_Aviso');
                let aviso = avisoEnt.getView("SGA_PDA_v_AvisosUsuario", 0, 1, `IdAviso = ${IdAviso}`, "", null);
                return `<div class="col-12">
                    <div class="col-12">
                        <span class="labelPDA txt-outstanding">De: </span>${aviso[0].Nombre} ${aviso[0].Apellidos}
                    </div>
                    <div class="col-12">
                        <span class="labelPDA txt-outstanding">Fecha: </span>
                        <b>${flexygo.pda.convertDate(aviso[0].FechaCreacion)}</b>
                    </div>
                    <div class="col-12">
                        <span class="labelPDA txt-outstanding">Asunto: </span>${aviso[0].Descrip}
                    </div>
                    <div class="col-12">
                        <span class="labelPDA txt-outstanding">Mensaje: </span> ${aviso[0].Observaciones}
                    </div>
                    </div>
                    <div class="col-12">
                        <button style="float:right;" onclick="flexygo.pda.aviso.marcarAvisoComoLeido(${IdAviso})" class="menu-button bg-outstanding float-right margin-top-l">LEÍDO</button>
                    </div>`;
            };
            aviso_1.marcarAvisoComoLeido = (IdAviso) => {
                let proc = new flexygo.Process('SGA_PDA_dll_MarcarAvisoLeido', null, null);
                let params = [{ 'Key': 'IdAviso', 'Value': IdAviso }];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.SuccessMessage) {
                            if ($("#dialogAviso")) {
                                $("#dialogAviso").remove();
                            }
                            $(`#Aviso_${IdAviso}`).remove();
                            flexygo.pda.aviso.loadAvisos();
                        }
                    }
                });
            };
            //Evento lanzado en la carga del navegador, antes estaba en el afterlogin pero al modificarse su ejecución únicamente se comprueba ahora cuando hay un login
            $(document).ready(function () {
                flexygo.pda.aviso.loadParametroAviso();
            });
        })(aviso = pda.aviso || (pda.aviso = {}));
    })(pda = flexygo.pda || (flexygo.pda = {}));
})(flexygo || (flexygo = {}));
//# sourceMappingURL=aviso.js.map