var flexygo;
(function (flexygo) {
    var pda;
    (function (pda) {
        var bulto;
        (function (bulto) {
            //GENÉRICO: El evento OnKeyUp se usa para no lanzar la acción del enter sobre los focos de botón. Es necesario un OnKeyDown sólo para el tabulador
            bulto.readKeyTab = (e, funcname, params) => {
                if (e.keyCode == 9) {
                    e.preventDefault();
                    flexygo.pda.bulto[funcname].apply(flexygo.pda.bulto, params);
                }
                else {
                    return;
                }
            };
            //GENÉRICO: Lectura de carácteres de entrada y ejecución de la función cuando se recibe ENTER
            bulto.readByCharacter = (e, funcname, params) => {
                if (e.keyCode == 13) {
                    flexygo.pda.bulto[funcname].apply(flexygo.pda.bulto, params);
                }
                else {
                    return;
                }
            };
            bulto.BultoLiquidar = (IdDocDetalle, CodUbicacion) => {
                let promesa = new Promise(function (resolve, reject) {
                    let proc = new flexygo.Process('SGA_PDA_ubicacion_bultoliquidar', null, null);
                    let params = [{ 'Key': 'IdDocDetalle', 'Value': IdDocDetalle }, { 'Key': 'CodUbicacion', 'Value': CodUbicacion }];
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                return resolve();
                            }
                            if (response.LastException && response.LastException.Message) {
                                return reject(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                return reject(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                return resolve(response.Data);
                            }
                        }
                    });
                });
                return promesa;
            };
            //BUSCADOR COMBOS: Método de lectura por campos IdBulto y Codigo de objeto SGA_PDA_Bulto, para dupla flx-text y flx-dbcombo.
            bulto.LeerBultoCombo = (item, event) => {
                let promesa = new Promise(function (resolve, reject) {
                    //Parámetros
                    let params = $(`.param`);
                    let pbCodigo = $('flx-text[name = "pbCodigoBulto"]');
                    let pbCombo = $('flx-dbcombo[name = "pbComboBulto"]');
                    //Valor de búsqueda del campo de texto o del combo
                    let valorBusqueda = ((item.tagName).toLowerCase() == "flx-text") ? pbCodigo.val() : pbCombo.val();
                    if (!valorBusqueda) {
                        return resolve();
                    }
                    ;
                    //Defaults de la página
                    let myModule = $('flx-module')[0];
                    let page = flexygo.history.get(myModule);
                    let auxdef;
                    try {
                        auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                    }
                    catch (e) {
                        auxdef = {};
                    }
                    //Campo que indica si la lectura se ha llevado a cabo
                    let read = false;
                    //Si ha cambiado el valor del combo. Evitamos lanzar la búsqueda con el mismo valor.
                    if (auxdef.valorBusqueda != valorBusqueda) {
                        //En caso de recibir parámetro con longitudes a tener en cuenta, y se trata del campo de texto, se verifica si se ha legeado al tamaño del parámetro
                        read = params ? (((item.tagName).toLowerCase() == "flx-text") ? flexygo.pda.readCode(params, valorBusqueda, event) : true) : true;
                    }
                    //Si damos la entrada como buena
                    if (read) {
                        flexygo.pda.addLock();
                        //Recuperamos el código para aquellos casos que introduzcan el bulto. Necesario porque el proceso de búsqueda rellena la tabla temporal con la descripción
                        if ((item.tagName).toLowerCase() != "flx-text") {
                            let BultoEnt = new flexygo.obj.Entity(`SGA_PDA_BULTOS`, `IdBulto = ${valorBusqueda}`);
                            BultoEnt.read();
                            valorBusqueda = (BultoEnt.data.CodBarras1.Value) ? BultoEnt.data.CodBarras1.Value : valorBusqueda;
                        }
                        //Debo validar este bulto y buscar si ese codigo de barras existe entre todos los que hay
                        let proc = new flexygo.Process('SGA_PDA_dll_Bulto_BuscarPorCodigoBarras', null, null);
                        let params = [{ "Key": "CodBulto", "Value": valorBusqueda }];
                        proc.run(params, (response) => {
                            if (response) {
                                if (response.JSCode) {
                                    flexygo.pda.removeLock();
                                    var func = new Function(response.JSCode);
                                    func.call(response.JSCode);
                                    return resolve();
                                }
                                if (response.LastException && response.LastException.Message) {
                                    return reject(response.LastException.Message);
                                }
                                else if (response.WarningMessage) {
                                    return reject(response.WarningMessage);
                                }
                                else if (response.SuccessMessage) {
                                    if (!response.Data.IdBulto) {
                                        flexygo.pda.bulto.LimpiarBulto(true);
                                        return reject("No se ha encontrado ningún bulto que coincida con el criterio de búsqueda introducido.");
                                    }
                                    //Encontramos módulos a visualizar y los cargamos
                                    $("flx-module.LecturaBultoDatos").find('flx-list, flx-view').map(function (indice, modulo) {
                                        let module = $(modulo)[0];
                                        module.additionalWhere = `IdBulto = '${response.Data.IdBulto}'`;
                                        module.init();
                                    });
                                    //Valor por defecto para evitar lanzar búsquedas sin cambio de valor
                                    auxdef.valorBusqueda = valorBusqueda;
                                    page.defaults = JSON.stringify(auxdef);
                                    //Relación de campo texto/combo
                                    if ((item.tagName).toLowerCase() == "flx-text" && pbCombo[0]) {
                                        pbCombo[0].additionalWhere = `IdBulto = '${response.Data.IdBulto}'`;
                                        pbCombo[0].refresh();
                                        pbCombo.val(response.Data.IdBulto);
                                    }
                                    else {
                                        pbCodigo.val(valorBusqueda);
                                    }
                                    //Foco automático por propiedad tabindex en los campos
                                    flexygo.pda.setAutomaticFocus(item);
                                    //Cerramos spinner
                                    flexygo.pda.removeLock();
                                    return resolve(response.Data);
                                }
                            }
                        });
                    }
                });
                return promesa;
            };
            //BUSCADOR COMBOS: Botón de limpieza del campo de texto de bulto, combo y módulos con datos.
            bulto.LimpiarBulto = (LimpiarModulos) => {
                //Controles
                let params = $(`.param`);
                let pbCodigo = $('flx-text[name = "pbCodigoBulto"]');
                let pbCombo = $('flx-dbcombo[name = "pbComboBulto"]');
                //Campos de ubicación
                pbCodigo.val(null);
                //Filtro del combo
                pbCombo[0].additionalWhere = `IdAlmacen = '${flexygo.context.currentAlmacen}'`;
                pbCombo[0].refresh();
                pbCombo.val(null);
                //Encontramos módulos a visualizar y los limpiamos
                if (LimpiarModulos) {
                    $("flx-module.LecturaBultoDatos").find('flx-list, flx-view').map(function (indice, modulo) {
                        let module = $(modulo)[0];
                        module.additionalWhere = "1 = 0";
                        module.init();
                    });
                }
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                auxdef.valorBusqueda = "";
                page.defaults = JSON.stringify(auxdef);
                //Foco
                pbCodigo[0].querySelector("input").focus();
            };
            //VALIDAR BULTO: Validación del trabajo de bulto
            bulto.Validar = (item) => {
                //Parámetros
                let pbCodigo = $('flx-text[name = "pbCodigoBulto"]');
                let pbCombo = $('flx-dbcombo[name = "pbComboBulto"]');
                //Tiene que existir lectura
                if ((!pbCodigo.val() && !pbCombo.val()) || (pbCodigo.val() == "" && pbCombo.val() == "")) {
                    flexygo.msg.warning("Introduzca el bulto a validar.");
                    pbCodigo[0].querySelector("input").focus();
                    pbCodigo[0].querySelector("input").select();
                    return;
                }
                //Se valida y finaliza el trabajo asociado en caso de existir
                flexygo.pda.addLock();
                var proc = new flexygo.Process('SGA_PDA_dll_Bulto_Validar', null, null);
                let params = [{ 'Key': 'CodBulto', 'Value': pbCodigo.val() }];
                proc.run(params, function (response) {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                        else if (response.SuccessMessage) {
                            flexygo.pda.bulto.LimpiarBulto(true);
                            flexygo.msg.success("Trabajo finalizado correctamente", null, '');
                            return;
                        }
                        flexygo.pda.removeLock();
                    }
                    //Foco al campo de lectura
                    pbCodigo[0].querySelector("input").focus();
                    pbCodigo[0].querySelector("input").select();
                });
            };
        })(bulto = pda.bulto || (pda.bulto = {}));
    })(pda = flexygo.pda || (flexygo.pda = {}));
})(flexygo || (flexygo = {}));
//# sourceMappingURL=bulto.js.map