var flexygo;
(function (flexygo) {
    var pda;
    (function (pda) {
        var consolidar;
        (function (consolidar) {
            //GENÉRICO: El evento OnKeyUp se usa para no lanzar la acción del enter sobre los focos de botón. Es necesario un OnKeyDown sólo para el tabulador
            consolidar.readKeyTab = (e, funcname, params) => {
                if (e.keyCode == 9) {
                    e.preventDefault();
                    flexygo.pda.consolidar[funcname].apply(flexygo.pda.consolidar, params);
                }
                else {
                    return;
                }
            };
            //GENÉRICO: Lectura de carácteres de entrada y ejecución de la función cuando se recibe ENTER
            consolidar.readByCharacter = (e, funcname, params) => {
                if (e.keyCode == 13) {
                    flexygo.pda.consolidar[funcname].apply(flexygo.pda.consolidar, params);
                }
                else {
                    return;
                }
            };
            //SELECCIÓN BULTO ORIGEN: Al entrar en la página de selección de bulto de origen se borra la selección previa del terminal
            consolidar.borrarinicial = (e) => {
                let valor = 0;
                let proc = new flexygo.Process('SGA_PDA_dll_Consolidar_BorrarInicial', null, null);
                let params = [{ 'Key': 'valor', 'Value': valor }];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                    }
                });
            };
            //SELECCIÓN BULTO ORIGEN: lectura del bulto por campo de texto o combo
            //SELECCIÓN BULTO DESTINO: lectura del bulto por campo de texto o combo
            consolidar.LeerBultoConsolidar = (e, event) => {
                //Parámetros
                let params = $(`.param`);
                let pbCodigo = $('flx-text[name = "pbCodigoBulto"]');
                let pbCombo = $('flx-dbcombo[name = "pbComboBulto"]');
                //Valor de búsqueda del campo de texto o del combo
                let valorBusqueda = ((e.tagName).toLowerCase() == "flx-text") ? pbCodigo.val() : pbCombo.val();
                if (!valorBusqueda) {
                    return;
                }
                ;
                //Campo que indica si la lectura se ha llevado a cabo
                let read = false;
                //En caso de recibir parámetro con longitudes a tener en cuenta, y se trata del campo de texto, se verifica si se ha legeado al tamaño del parámetro
                read = params ? (((e.tagName).toLowerCase() == "flx-text") ? flexygo.pda.readCode(params, valorBusqueda, event) : true) : true;
                if (!read) {
                    return;
                }
                flexygo.pda.addLock();
                //Se lanza la búsqueda
                let lectura = flexygo.pda.bulto.LeerBultoCombo(e, event);
                lectura.then(function (Datos) {
                    if (Datos) {
                        //Validar el estado del bulto
                        let bultoEnt = new flexygo.obj.Entity(`SGA_PDA_Bulto`, `IdBulto = '${Datos.IdBulto}'`);
                        bultoEnt.read();
                        //No debe estar liquidado
                        if (bultoEnt.data.IdEstado.Value == 4) {
                            flexygo.pda.bulto.LimpiarBulto(true);
                            flexygo.msg.warning("No se puede manipular un bulto en estado liquidado", null, '');
                            return;
                        }
                        //Se valida el trabajo en consolidaciones
                        let proc = new flexygo.Process('SGA_PDA_dll_PDA_Bulto_EstadoTrabajo', null, null);
                        let params = [{ 'Key': 'IdBulto', 'Value': Datos.IdBulto }];
                        proc.run(params, (response) => {
                            if (response) {
                                if (response.JSCode) {
                                    var func = new Function(response.JSCode);
                                    func.call(response.JSCode);
                                    flexygo.pda.removeLock();
                                }
                                if (response.LastException && response.LastException.Message) {
                                    flexygo.pda.bulto.LimpiarBulto(true);
                                    flexygo.msg.error(response.LastException.Message);
                                }
                                else if (response.WarningMessage) {
                                    flexygo.pda.bulto.LimpiarBulto(true);
                                    flexygo.msg.warning(response.WarningMessage);
                                }
                            }
                            flexygo.pda.removeLock();
                        });
                    }
                });
                lectura.catch(function (error) {
                    if (error && error != "") {
                        flexygo.msg.warning(error);
                    }
                });
            };
            //SELECCIÓN BULTO ORIGEN: botón "Bulto Completo" que lanza la acción sobre el bulto leído
            consolidar.completo = (e, IdBultoLect) => {
                let pgn;
                let IdBulto = IdBultoLect.val();
                if (!IdBulto) {
                    flexygo.msg.warning("Selecciona un bulto", null, '');
                    return;
                }
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let modList = $(`[modulename=SGA_PDA_m_Articulo_Listado_new]flx-list`)[0];
                let CodBarras1;
                if (IdBulto) {
                    let bultoEnt = new flexygo.obj.Entity(`SGA_PDA_Bulto`, "IdBulto = " + IdBulto);
                    bultoEnt.read();
                    CodBarras1 = bultoEnt.data.CodBarras1.Value;
                }
                let codBarras1;
                let cboArticulo;
                let Cantidad;
                let Lote;
                let LoteOld;
                //Propiedades
                let P1 = "";
                let P2 = "";
                let P3 = "";
                let P4 = "";
                let P5 = "";
                let P6 = "";
                let P7 = "";
                let P8 = "";
                let P9 = "";
                let P10 = "";
                let long = modList.data.length;
                let paso = 0;
                if (modList.data) {
                    flexygo.pda.addLock();
                    //chkDespreparacion
                    if ($('input:radio[name=TipoCons]:checked').val() == 3) {
                        let Procesar = false;
                        for (let step = 0; step < long; step++) {
                            if (modList.data[step].IdArticulo) {
                                //validar primero, utilizamos el lote que tenia el articulo ya que si no piensa que no es el del bulto
                                let proc = new flexygo.Process('SGA_PDA_dll_PDA_Bulto_ValidaLecturaConsProp', null, null);
                                let params = [
                                    { 'Key': 'IdBultoOrigen', 'Value': IdBulto },
                                    { 'Key': 'CodBarras', 'Value': CodBarras1 },
                                    { 'Key': 'IdArticulo', 'Value': modList.data[step].IdArticulo },
                                    { 'Key': 'P1', 'Value': modList.data[step].P1 },
                                    { 'Key': 'Lote', 'Value': modList.data[step].Lote },
                                    { 'Key': 'Cantidad', 'Value': modList.data[step].Cantidad },
                                    { 'Key': 'P2', 'Value': modList.data[step].P2 },
                                    { 'Key': 'P3', 'Value': modList.data[step].P3 },
                                    { 'Key': 'P4', 'Value': modList.data[step].P4 },
                                    { 'Key': 'P5', 'Value': modList.data[step].P5 },
                                    { 'Key': 'P6', 'Value': modList.data[step].P6 },
                                    { 'Key': 'P7', 'Value': modList.data[step].P7 },
                                    { 'Key': 'P8', 'Value': modList.data[step].P8 },
                                    { 'Key': 'P9', 'Value': modList.data[step].P9 },
                                    { 'Key': 'P10', 'Value': modList.data[step].P10 }
                                ];
                                proc.run(params, (response) => {
                                    if (response) {
                                        if (response.JSCode) {
                                            var func = new Function(response.JSCode);
                                            func.call(response.JSCode);
                                            flexygo.pda.removeLock();
                                        }
                                        if (response.LastException && response.LastException.Message) {
                                            flexygo.msg.error(response.LastException.Message);
                                        }
                                        else if (response.WarningMessage) {
                                            flexygo.msg.warning(response.WarningMessage);
                                        }
                                    }
                                });
                                paso = step;
                            }
                        }
                        if (paso == long - 1) {
                            //despraparar
                            let proc = new flexygo.Process('SGA_PDA_dll_Manipular_Bultos_Despreparar', null, null);
                            let params = [{ 'Key': 'IdBulto', 'Value': IdBulto }, { 'Key': 'Completo', 'Value': true }];
                            if (IdBulto) {
                                proc.run(params, (response) => {
                                    if (response) {
                                        if (response.JSCode) {
                                            var func = new Function(response.JSCode);
                                            func.call(response.JSCode);
                                            flexygo.pda.removeLock();
                                        }
                                        if (response.LastException && response.LastException.Message) {
                                            flexygo.msg.error(response.LastException.Message);
                                        }
                                        else if (response.WarningMessage) {
                                            flexygo.msg.warning(response.WarningMessage);
                                        }
                                        else if (response.SuccessMessage) {
                                            flexygo.msg.success("Proceso ejecutado con éxito.", null, null);
                                            flexygo.pda.limpiarFiltro('#CodBarras1, #cboBulto', 'SGA_PDA_m_Articulo_Listado_new', 'flx-list', null);
                                        }
                                    }
                                });
                            }
                            else {
                                flexygo.msg.warning("Indique bulto", null, '');
                            }
                        }
                    }
                    else {
                        if (IdBulto) {
                            let auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                            auxdef.IdBulto = IdBulto;
                            let repal = false;
                            if ($('input:radio[name=TipoCons]:checked').val() == 2) {
                                repal = true;
                            }
                            else {
                                repal = false;
                            }
                            auxdef.Repaletizado = repal;
                            auxdef.BultoCompleto = true;
                            page.defaults = JSON.stringify(auxdef);
                            pgn = 'PDA_pg_Consolidar_Completo';
                            flexygo.nav.openPageName(pgn, '', '', page.defaults, 'current', true);
                        }
                        else {
                            flexygo.msg.warning("Indique bulto", null, '');
                        }
                    }
                }
                else {
                    flexygo.msg.warning("Selecciona un bulto", null, '');
                }
            };
            //SELECCIÓN BULTO ORIGEN: opción de lectura de artículo que abre página LECTURA DE ARTÍCULO
            consolidar.articulo = (e, IdArticuloLect, IdBultoLect, CodBarras1Lect, modName, IdDetalleLect) => {
                let IdArticulo = IdArticuloLect.val();
                let IdDetalle = IdDetalleLect.val();
                let IdBultoOrigen = IdBultoLect.val();
                let CodBarras1 = CodBarras1Lect.val();
                if (!IdArticulo) {
                    flexygo.msg.warning("No ha seleccionado un articulo", null, '');
                    return;
                }
                if (!IdBultoOrigen) {
                    flexygo.msg.warning("Indique un bulto", null, '');
                    return;
                }
                //Datos de la lectura
                let module2 = $(`[modulename=${modName}]flx-list`)[0];
                const datos = module2.data.filter(detalle => detalle.IdDetalle === IdDetalle);
                let DescripArticulo = datos.DescripArticulo;
                let Lote = datos.Lote;
                let LoteProv = datos.LoteProv;
                let P1 = datos.P1;
                let P2 = datos.P2;
                let repal = ($('input:radio[name=TipoCons]:checked').val() == 2);
                let despre = ($('input:radio[name=TipoCons]:checked').val() == 3);
                //Page Defaults
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                auxdef.IdBulto = IdBultoOrigen;
                auxdef.IdDetalle = IdDetalle;
                auxdef.Despreparado = despre;
                auxdef.Repaletizado = repal;
                auxdef.IdArticulo = IdArticulo;
                auxdef.CodBarras1 = CodBarras1;
                auxdef.BultoCompleto = false;
                auxdef.DescripArticulo = DescripArticulo;
                auxdef.Lote = Lote;
                auxdef.LoteProv = LoteProv;
                auxdef.P1 = P1;
                auxdef.P2 = P2;
                auxdef.IdTerminal = flexygo.context.currentTerminal;
                page.defaults = JSON.stringify(auxdef);
                //Abrimos página
                flexygo.nav.openPageName('PDA_pg_Consolidar_Articulo', '', '', page.defaults, 'main', true, e);
            };
            //LECTURA DE ARTÍCULO: Carga inicial del módulo con los datos seleccionados de la página inicial de selección de bulto.
            consolidar.initArticulo = (e) => {
                flexygo.pda.addLock();
                //Cargamos parámetros
                flexygo.pda.loadParametros($(".param"));
                //Botón de lecturas
                flexygo.pda.loadBadgeValue($("#badge"), 'IdTerminal', 'Terminal_Consolidar_Bultos', 'IdTerminal', 'IdTerminal');
                //Cargamos las propiedades del artículo
                flexygo.pda.consolidar.CargarPropiedadesArticulo(e, event);
                flexygo.pda.removeLock();
            };
            //LECTURA DE ARTÍCULO: Cargar las propiedades con la selección
            consolidar.CargarPropiedadesArticulo = (item, event) => {
                //Campos
                let parametros = $(`.param`);
                let pbCodigoArticulo = $('flx-text[name = "pbCodigoArticulo"]');
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Si no tiene atributo name es que venimos del init del módulo, recuperamos los valores del pagedefault
                let controlName = (item && item.attributes && item.attributes.name) ? item.attributes.name.value : "";
                //Si no tiene atributo name es que venimos del init del módulo, recuperamos los valores del pagedefault
                let IdArticulo = controlName == "pbComboArticulo" ? pbComboArticulo.val() : null;
                let Lote;
                let LoteProv;
                let P1;
                let P2;
                let IdDetalle;
                if (controlName == "") {
                    IdArticulo = auxdef.IdArticulo ? auxdef.IdArticulo : "";
                    Lote = auxdef.Lote ? auxdef.Lote : "";
                    LoteProv = auxdef.LoteProv ? auxdef.LoteProv : "";
                    P1 = auxdef.P1 ? auxdef.P1 : "";
                    P2 = auxdef.P2 ? auxdef.P2 : "";
                    IdDetalle = auxdef.IdDetalle ? auxdef.IdDetalle : 0;
                }
                //Valor de búsqueda del campo de texto o del combo
                let valorBusqueda = controlName != "" ? $(`[name = "${controlName}"]`).val() : IdArticulo;
                if (!valorBusqueda) {
                    return;
                }
                ;
                //Campo que indica si la lectura se ha llevado a cabo
                let read = false;
                //Si ha cambiado el valor del combo. Evitamos lanzar la búsqueda con el mismo valor.
                if (auxdef.valorBusqueda != valorBusqueda) {
                    //En caso de recibir parámetro con longitudes a tener en cuenta, y se trata del campo de texto, se verifica si se ha legeado al tamaño del parámetro
                    read = parametros ? (((item.tagName).toLowerCase() == "flx-text") ? flexygo.pda.readCode(parametros, valorBusqueda, event) : true) : true;
                }
                //No se han dado las condiciones de lectura
                if (!read) {
                    return;
                }
                ;
                flexygo.pda.addLock();
                //Bulto con el que trabajamos, recueprado de la página anterior de lectura de bulto y selección de detalle
                let IdBulto = auxdef.IdBulto ? auxdef.IdBulto : 0;
                if (IdBulto == 0) {
                    flexygo.msg.error("Se ha perdido la lectura del bulto.");
                    return;
                }
                //Si recibimos el dato por texto (y no por init del módulo) hay que lanzar búsqueda
                if (controlName == 'pbCodigoArticulo') {
                    //Buscar por código introducido, da igual si es Id o codBarras
                    let proc = new flexygo.Process('SGA_PDA_dll_BuscaArticuloPorCodigos', null, null);
                    let params = [{ 'Key': 'CampoBusqueda', 'Value': valorBusqueda }];
                    proc.run(params, (response) => {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                        else if (response.SuccessMessage) {
                            //Dependiendo de la búsqueda podemos recibir información adicional como las propiedades.
                            IdArticulo = response.Data.IdArticulo ? response.Data.IdArticulo : IdArticulo;
                            P1 = response.Data.P1 ? response.Data.P1 : P1;
                            P2 = response.Data.P2 ? response.Data.P2 : P2;
                            //Refrescar datos de combos.
                            let refresco = flexygo.pda.consolidar.RefrescarCombos(item, IdBulto, IdDetalle, IdArticulo, Lote, P1, P2);
                            //Tras refresco
                            refresco.then(function () {
                                //Artículo
                                pbCodigoArticulo.val(valorBusqueda);
                                //Establecer Focos
                                flexygo.pda.consolidar.EstablecerFoco(item);
                            });
                        }
                    });
                }
                else {
                    //Refrescar datos de combos.
                    let refresco = flexygo.pda.consolidar.RefrescarCombos(item, IdBulto, IdDetalle, IdArticulo, Lote, P1, P2);
                    //Tras refresco
                    refresco.then(function () {
                        //Artículo
                        pbCodigoArticulo.val(valorBusqueda);
                        //Establecer Focos
                        flexygo.pda.consolidar.EstablecerFoco(item);
                    });
                }
                //Reset de los defaults. 
                if (!item.attributes.name) {
                    auxdef.IdArticulo = null;
                    auxdef.Lote = null;
                    auxdef.LoteProv = null;
                    auxdef.P1 = null;
                    auxdef.P2 = null;
                    auxdef.IdDetalle = null;
                }
                //Establecer la lectura actual como valor de búsqueda
                auxdef.valorBusqueda = valorBusqueda;
                page.defaults = JSON.stringify(auxdef);
                //Cerramos spinner
                flexygo.pda.removeLock();
            };
            //LECTURA DE ARTÍCULO: Refresca los combos de la página
            consolidar.RefrescarCombos = (item, IdBulto, IdDetalle, IdArticulo, Lote, P1, P2) => {
                let promesa = new Promise(function (resolve, reject) {
                    flexygo.pda.addLock();
                    let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                    let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                    let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                    let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                    let pbCantidad = $('flx-text[name = "pbCantidad"]');
                    //Con los datos del Page Default si viene de carga de módulo, o los leídos, se recargan los combos
                    let additionalWhere = IdDetalle ? `IdBulto = ${IdBulto} AND IdDetalle = ${IdDetalle}` : `IdBulto = ${IdBulto}`;
                    if (Lote) {
                        additionalWhere += ` AND IsNull(NumLote, '') = '${Lote}'`;
                    }
                    if (P1) {
                        additionalWhere += ` AND IsNull(P1, '') = '${P1}'`;
                    }
                    if (P2) {
                        additionalWhere += ` AND IsNull(P2, '') = '${P2}'`;
                    }
                    if (IdArticulo) {
                        additionalWhere += ` AND IdArticulo = '${IdArticulo}'`;
                    }
                    ;
                    additionalWhere += ' AND CantidadDisponible > 0';
                    //Filtramos combo artículos con los detalles del bulto leído
                    let additionalWhereArticulos = `IdBulto = ${IdBulto} AND CantidadDisponible > 0`;
                    pbComboArticulo[0].additionalWhere = additionalWhereArticulos;
                    pbComboArticulo[0].init();
                    if ((!pbComboArticulo.val() && !IdArticulo) || pbComboArticulo.val() != IdArticulo) {
                        pbComboArticulo.val(IdArticulo);
                    }
                    //Filtramos combo de lotes por Bulto-detalle-artículo si viene de la carga del módulo, por Bulto-artículo si viene del evento de los campos
                    if (pbComboLote[0].additionalWhere != additionalWhere) {
                        pbComboLote[0].additionalWhere = additionalWhere;
                        pbComboLote[0].init();
                        pbComboLote.find("li").first().attr('data-value') ? pbComboLote.show() : pbComboLote.hide();
                        pbComboLote.find("li").length == 1 ? pbComboLote.attr('disabled', "true") : pbComboLote.removeAttr("disabled");
                    }
                    if ((!pbComboLote.val() && !Lote) || pbComboLote.val() != Lote) {
                        pbComboLote.val(Lote ? Lote : (pbComboLote.find("li").length == 1 ? pbComboLote.find("li").first().attr('data-value') : null));
                    }
                    //Filtramos combos de propiedades por Bulto-detalle-artículo si viene de la carga del módulo, por Bulto-artículo si viene del evento de los campos
                    if (pbComboP1[0].additionalWhere != additionalWhere) {
                        pbComboP1[0].additionalWhere = additionalWhere;
                        pbComboP1[0].init();
                        pbComboP1.find("li").first().attr('data-value') ? pbComboP1.show() : pbComboP1.hide();
                        pbComboP1.find("li").length == 1 ? pbComboP1.attr('disabled', "true") : pbComboP1.removeAttr("disabled");
                    }
                    if ((!pbComboP1.val() && !P1) || pbComboP1.val() != P1) {
                        pbComboP1.val(P1 ? P1 : (pbComboP1.find("li").length == 1 ? pbComboP1.find("li").first().attr('data-value') : null));
                    }
                    if (pbComboP2[0].additionalWhere != additionalWhere) {
                        pbComboP2[0].additionalWhere = additionalWhere;
                        pbComboP2[0].init();
                        pbComboP2.find("li").first().attr('data-value') ? pbComboP2.show() : pbComboP2.hide();
                        pbComboP2.find("li").length == 1 ? pbComboP2.attr('disabled', "true") : pbComboP2.removeAttr("disabled");
                    }
                    if ((!pbComboP2.val() && !P2) || pbComboP2.val() != P2) {
                        pbComboP2.val(P2 ? P2 : (pbComboP2.find("li").length == 1 ? pbComboP2.find("li").first().attr('data-value') : null));
                    }
                    //Cantidad
                    if (IdArticulo) {
                        let objectWhere = IdArticulo ? `IdArticulo = '${IdArticulo}'` : '';
                        let ArticuloEnt = new flexygo.obj.Entity(`SGA_PDA_Articulo`, objectWhere);
                        ArticuloEnt.read();
                        let detalle = ArticuloEnt.getView("SGA_PDA_Articulo_Consolidacion", 0, 500, additionalWhere, "", null);
                        if (detalle.length == 0) {
                            flexygo.msg.warning("La combinación de datos introducida no se corresponde con ningún detalle disponible del bulto.", null, '');
                            return reject("La combinación de datos introducida no se corresponde con ningún detalle disponible del bulto.");
                        }
                        pbCantidad.val(detalle.length == 1 ? detalle[0].CantidadDisponible : 0);
                    }
                    else {
                        pbCantidad.val(null);
                    }
                    flexygo.pda.removeLock();
                    return resolve();
                });
                return promesa;
            };
            //LECTURA DE ARTÍCULO: Establecemos el foco
            consolidar.EstablecerFoco = (item) => {
                flexygo.pda.addLock();
                let pbCodigoArticulo = $('flx-text[name = "pbCodigoArticulo"]');
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                //Gestión de focos
                let campoOrigen = item.attributes.name ? item.attributes.name.value : 'pbCodigoArticulo';
                switch (campoOrigen) {
                    case 'pbCodigoArticulo':
                    case 'pbComboArticulo':
                        if (!pbComboLote.attr("disabled")) {
                            pbComboLote[0].querySelector('input').focus();
                            pbComboLote[0].querySelector('input').select();
                        }
                        else if (!pbComboP1.attr("disabled")) {
                            pbComboP1[0].querySelector('input').focus();
                            pbComboP1[0].querySelector('input').select();
                        }
                        else if (!pbComboP2.attr("disabled")) {
                            pbComboP2[0].querySelector('input').focus();
                            pbComboP2[0].querySelector('input').select();
                        }
                        else {
                            pbCantidad[0].querySelector('input').focus();
                            pbCantidad[0].querySelector('input').select();
                        }
                        break;
                    case 'pbComboLote':
                        if (!pbComboP1.attr("disabled")) {
                            pbComboP1[0].querySelector('input').focus();
                            pbComboP1[0].querySelector('input').select();
                        }
                        else if (!pbComboP2.attr("disabled")) {
                            pbComboP2[0].querySelector('input').focus();
                            pbComboP2[0].querySelector('input').select();
                        }
                        else {
                            pbCantidad[0].querySelector('input').focus();
                            pbCantidad[0].querySelector('input').select();
                        }
                        break;
                    case 'pbComboP1':
                        if (!pbComboP2.attr("disabled")) {
                            pbComboP2[0].querySelector('input').focus();
                            pbComboP2[0].querySelector('input').select();
                        }
                        else {
                            pbCantidad[0].querySelector('input').focus();
                            pbCantidad[0].querySelector('input').select();
                        }
                        break;
                    case 'pbComboP2':
                        pbCantidad[0].querySelector('input').focus();
                        pbCantidad[0].querySelector('input').select();
                        break;
                    case 'pbCantidad':
                        $('#btnNLectura').focus();
                        break;
                    default:
                        pbCodigoArticulo[0].querySelector('input').focus();
                        pbCodigoArticulo[0].querySelector('input').select();
                }
                flexygo.pda.removeLock();
            };
            //LECTURA DE ARTÍCULO: Limpia los campos
            consolidar.LimpiarCampos = (item) => {
                flexygo.pda.addLock();
                //Campos
                let pbCodigoArticulo = $('flx-text[name = "pbCodigoArticulo"]');
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbLoteProv = $('flx-text[name = "pbLoteProv"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                //Reset de lo defaults de la página (excepto IdBulto)
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                auxdef.IdArticulo = null;
                auxdef.Lote = null;
                auxdef.LoteProv = null;
                auxdef.P1 = null;
                auxdef.P2 = null;
                auxdef.IdDetalle = null;
                auxdef.valorBusqueda = null;
                page.defaults = JSON.stringify(auxdef);
                //Bulto con el que trabajamos, recueprado de la página anterior de lectura de bulto y selección de detalle
                let IdBulto = auxdef.IdBulto ? auxdef.IdBulto : 0;
                if (IdBulto == 0) {
                    flexygo.msg.error("Se ha perdido la lectura del bulto.");
                    return;
                }
                //Reset de campos
                pbCodigoArticulo.val(null);
                pbComboArticulo.val(null);
                pbLoteProv.val(null);
                pbComboLote.val(null);
                pbComboP1.val(null);
                pbComboP2.val(null);
                pbCantidad.val(null);
                //Refrescamos los combos
                let refresco = flexygo.pda.consolidar.RefrescarCombos(item, IdBulto, null, null, null, null, null);
                //Lectura correcta
                refresco.then(function () {
                    //Ocultamos campos
                    pbLoteProv.hide();
                    pbComboLote.hide();
                    pbComboP1.hide();
                    pbComboP2.hide();
                    //Foco
                    pbCodigoArticulo[0].querySelector('input').focus();
                    pbCodigoArticulo[0].querySelector('input').select();
                });
                flexygo.pda.removeLock();
            };
            //LECTURA DE ARTÍCULO: cambio de lote debe actualizar combos asociados
            consolidar.SeleccionaLote = (item) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Datos leídos
                let IdBulto = auxdef.IdBulto ? auxdef.IdBulto : 0;
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                //Refrescar datos de combos.
                let refresco = flexygo.pda.consolidar.RefrescarCombos(item, IdBulto, null, pbComboArticulo.val(), pbComboLote.val(), null, null);
                //Tras refresco
                refresco.then(function () {
                    //Establecer Focos
                    flexygo.pda.consolidar.EstablecerFoco(item);
                });
            };
            //LECTURA DE ARTÍCULO: cambio de propiedad debe actualizar combos asociados
            consolidar.SeleccionaPropiedad = (item) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Datos leídos
                let IdBulto = auxdef.IdBulto ? auxdef.IdBulto : 0;
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                //Refrescar datos de combos.
                let refresco = flexygo.pda.consolidar.RefrescarCombos(item, IdBulto, null, pbComboArticulo.val(), pbComboLote.val(), pbComboP1.val(), pbComboP2.val());
                //Tras refresco
                refresco.then(function () {
                    //Establecer Focos
                    flexygo.pda.consolidar.EstablecerFoco(item);
                });
            };
            //LECTURA DE ARTÍCULO: Confirma lectura y limpia los campos para nueva lectura
            consolidar.NuevaLectura = (item) => {
                flexygo.pda.addLock();
                let lectura = flexygo.pda.consolidar.ConfirmarLectura(item);
                //Lectura correcta
                lectura.then(function () {
                    //Limpiamos formulario para nueva lectura
                    flexygo.pda.consolidar.LimpiarCampos(item);
                });
                //Lectura con error
                lectura.catch(function (error) {
                    if (error && error != "") {
                        flexygo.msg.warning(error);
                    }
                });
            };
            //LECTURA DE ARTÍCULO: confirma la lectura en curso, en caso de existir, y finaliza el proceso
            consolidar.ConfirmarLecturas = (item) => {
                flexygo.pda.addLock();
                //Campos de lectura
                let pbCodigoArticulo = $('flx-text[name = "pbCodigoArticulo"]');
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                //Suponemos que si hay artículo y cantidad, hay una lectura pendiente de validar
                if ((pbCodigoArticulo.val() || pbComboArticulo.val()) && pbCantidad.val() && pbCantidad.val() > 0) {
                    let lectura = flexygo.pda.consolidar.ConfirmarLectura(item);
                    //Lectura correcta
                    lectura.then(function () {
                        //Finalizamos el proceso
                        flexygo.pda.consolidar.FinalizarLecturas(item);
                    });
                    //Lectura con error
                    lectura.catch(function (error) {
                        if (error && error != "") {
                            flexygo.msg.warning(error);
                        }
                    });
                }
                else {
                    //Finalizamos el proceso
                    flexygo.pda.consolidar.FinalizarLecturas(item);
                }
            };
            //LECTURA DE ARTÍCULO: confirmar la lectura del artículo
            consolidar.ConfirmarLectura = (item) => {
                let promesa = new Promise(function (resolve, reject) {
                    //Campos de lectura
                    let pbCodigoArticulo = $('flx-text[name = "pbCodigoArticulo"]');
                    let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                    let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                    let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                    let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                    let pbCantidad = $('flx-text[name = "pbCantidad"]');
                    //Datos del Page Defaults
                    let module = $('flx-module')[0];
                    let page = flexygo.history.get(module);
                    let IdBulto = JSON.parse(page.defaults).IdBulto ? JSON.parse(page.defaults).IdBulto : 0;
                    let Despreparacion = JSON.parse(page.defaults).Despreparado ? JSON.parse(page.defaults).Despreparado : false;
                    //Datos de campos
                    let codBarras1 = pbCodigoArticulo.val();
                    let cboArticulo = pbComboArticulo.val();
                    let Cantidad = pbCantidad.val();
                    let Lote = pbComboLote.val();
                    let P1 = pbComboP1.val();
                    let P2 = pbComboP2.val();
                    let P3 = "";
                    let P4 = "";
                    let P5 = "";
                    let P6 = "";
                    let P7 = "";
                    let P8 = "";
                    let P9 = "";
                    let P10 = "";
                    if (codBarras1 && Cantidad && Cantidad > 0) {
                        //validar primero, utilizamos el lote que tenia el articulo ya que si no piensa que no es el del bulto
                        let proc = new flexygo.Process('SGA_PDA_dll_PDA_Bulto_ValidaLecturaConsProp', null, null);
                        let params = [
                            { 'Key': 'IdBultoOrigen', 'Value': IdBulto },
                            { 'Key': 'CodBarras', 'Value': pbCodigoArticulo.val() },
                            { 'Key': 'IdArticulo', 'Value': cboArticulo },
                            { 'Key': 'P1', 'Value': P1 },
                            { 'Key': 'Lote', 'Value': Lote },
                            { 'Key': 'Cantidad', 'Value': Cantidad },
                            { 'Key': 'P2', 'Value': P2 },
                            { 'Key': 'P3', 'Value': P3 },
                            { 'Key': 'P4', 'Value': P4 },
                            { 'Key': 'P5', 'Value': P5 },
                            { 'Key': 'P6', 'Value': P6 },
                            { 'Key': 'P7', 'Value': P7 },
                            { 'Key': 'P8', 'Value': P8 },
                            { 'Key': 'P9', 'Value': P9 },
                            { 'Key': 'P10', 'Value': P10 }
                        ];
                        flexygo.pda.addLock();
                        proc.run(params, (response) => {
                            if (response) {
                                if (response.JSCode) {
                                    var func = new Function(response.JSCode);
                                    func.call(response.JSCode);
                                    flexygo.pda.removeLock();
                                    return resolve();
                                }
                                if (response.LastException && response.LastException.Message) {
                                    return reject(response.LastException.Message);
                                }
                                else if (response.WarningMessage) {
                                    return reject(response.WarningMessage);
                                }
                                else if (response.SuccessMessage) {
                                    //Botón de lecturas
                                    flexygo.pda.loadBadgeValue($("#badge"), 'IdTerminal', 'Terminal_Consolidar_Bultos', 'IdTerminal', 'IdTerminal');
                                    return resolve();
                                }
                            }
                            else {
                                return resolve();
                            }
                        });
                    }
                    else {
                        flexygo.pda.removeLock();
                        return reject("Datos incorrectos.");
                    }
                });
                return promesa;
            };
            //LECTURA DE ARTÍCULO: finaliza el proceso con las lectura confirmadas hasta el momento
            consolidar.FinalizarLecturas = (item) => {
                flexygo.pda.addLock();
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let IdBulto = JSON.parse(page.defaults).IdBulto ? JSON.parse(page.defaults).IdBulto : 0;
                let Despreparacion = JSON.parse(page.defaults).Despreparado ? JSON.parse(page.defaults).Despreparado : false;
                if (Despreparacion) {
                    //Confirmar ahora si es despreparación
                    let proc = new flexygo.Process('SGA_PDA_dll_Manipular_Bultos_Despreparar', null, null);
                    let params = [{ 'Key': 'IdBulto', 'Value': IdBulto }, { 'Key': 'Completo', 'Value': false }];
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                flexygo.pda.removeLock();
                            }
                            if (response.LastException && response.LastException.Message) {
                                flexygo.msg.error(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                flexygo.msg.warning(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                flexygo.msg.success("Proceso ejecutado con éxito.", null, null);
                                flexygo.nav.openPageName('PDA_pg_Manipulacion', '', '', null, 'current', false, item);
                            }
                        }
                    });
                }
                else {
                    //Pedimos el bulto destino
                    var auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                    page.defaults = JSON.stringify(auxdef);
                    let pgn = 'PDA_pg_Consolidar_Completo';
                    flexygo.nav.openPageName(pgn, '', '', page.defaults, 'current', true);
                }
            };
            //LECTURA DE ARTÍCULO: finaliza el proceso descartando todas las lecturas realizadas
            consolidar.DescartarLecturas = (e) => {
                flexygo.pda.addLock();
                let proc = new flexygo.Process('SGA_PDA_dll_finalizararticulo', null, null);
                let params = [{ 'Key': 'IdBulto', 'Value': 0 }];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                        else if (response.SuccessMessage) {
                            if (response.Data.cuenta) {
                                flexygo.msg.confirm('Tiene lecturas pendientes de confirmar. Si continua se borrarán. ¿Desea continuar?', function (ret) {
                                    if (ret) {
                                        proc = new flexygo.Process('SGA_PDA_dll_borrarlecturas', null, null);
                                        params = [{ 'Key': 'IdBulto', 'Value': 0 }];
                                        proc.run(params, (response) => {
                                            if (response) {
                                                if (response.JSCode) {
                                                    var func = new Function(response.JSCode);
                                                    func.call(response.JSCode);
                                                    flexygo.pda.removeLock();
                                                }
                                                if (response.LastException && response.LastException.Message) {
                                                    flexygo.msg.error(response.LastException.Message);
                                                }
                                                else if (response.WarningMessage) {
                                                    flexygo.msg.warning(response.WarningMessage);
                                                }
                                                else if (response.SuccessMessage) {
                                                    flexygo.nav.openPageName('PDA_pg_Manipulacion', '', '', null, 'current', false, null);
                                                }
                                            }
                                        });
                                    }
                                });
                            }
                            else {
                                flexygo.nav.openPageName('PDA_pg_Manipulacion', '', '', null, 'current', false, null);
                            }
                        }
                    }
                });
            };
            //LECTURA DE ARTÍCULO: eliminar lectura desde el diálogo de lecturas realizadas.
            consolidar.EliminarLectura = (item, detEliminar) => {
                flexygo.pda.addLock();
                let IdDetalle = detEliminar.val();
                if (!IdDetalle || IdDetalle == 0) {
                    flexygo.msg.warning("No ha seleccionado un detalle a eliminar.", null, '');
                    return;
                }
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                let IdBulto = auxdef.IdBulto ? auxdef.IdBulto : 0;
                if (IdBulto == 0) {
                    flexygo.msg.error("Se ha perdido la lectura del bulto.");
                    return;
                }
                //Pedimos confirmación del borrado
                flexygo.msg.confirm('¿Está seguro que quiere eliminar la lectura seleccionada?', function (ret) {
                    if (!ret) {
                        return;
                    }
                    ;
                    let proc = new flexygo.Process('SGA_PDA_dll_BorrarLectura', null, null);
                    let params = [
                        { 'Key': 'IdBulto', 'Value': IdBulto },
                        { 'Key': 'IdDetalle', 'Value': IdDetalle }
                    ];
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                flexygo.pda.removeLock();
                            }
                            if (response.LastException && response.LastException.Message) {
                                flexygo.msg.error(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                flexygo.msg.warning(response.WarningMessage);
                                flexygo.nav.openPageName('syspage-generic-controlpanel', '', '', null, 'main', false, null);
                            }
                            else if (response.SuccessMessage) {
                                //Botón de lecturas del módulo principal
                                flexygo.pda.loadBadgeValue($("#badge"), 'IdTerminal', 'Terminal_Consolidar_Bultos', 'IdTerminal', 'IdTerminal');
                                //lista de lecturas
                                let list = $("#dialog").find("flx-list")[0];
                                list.refresh();
                                flexygo.pda.removeLock();
                            }
                        }
                    });
                });
                flexygo.pda.removeLock();
            };
            //SELECCIÓN BULTO DESTINO: botones de confirmar y confirmar y validar.
            consolidar.confirmar = (e, IdBultoLect, Confirma) => {
                let IdBultoDestino = IdBultoLect.val();
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let IdBultoOrigen = JSON.parse(page.defaults).IdBulto ? JSON.parse(page.defaults).IdBulto : 0;
                let BultoCompleto = JSON.parse(page.defaults).BultoCompleto ? JSON.parse(page.defaults).BultoCompleto : 0;
                let Repaletizado = JSON.parse(page.defaults).Repaletizado ? JSON.parse(page.defaults).Repaletizado : 0;
                if (!IdBultoDestino) {
                    flexygo.msg.warning("Introduzca un bulto");
                    return;
                }
                let proc = new flexygo.Process('SGA_PDA_dll_Manipular_Bultos_ConsolidarRepaletizar', null, null);
                let params = [
                    { 'Key': 'IdBultoOrigen', 'Value': IdBultoOrigen },
                    { 'Key': 'IdBultoDestino', 'Value': IdBultoDestino },
                    { 'Key': 'BultoCompleto', 'Value': BultoCompleto },
                    { 'Key': 'Confirma', 'Value': Confirma },
                    { 'Key': 'Repaletizado', 'Value': Repaletizado }
                ];
                flexygo.pda.addLock();
                if (IdBultoDestino) {
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                flexygo.pda.removeLock();
                            }
                            if (response.LastException && response.LastException.Message) {
                                flexygo.msg.error(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                flexygo.msg.warning(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                flexygo.msg.success("Proceso ejecutado con éxito.", null, null);
                                flexygo.nav.openPageName('PDA_pg_Manipulacion', '', '', null, 'current', false, e);
                            }
                        }
                    });
                }
            };
            //para cargar solo las propiedades P1 y P2, modificar stock si así lo indica la dll. Esto sucede cada vez que se cambia el articulo
            //Y modifcar el lote (esto sucede si el articulo no es con lote pero la definicion del producto si que lleva lote)
            consolidar.ActualizaStockPropiedadesManuales = (IdArticulo, LoteResult, P1Result, P2Result, stock, cantidad) => {
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let IdUbicacion = JSON.parse(page.defaults).IdUbicacionOrigen;
                if (!IdUbicacion) {
                    let CodUbicacion = JSON.parse(page.defaults).CodigoUbicacion;
                    if (!CodUbicacion) {
                        CodUbicacion = JSON.parse(page.defaults).UbicacionTrabajo;
                    }
                    let UbicEnt = new flexygo.obj.Entity(`SGA_PDA_Ubicacion`, `Codigo = '${CodUbicacion}'`);
                    UbicEnt.read();
                    IdUbicacion = UbicEnt.data.IdUbicacion.Value;
                }
                if (IdArticulo) {
                    //Aqui debo primero verificar si el articulo tiene trabajo de lotes
                    //sino lo tiene y la definición del producto si que tiene lote pues lo cargo pero lo dejo oculto
                    if (LoteResult == "" || !LoteResult) {
                        let proc = new flexygo.Process('SGA_PDA_Lote_P', null, null);
                        let params = [{ 'Key': 'IdArticulo', 'Value': IdArticulo }];
                        flexygo.pda.addLock();
                        proc.run(params, (response) => {
                            if (response) {
                                if (response.JSCode) {
                                    var func = new Function(response.JSCode);
                                    func.call(response.JSCode);
                                    flexygo.pda.removeLock();
                                }
                                if (response.LastException && response.LastException.Message) {
                                    flexygo.msg.error(response.LastException.Message);
                                }
                                else if (response.WarningMessage) {
                                    flexygo.msg.warning(response.WarningMessage);
                                }
                                else if (response.SuccessMessage) {
                                    //encontre definicion de lote en el articulo y no es trabajo con lote
                                    if (response.Data.LoteP != "") {
                                        $('#loteProv').val(response.Data.LoteP);
                                        LoteResult = response.Data.LoteP;
                                        $('#loteProv').hide();
                                    }
                                    let proc = new flexygo.Process('SGA_PDA_DameStockArticuloConP', null, null);
                                    let params = [{ 'Key': 'IdArticulo', 'Value': IdArticulo }, { 'Key': 'NumLote', 'Value': LoteResult ? LoteResult : "" }, { 'Key': 'P1', 'Value': P1Result ? P1Result : "" }, { 'Key': 'P2', 'Value': P2Result ? P2Result : "" }, { 'Key': 'IdUbicacion', 'Value': IdUbicacion }];
                                    proc.run(params, (response) => {
                                        if (response) {
                                            if (response.JSCode) {
                                                var func = new Function(response.JSCode);
                                                func.call(response.JSCode);
                                                flexygo.pda.removeLock();
                                            }
                                            if (response.LastException && response.LastException.Message) {
                                                flexygo.msg.error(response.LastException.Message);
                                            }
                                            else if (response.WarningMessage) {
                                                flexygo.msg.warning(response.WarningMessage);
                                            }
                                            else if (response.SuccessMessage) {
                                                stock.val(response.Data.stock);
                                                cantidad[0].querySelector("input").focus();
                                                if (P1Result != "") {
                                                    //siempre actualizar el text P1 con lo seleccionado
                                                    $('#P1').val(P1Result);
                                                }
                                                if (P2Result != "") {
                                                    //siempre actualizar el text P2 con lo seleccionado
                                                    $('#P2').val(P2Result);
                                                }
                                            }
                                        }
                                        flexygo.pda.removeLock();
                                    });
                                }
                            }
                        });
                    }
                    else {
                        let proc = new flexygo.Process('SGA_PDA_DameStockArticuloConP', null, null);
                        let params = [{ 'Key': 'IdArticulo', 'Value': IdArticulo }, { 'Key': 'NumLote', 'Value': LoteResult ? LoteResult : "" }, { 'Key': 'P1', 'Value': P1Result ? P1Result : "" }, { 'Key': 'P2', 'Value': P2Result ? P2Result : "" }, { 'Key': 'IdUbicacion', 'Value': IdUbicacion }];
                        flexygo.pda.addLock();
                        proc.run(params, (response) => {
                            if (response) {
                                if (response.JSCode) {
                                    var func = new Function(response.JSCode);
                                    func.call(response.JSCode);
                                    flexygo.pda.removeLock();
                                }
                                if (response.LastException && response.LastException.Message) {
                                    flexygo.msg.error(response.LastException.Message);
                                }
                                else if (response.WarningMessage) {
                                    flexygo.msg.warning(response.WarningMessage);
                                }
                                else if (response.SuccessMessage) {
                                    stock.val(response.Data.stock);
                                    cantidad[0].querySelector("input").focus();
                                    if (P1Result != "") {
                                        //siempre actualizar el text P1 con lo seleccionado
                                        $('#P1').val(P1Result);
                                    }
                                    if (P2Result != "") {
                                        //siempre actualizar el text P2 con lo seleccionado
                                        $('#P2').val(P2Result);
                                    }
                                }
                            }
                            flexygo.pda.removeLock();
                        });
                    }
                }
                else {
                    flexygo.msg.warning("Codigo de barras no encontrado.", null, '');
                }
            };
        })(consolidar = pda.consolidar || (pda.consolidar = {}));
    })(pda = flexygo.pda || (flexygo.pda = {}));
})(flexygo || (flexygo = {}));
//# sourceMappingURL=consolidar.js.map