var flexygo;
(function (flexygo) {
    var pda;
    (function (pda) {
        var consultas;
        (function (consultas) {
            //GENÉRICO: El evento OnKeyUp se usa para no lanzar la acción del enter sobre los focos de botón. Es necesario un OnKeyDown sólo para el tabulador
            consultas.readKeyTab = (e, funcname, params) => {
                if (e.keyCode == 9) {
                    e.preventDefault();
                    flexygo.pda.consultas[funcname].apply(flexygo.pda.consultas, params);
                }
                else {
                    return;
                }
            };
            //GENÉRICO: Lectura de carácteres de entrada y ejecución de la función cuando se recibe ENTER
            consultas.readByCharacter = (e, funcname, params) => {
                if (e.keyCode == 13) {
                    flexygo.pda.consultas[funcname].apply(flexygo.pda.consultas, params);
                }
                else {
                    return;
                }
            };
            //CONSULTA ARTÍCULOS: combo de lectura.
            consultas.LeerArticulo = (item, codBarras, cboArticulos, prop, event, parametros) => {
                let read = false;
                let valorBusqueda = prop == "CodBarras" ? codBarras.val() : cboArticulos.val();
                if (!valorBusqueda) {
                    return;
                }
                ;
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                if (auxdef.valorBusqueda != valorBusqueda) {
                    if (parametros) {
                        if (valorBusqueda) {
                            if (prop == "CodBarras") {
                                read = flexygo.pda.readCode(parametros, valorBusqueda, event);
                            }
                            else {
                                read = true;
                            }
                        }
                    }
                    else {
                        read = true;
                    }
                    if (read) {
                        flexygo.pda.addLock();
                        flexygo.pda.consultas.buscaArticuloPorCodigos(valorBusqueda, (res) => {
                            if (res.IdArticulo) {
                                //Lanzamos carga de propiedades del artículo
                                let proc = new flexygo.Process('SGA_PDA_dll_RellenaTablaTemporalPropiedades', null, null);
                                let params = [{ "Key": "IdArticulo", "Value": res.IdArticulo }];
                                proc.run(params, (response) => {
                                    if (response) {
                                        if (response.JSCode) {
                                            var func = new Function(response.JSCode);
                                            func.call(response.JSCode);
                                            flexygo.pda.removeLock();
                                        }
                                        if (response.LastException && response.LastException.Message) {
                                            flexygo.msg.error(response.LastException.Message);
                                        }
                                        else if (response.WarningMessage) {
                                            flexygo.msg.warning(response.WarningMessage);
                                        }
                                        else if (response.SuccessMessage) {
                                            let module = $(`[modulename=SGA_PDA_md_Articulos_Stock_Listado]flx-list`)[0];
                                            module.additionalWhere = "";
                                            module.additionalWhere = `IdArticulo = '${res.IdArticulo}'`;
                                            module.init();
                                        }
                                    }
                                });
                                auxdef.valorBusqueda = valorBusqueda;
                                page.defaults = JSON.stringify(auxdef);
                                //Actualizamos valor de elementos de búsqueda
                                if (prop == "CodBarras") {
                                    if (cboArticulos[0]) {
                                        cboArticulos[0].additionalWhere = "IdArticulo = '" + res.IdArticulo + "'";
                                        cboArticulos[0].refresh();
                                    }
                                    cboArticulos.val(res.IdArticulo);
                                }
                                else {
                                    codBarras.val(res.IdArticulo);
                                }
                            }
                            else {
                                let module = $(`[modulename=SGA_PDA_md_Articulos_Stock_Listado]flx-list`)[0];
                                module.additionalWhere = "1 = 0";
                                module.init();
                                flexygo.msg.warning("No se ha encontrado ningún artículo que coincida con el criterio de búsqueda introducido.");
                            }
                        });
                    }
                }
            };
            //CONSULTA ARTÍCULO: búsqueda de artículos por cadena de búsqueda
            consultas.buscaArticuloPorCodigos = (text, callback) => {
                if (text) {
                    let proc = new flexygo.Process('SGA_PDA_dll_BuscaArticuloPorCodigos', null, null);
                    let params = [{ "Key": "CampoBusqueda", "Value": text }];
                    flexygo.pda.addLock();
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                flexygo.pda.removeLock();
                            }
                            if (response.LastException && response.LastException.Message) {
                                flexygo.msg.error(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                flexygo.pda.removeLock();
                            }
                            else if (response.SuccessMessage) {
                                flexygo.pda.removeLock();
                                callback(response.Data);
                            }
                        }
                    });
                }
            };
            //CONSULTA BULTOS: botón mover bulto
            consultas.MoverBulto = (e, codBarras1) => {
                let CodBarras1 = codBarras1.val();
                if (!CodBarras1) {
                    flexygo.msg.warning("Introduzca bulto.", null, '');
                }
                else {
                    flexygo.pda.addLock();
                    let module = $('flx-module')[0];
                    let page = flexygo.history.get(module);
                    let auxdef = page.defaults ? JSON.parse(page.defaults) : {};
                    auxdef.CodBarras1 = CodBarras1;
                    page.defaults = JSON.stringify(auxdef);
                    flexygo.nav.openPageName('SGA_PDA_pg_Mov_BULTOS', '', '', page.defaults, 'main', true, e);
                }
            };
            //CONSULTA UBICACiÓN: botón genera conteo
            consultas.GeneraConteo = (e, mod) => {
                //Parámetros
                let pbCodigo = $('flx-text[name = "pbCodigoUbicacion"]');
                let pbCombo = $('flx-dbcombo[name = "pbComboUbicacion"]');
                //Validación
                if (!pbCombo.val()) {
                    flexygo.msg.warning("Seleccione una ubicación");
                    return;
                }
                //Obtenemos código asociado
                let Ubicacion = new flexygo.obj.Entity(`SGA_PDA_Ubicacion`, `IdAlmacen = ${flexygo.context.currentAlmacen} AND IdUbicacion = '${pbCombo.val()}'`);
                Ubicacion.read();
                let CodUbicacion = Ubicacion.data.Codigo.Value;
                flexygo.pda.addLock();
                let proc = new flexygo.Process('SGA_PDA_dll_ConteoUbicaciones_GeneraTrabajoConteo', null, null);
                let params = [{ "Key": "CodigoUbicacion", "Value": CodUbicacion }];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                            flexygo.nav.openPageName('syspage-generic-controlpanel', '', '', null, 'main', false, null);
                        }
                        else if (response.SuccessMessage) {
                            let ConteoEnt = new flexygo.obj.Entity(`SGA_PDA_Trabajo_Inventario`, `IdTrabajoAlm = ${response.Data.IdTrabajoNew}`);
                            ConteoEnt.read();
                            flexygo.context.CodUbicLeidaInventario = `${CodUbicacion}`;
                            $('#IdDocDetalle').val(ConteoEnt.data.IdDocDetalle.Value);
                            flexygo.pda.removeLock();
                            flexygo.pda.conteo.seleccionarConteo(ConteoEnt.data.IdDocDetalle.Value);
                        }
                    }
                });
            };
        })(consultas = pda.consultas || (pda.consultas = {}));
    })(pda = flexygo.pda || (flexygo.pda = {}));
})(flexygo || (flexygo = {}));
//# sourceMappingURL=consultas.js.map