/**
 * @namespace flexygo.pda.contador
 */
var flexygo;
(function (flexygo) {
    var pda;
    (function (pda) {
        var contador;
        (function (contador) {
            contador.arrTimers = [];
            contador.loadCounters = function (menu, Consultas) {
                //Limpiamos el timer por si hay una ejecución anterior
                flexygo.pda.contador.arrTimers.map(function (timerId) {
                    clearTimeout(timerId);
                });
                //Lo volvemos a crear
                flexygo.pda.contador.arrTimers = [];
                //Lanzamos el timer cada 200ms hasta que se pueda ejecutar por haberse cargado el menú
                var timerMod = setInterval(function () {
                    let conexion = flexygo.pda.OnlineCheck();
                    conexion.then(function () {
                        if (!menu.hasClass("loading")) {
                            //Ya está cargado el menú, no tenemos que volver a ejecutar el interval
                            clearInterval(timerMod);
                            //Rescatamos el valor del parametro en BBDD
                            let parametroTimer = new flexygo.obj.Entity("SGA_PDA_Configuracion", "Parametro = 'TimerInterval'");
                            parametroTimer.read();
                            //Si está definido el parámetro
                            if (Number(parametroTimer.data.Valor.Value)) {
                                let time = Number(parametroTimer.data.Valor.Value);
                                //Recorremos los contadores definidos, asignando el div con el contador a los nodos
                                for (let i = 0; i < Consultas.datos.length; i++) {
                                    if (document.body.querySelectorAll('flx-module[modulename="' + Consultas.datos[i].Module + '"]').length > 0 && menu[0].moduleName == Consultas.datos[i].Module) {
                                        flexygo.pda.contador.execCountProcess(0, Consultas.datos[i].Module, Consultas.datos[i].Objeto, Consultas.datos[i].Vista, Consultas.datos[i].Where, Consultas.datos[i].class, Consultas.datos[i].classContador, Consultas.datos[i].WhereUrgente, Consultas.datos[i].classContadorUrgente);
                                        flexygo.pda.contador.execCountProcess(time, Consultas.datos[i].Module, Consultas.datos[i].Objeto, Consultas.datos[i].Vista, Consultas.datos[i].Where, Consultas.datos[i].class, Consultas.datos[i].classContador, Consultas.datos[i].WhereUrgente, Consultas.datos[i].classContadorUrgente);
                                    }
                                    ;
                                }
                                ;
                            }
                        }
                    });
                    conexion.catch(function () { console.log("Error OnlineCheck Contador"); });
                }, 200);
            };
            contador.loadCountersMainMenu = function (menu) {
                // Cargamos los datos de los contadores
                var Consultas = {
                    "datos": [
                        { "Module": "Main_Menu", "class": "MenuMain_Movimientos", "Objeto": "SGA_PDA_Trabajo_Almacen", "Vista": "SGA_PDA_Contador_TrabajosAlmacen", "Where": "IdtipoMov = 0 and IdAlmacen = " + flexygo.context.currentAlmacen + " and IdMaquina = '" + flexygo.context.currentMaquina + "'", "classContador": "counter", "WhereUrgente": "", "classContadorUrgente": "" },
                        { "Module": "Main_Menu", "class": "MenuMain_Traspaso", "Objeto": "SGA_PDA_Trabajo_Almacen", "Vista": "SGA_PDA_Contador_TrabajosAlmacen", "Where": "IdtipoMov = 2 and IdAlmacen = " + flexygo.context.currentAlmacen + " and IdMaquina = '" + flexygo.context.currentMaquina + "'", "classContador": "counter", "WhereUrgente": "", "classContadorUrgente": "" },
                        { "Module": "Main_Menu", "class": "MenuMain_Preparaciones", "Objeto": "SGA_PDA_Trabajo_Almacen", "Vista": "SGA_PDA_Contador_Preparaciones", "Where": "", "classContador": "counter", "WhereUrgente": "", "classContadorUrgente": "" },
                        { "Module": "Main_Menu", "class": "MenuMain_Expediciones", "Objeto": "SGA_PDA_Trabajo_Almacen", "Vista": "SGA_PDA_Contador_TrabajosAlmacen_Expediciones", "Where": "", "classContador": "counter", "WhereUrgente": "", "classContadorUrgente": "" },
                        { "Module": "Main_Menu", "class": "MenuMain_ConteoUbics", "Objeto": "SGA_PDA_Trabajo_Almacen", "Vista": "SGA_PDA_Contador_TrabajosAlmacen", "Where": "IdTipoMov = 3 AND IdTipoTrabajo between 3 and 4 AND IdAlmacen = " + flexygo.context.currentAlmacen + " AND IsNull(IdEmpleado, " + flexygo.context.currentReference + ") = " + flexygo.context.currentReference, "classContador": "counter", "WhereUrgente": "", "classContadorUrgente": "" }
                    ]
                };
                flexygo.pda.contador.loadCounters(menu, Consultas);
            };
            contador.loadCountersMovimientoMenu = function (menu) {
                // Cargamos los datos de los contadores
                var Consultas = {
                    "datos": [
                        { "Module": "Movimiento_Menu", "class": "MenuMovs_Pendiente", "Objeto": "SGA_PDA_Trabajo_Almacen", "Vista": "SGA_PDA_Contador_EntradasPendientes", "Where": "", "classContador": "counter", "WhereUrgente": "", "classContadorUrgente": "" }
                    ]
                };
                flexygo.pda.contador.loadCounters(menu, Consultas);
            };
            contador.execCountProcess = (time, Module, Objeto, Vista, Where, Clase, ClaseContador, WhereUrgente, ClaseContadorUrgente) => {
                let p = new Promise(function (resolve, reject) {
                    let timer = setTimeout(function tick() {
                        if (document.body.querySelectorAll('flx-module[modulename="' + Module + '"]').length > 0) {
                            try {
                                let conexion = flexygo.pda.OnlineCheck();
                                conexion.then(function () {
                                    //Clase del contador
                                    let ClaseFinal = ClaseContador;
                                    //Obtenemos el dato de la vista flexy
                                    let Contador = new flexygo.obj.Entity(Objeto).getViewCount(Vista, Where, null);
                                    let Contadortxt = Contador.toString();
                                    if (Contador > 99) {
                                        Contadortxt = "+99";
                                    }
                                    ;
                                    //Verificar Contador Urgente
                                    if (WhereUrgente) {
                                        let ContadorUrgente = new flexygo.obj.Entity(Objeto).getViewCount(Vista, WhereUrgente, null);
                                        if (ContadorUrgente > 0) {
                                            ClaseFinal = ClaseContadorUrgente;
                                        }
                                        ;
                                    }
                                    //Obtenemos el nodo y le añadimos el div con el dato
                                    let nodos = document.getElementsByClassName(Clase);
                                    let nodo = nodos[nodos ? nodos.length - 1 : 0];
                                    if (nodo) {
                                        let EtiquetaContador = document.createElement("div");
                                        EtiquetaContador.className = ClaseFinal;
                                        EtiquetaContador.innerText = Contadortxt;
                                        nodo.appendChild(EtiquetaContador);
                                    }
                                    if (time != 0) {
                                        timer = setTimeout(tick, Number(time));
                                    }
                                });
                                conexion.catch(function () { console.log("Error OnlineCheck CountProcess"); });
                            }
                            catch (error) {
                                clearTimeout(timer);
                                let nodos = document.getElementsByClassName(Clase);
                                let nodo = nodos[nodos ? nodos.length - 1 : 0];
                                if (nodo) {
                                    let EtiquetaContador = document.createElement("div");
                                    EtiquetaContador.className = ClaseContador;
                                    EtiquetaContador.innerText = "E";
                                    nodo.appendChild(EtiquetaContador);
                                    flexygo.msg.warning("El contador " + Clase + " se ha deshabilitado por errores en la ejecución.", null, null);
                                }
                            }
                        }
                        else {
                            clearTimeout(timer);
                        }
                    }, Number(time));
                    if (time != 0) {
                        flexygo.pda.contador.arrTimers.push(timer);
                    }
                    return resolve();
                });
                return p;
            };
        })(contador = pda.contador || (pda.contador = {}));
    })(pda = flexygo.pda || (flexygo.pda = {}));
})(flexygo || (flexygo = {}));
//# sourceMappingURL=contador.js.map