/**
 * @namespace flexygo.pda.expedicion
 */
var flexygo;
(function (flexygo) {
    var pda;
    (function (pda) {
        var expedicion;
        (function (expedicion_1) {
            //GENÉRICO: El evento OnKeyUp se usa para no lanzar la acción del enter sobre los focos de botón. Es necesario un OnKeyDown sólo para el tabulador
            expedicion_1.readKeyTab = (e, funcname, params) => {
                if (e.keyCode == 9) {
                    e.preventDefault();
                    flexygo.pda.expedicion[funcname].apply(flexygo.pda.expedicion, params);
                }
                else {
                    return;
                }
            };
            //GENÉRICO: Leer carácter y lanzar función en caso de encontrarlo
            expedicion_1.readByCharacter = (e, funcname, params) => {
                if (e.keyCode == 13) {
                    flexygo.pda.expedicion[funcname].apply(flexygo.pda.expedicion, params);
                }
                else {
                    return;
                }
            };
            //LISTA EXPEDICIONES: Botón comenzar tras selección de expedición
            expedicion_1.Comenzar = (expedicion) => {
                //Validación de selección
                if (!expedicion.val()) {
                    flexygo.msg.warning("No se ha seleccionado una expedición", null, '');
                    return;
                }
                //Defaults de la página
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                auxdef.IdExpedicion = expedicion.val();
                page.defaults = JSON.stringify(auxdef);
                //Apertura de página de destinatarios.
                flexygo.nav.openPageName('SGA_PDA_pg_ExpedicionesDestinatarios', 'SGA_PDA_Expediciones_Destinatarios', `IdExpedicion=${expedicion.val()} AND IdMaquina = '${flexygo.context.currentMaquina}' AND BultosPendientes > 0`, page.defaults, 'main', false, expedicion);
            };
            //DESTINATARIOS: Botón confirmar para confirmar la selección del destinatario
            expedicion_1.Destinatario = (destinatario) => {
                //Validación de selección
                if (!destinatario.val()) {
                    flexygo.msg.warning("No se ha seleccionado una destinatario", null, '');
                    return;
                }
                //Defaults de la página
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                auxdef.IdDestinatario = destinatario.val();
                page.defaults = JSON.stringify(auxdef);
                //Apertura de página de trabajos de bulto
                flexygo.nav.openPageName('SGA_PDA_pg_ExpedicionesBultos', 'SGA_PDA_Expediciones_Destinatarios', `IdExpedicion = ${auxdef.IdExpedicion} AND IdDestinatario = '${destinatario.val()}' AND IdMaquina = '${flexygo.context.currentMaquina}' AND IdEstadoTrabajoAlm NOT IN (-1,3)`, page.defaults, 'main', false, destinatario);
            };
            //TRABAJOS BULTO: Botón selección de bulto.
            expedicion_1.Bulto = (bulto, trabajo) => {
                //Validación de selección
                if (!bulto.val()) {
                    flexygo.msg.warning("No se ha seleccionado una bulto", null, '');
                    return;
                }
                //Defaults de la página
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                auxdef.IdBulto = bulto.val();
                auxdef.IdTrabajo = trabajo.val();
                let proc = new flexygo.Process('SGA_PDA_dll_Expediciones_ProximoDetalleOrden', null, null);
                let params = [
                    { "Key": "IdOrden", "Value": auxdef.IdExpedicion },
                    { "Key": "IdTrabajo", "Value": auxdef.IdTrabajo },
                    { "Key": "IdDocDetalle", "Value": 0 }
                ];
                flexygo.pda.addLock();
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            flexygo.pda.removeLock();
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                            flexygo.nav.openPageName('syspage-generic-controlpanel', '', '', null, 'main', false, null);
                        }
                        else if (response.SuccessMessage) {
                            auxdef = $.extend({}, auxdef, response.Data);
                            page.defaults = JSON.stringify(auxdef);
                            flexygo.nav.openPageName('SGA_PDA_pg_BultoSalida', 'SGA_PDA_Bulto_Salida', `IdDocDetalle=${response.Data.IdDocDetalle}`, page.defaults, 'main', false, bulto);
                        }
                    }
                });
            };
            //BULTO UBICACIÓN ORIGEN: Botón siguiente trabajo de bulto
            expedicion_1.SiguienteBulto = (e) => {
                //Defaults de la página
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                let proc = new flexygo.Process('SGA_PDA_dll_Expediciones_ProximoDetalleOrden', null, null);
                let params = [
                    { "Key": "IdOrden", "Value": auxdef.IdOrden },
                    { "Key": "IdTrabajo", "Value": 0 },
                    { "Key": "IdDocDetalle", "Value": auxdef.IdDocDetalle }
                ];
                flexygo.pda.addLock();
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            flexygo.pda.removeLock();
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                        else if (response.SuccessMessage) {
                            if (response.Data.IdDocDetalle == auxdef.IdDocDetalle) {
                                flexygo.msg.warning("No hay más trabajos pendientes para el destinatario.");
                            }
                            else {
                                //Instanciamos trabajo y obtenemos ubicación destino
                                let TrabajoDetalle = new flexygo.obj.Entity(`SGA_PDA_Bulto_Salida`, `IdTrabajoAlm = ${response.Data.IdTrabajo} AND IdDocDetalle = ${response.Data.IdDocDetalle}`);
                                TrabajoDetalle.read();
                                auxdef.IdBulto = TrabajoDetalle.data.IdBulto.Value;
                                auxdef = $.extend({}, auxdef, response.Data);
                                page.defaults = JSON.stringify(auxdef);
                                flexygo.nav.openPageName('SGA_PDA_pg_BultoSalida', 'SGA_PDA_Bulto_Salida', `IdDocDetalle=${response.Data.IdDocDetalle}`, page.defaults, 'main', false, e);
                            }
                        }
                    }
                });
            };
            //BULTO UBICACIÓN ORIGEN: Botón Confirmar para confirmar la ubicación origen y comenzar el trabajo de bulto
            expedicion_1.ComenzarTrabajo = (e, modNameSel, modNameOri) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //módulos de control
                let modSelected = $(`[modulename=${modNameSel}]flx-list`)[0];
                let modOrigen = $(`[modulename=${modNameOri}]flx-view`)[0];
                //Parámetros
                let pbCodigoBulto = $("#codBulto");
                let pbIdBulto = $("#IdBulto");
                //Se ha leído la ubicación
                if (modSelected.data && modSelected.data.length > 0 && modOrigen.data) {
                    flexygo.pda.addLock();
                    let CodUbicacion = modSelected.data[0].Codigo;
                    let IdUbicacion = modSelected.data[0].IdUbicacion;
                    let CodUbicOrigen = modOrigen.data.CodigoUbicacion.Value;
                    if (CodUbicacion != CodUbicOrigen) {
                        flexygo.msg.confirm('La ubicación no coincide.¿Desea continuar?', function (ret) {
                            if (ret) {
                                auxdef.CodBulto = pbCodigoBulto.val();
                                auxdef.IdBulto = pbIdBulto.val();
                                auxdef.CodUbic = CodUbicacion;
                                auxdef.CodigoUbicacion = CodUbicacion;
                                auxdef.IdUbicacion = IdUbicacion;
                                page.defaults = JSON.stringify(auxdef);
                                flexygo.nav.openPageName('SGA_PDA_pg_Expediciones_BultoLectura', 'SGA_PDA_Bulto', `IdBulto=${auxdef.IdBulto}`, page.defaults, 'main', false, e);
                            }
                            else {
                                flexygo.pda.ubicacion.LimpiarUbicacion();
                            }
                        });
                    }
                    else {
                        auxdef.CodBulto = pbCodigoBulto.val();
                        auxdef.IdBulto = pbIdBulto.val();
                        auxdef.CodUbic = CodUbicacion;
                        auxdef.CodigoUbicacion = CodUbicacion;
                        auxdef.IdUbicacion = IdUbicacion;
                        page.defaults = JSON.stringify(auxdef);
                        flexygo.nav.openPageName('SGA_PDA_pg_Expediciones_BultoLectura', 'SGA_PDA_Bulto', `IdBulto=${auxdef.IdBulto}`, page.defaults, 'main', false, e);
                    }
                }
                else {
                    flexygo.msg.warning("Selecciona una ubicación");
                }
            };
            //BULTO: Botón confirmar la lectura del bulto y pasar a ubicación destino
            expedicion_1.ConfirmarBulto = (e) => {
                //Parámetros
                let pbCodigo = $('flx-text[name = "pbCodigoBulto"]');
                let pbCombo = $('flx-dbcombo[name = "pbComboBulto"]');
                //Valor
                let IdBulto = pbCombo.val();
                //Lectura correcta
                if (!IdBulto) {
                    flexygo.msg.warning("No se ha seleccionado una bulto", null, '');
                    return;
                }
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Verificar que es el mismo bulto
                if (auxdef.IdBulto != IdBulto) {
                    flexygo.msg.warning("El bulto no coincide con el del trabajo", null, '');
                    return;
                }
                //confirmamos lectura
                let proc = new flexygo.Process('SGA_PDA_dll_Trabajo_ConfirmaLecturaBulto', null, null);
                let params = [
                    { "Key": "IdDocDetalle", "Value": auxdef.IdDocDetalle },
                    { "Key": "CodBulto", "Value": auxdef.CodBulto },
                    { "Key": "CodUbicacion", "Value": auxdef.CodUbic }
                ];
                flexygo.pda.addLock();
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            flexygo.pda.removeLock();
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                            flexygo.nav.openPageName('syspage-generic-controlpanel', '', '', null, 'main', false, null);
                        }
                        else if (response.SuccessMessage) {
                            flexygo.nav.openPageName('SGA_PDA_m_Expediciones_BultoUbicacionDestino', 'SGA_PDA_Bulto_Salida', `IdDocDetalle=${auxdef.IdDocDetalle}`, page.defaults, 'main', false, e);
                        }
                    }
                });
            };
            //BULTO UBICACIÓN DESTINO: Carga inicial del módulo
            expedicion_1.InicializaModuloUbicacionDestino = () => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                flexygo.pda.addLock();
                //Instanciamos trabajo y obtenemos ubicación destino
                let TrabajoDetalle = new flexygo.obj.Entity(`SGA_PDA_Bulto_Salida`, `IdTrabajoAlm = ${auxdef.IdTrabajo} AND IdDocDetalle = ${auxdef.IdDocDetalle}`);
                TrabajoDetalle.read();
                if (TrabajoDetalle.data && TrabajoDetalle.data.CodigoUbicacionDestino.Value) {
                    //Carga la ubicación de lectura de destino y la valida
                    $("#CodUbic").val(TrabajoDetalle.data.CodigoUbicacionDestino.Value);
                    $("#CodUbic").find('input').trigger('input');
                }
                flexygo.pda.removeLock();
            };
            //BULTO UBICACIÓN DESTINO: Botón finalizar trabajo de bulto completo
            expedicion_1.Finalizar = (e) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Parámetros
                let pbComboUbicacion = $('flx-dbcombo[name = "pbComboUbicacion"]');
                //Si no tiene datos no se ha introducido la ubicación
                if (!pbComboUbicacion.val()) {
                    flexygo.msg.warning("No ha introducido una Ubicación");
                    return;
                }
                flexygo.pda.addLock();
                //Datos del trabajo
                let TrabajoDetalle = new flexygo.obj.Entity(`SGA_PDA_Bulto_Salida`, `IdTrabajoAlm = ${auxdef.IdTrabajo} AND IdDocDetalle = ${auxdef.IdDocDetalle}`);
                TrabajoDetalle.read();
                if (!TrabajoDetalle.data || !TrabajoDetalle.data.IdUbicacionDestino.Value) {
                    flexygo.msg.warning("No se ha podido recuperar la ubicación destino del trabajo de bulto");
                    return;
                }
                if (TrabajoDetalle.data.IdUbicacionDestino.Value != pbComboUbicacion.val()) {
                    flexygo.msg.confirm("La ubicación no coincide ¿Desea continuar?", function (ret) {
                        if (!ret) {
                            flexygo.pda.ubicacion.LimpiarUbicacion();
                            return;
                        }
                        else {
                            expedicion_1.FinalizarExpedicion(e, pbComboUbicacion.val());
                        }
                    });
                }
                else {
                    expedicion_1.FinalizarExpedicion(e, pbComboUbicacion.val());
                }
            };
            //BULTO UBICACIÓN DESTINO: proceso que finaliza la lectura con la ubicación concreta
            expedicion_1.FinalizarExpedicion = (e, IdUbicacion) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                flexygo.pda.addLock();
                //Recuperamos el código de ubicación a partir del IdUbicacion
                let UbicacionDestino = new flexygo.obj.Entity(`SGA_PDA_Ubicacion`, `IdUbicacion = '${IdUbicacion}'`);
                UbicacionDestino.read();
                let CodDestino = UbicacionDestino.data.Codigo.Value;
                //Validamos trabajo y recuperamos bultos pendientes
                let proc = new flexygo.Process('SGA_PDA_dll_Expediciones_Finalizar', null, null);
                let params = [
                    { "Key": "IdTrabajo", "Value": auxdef.IdTrabajo },
                    { "Key": "CodUbicDestino", "Value": CodDestino },
                    { "Key": "IdExpedicion", "Value": auxdef.IdExpedicion },
                    { "Key": "IdDestinatario", "Value": auxdef.IdDestinatario }
                ];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            flexygo.pda.removeLock();
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                            flexygo.nav.openPageName('syspage-generic-controlpanel', '', '', null, 'main', false, null);
                        }
                        else if (response.SuccessMessage) {
                            if (response.Data.BultosPendientes > 0) {
                                flexygo.pda.removeLock();
                                flexygo.pda.expedicion.SiguienteBulto(e);
                            }
                            else {
                                //Si hay más destinatarios en la misma expedición, abrimos página de destinatarios
                                let Destinatario = new flexygo.obj.Entity(`SGA_PDA_Expediciones_Destinatario`);
                                let numDestinatarios = Destinatario.getViewCount("SGA_PDA_Expediciones_DestinatarioDefaultList", `IdExpedicion=${auxdef.IdExpedicion} AND IdMaquina = '${flexygo.context.currentMaquina}' AND BultosPendientes > 0`);
                                if (numDestinatarios > 0) {
                                    flexygo.msg.success("Trabajos de destinatario finalizados");
                                    flexygo.nav.openPageName('SGA_PDA_pg_ExpedicionesDestinatarios', 'SGA_PDA_Expediciones_Destinatarios', `IdExpedicion=${auxdef.IdExpedicion} AND IdMaquina = '${flexygo.context.currentMaquina}' AND BultosPendientes > 0`, page.defaults, 'main', false);
                                    return;
                                }
                                //Si no hay más destinatarios, pero quedan expediciones pendientes, abrimos página de expediciones
                                let Expedicion = new flexygo.obj.Entity(`SGA_PDA_Expedicion`);
                                let numExpediciones = Expedicion.getViewCount("SGA_PDA_ExpedicionDefaultList", "1=1");
                                if (numExpediciones > 0) {
                                    flexygo.msg.success("Trabajos de expedición finalizados");
                                    flexygo.nav.openPageName('SGA_PDA_pg_Expediciones', '', '', null, 'main', false, null);
                                    return;
                                }
                                //Si no hay ni destinatarios ni expediciones abrimos Home
                                flexygo.msg.success("No quedan más expediciones pendientes");
                                flexygo.nav.execProcess('GoHome', '', '', null, null, 'current', false, e);
                            }
                        }
                    }
                });
            };
        })(expedicion = pda.expedicion || (pda.expedicion = {}));
    })(pda = flexygo.pda || (flexygo.pda = {}));
})(flexygo || (flexygo = {}));
//# sourceMappingURL=expedicion.js.map