var flexygo;
(function (flexygo) {
    var pda;
    (function (pda) {
        var generarbulto;
        (function (generarbulto) {
            //GENÉRICO: El evento OnKeyUp se usa para no lanzar la acción del enter sobre los focos de botón. Es necesario un OnKeyDown sólo para el tabulador
            generarbulto.readKeyTab = (e, funcname, params) => {
                if (e.keyCode == 9) {
                    e.preventDefault();
                    flexygo.pda.generarbulto[funcname].apply(flexygo.pda.generarbulto, params);
                }
                else {
                    return;
                }
            };
            //GENÉRICO: Lectura de carácteres de entrada y ejecución de la función cuando se recibe ENTER
            generarbulto.readByCharacter = (e, funcname, params) => {
                if (e.keyCode == 13) {
                    flexygo.pda.generarbulto[funcname].apply(flexygo.pda.generarbulto, params);
                }
                else {
                    return;
                }
            };
            //LEER UBICACIÓN: leer ubicación y comenzar proceso de lectura de artículos
            generarbulto.Comenzar = (e, selected) => {
                let module = $(`[modulename=${selected}]flx-list`)[0];
                let idUbicacion = module.data[0].IdUbicacion;
                let codUbic = module.data[0].Codigo;
                if (module.data && module.data.length > 0) {
                    flexygo.nav.openPageName('SGA_PDA_GenerarBultos', 'SGA_PDA_Ubicacion', `Idalmacen = ${flexygo.context.currentAlmacen} AND IdUbicacion = '${idUbicacion}'`, `{"IdUbicacionOrigen" : "${idUbicacion}", "CodigoUbicacionOrigen":"${codUbic}"}`, 'main', true, e);
                }
                else {
                    flexygo.msg.warning("Selecciona una ubicación de origen");
                }
            };
            //GENERAR BULTO: lectura del bulto para creación. Puede no existir el código de barras introducido y el proceso de generar bulto lo creará.
            generarbulto.LeerBulto = (item, event) => {
                //Parámetros
                let parametros = $(`.param`);
                let pbCodigoBulto = $('flx-text[name = "pbCodigoBulto"]');
                let pbComboBulto = $('flx-dbcombo[name = "pbComboBulto"]');
                let pbComboEmbalaje = $('flx-dbcombo[name = "pbComboEmbalaje"]');
                let pbCodigoArticulo = $('flx-text[name = "pbCodigoArticulo"]');
                //Valor de búsqueda del campo de texto o del combo
                let valorBusqueda = ((item.tagName).toLowerCase() == "flx-text") ? pbCodigoBulto.val() : pbComboBulto.val();
                if (!valorBusqueda) {
                    return;
                }
                ;
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Campo que indica si la lectura se ha llevado a cabo
                let read = false;
                //Si ha cambiado el valor del combo. Evitamos lanzar la búsqueda con el mismo valor.
                if (auxdef.valorBusqueda != valorBusqueda) {
                    //En caso de recibir parámetro con longitudes a tener en cuenta, y se trata del campo de texto, se verifica si se ha legeado al tamaño del parámetro
                    read = parametros ? (((item.tagName).toLowerCase() == "flx-text") ? flexygo.pda.readCode(parametros, valorBusqueda, event) : true) : true;
                    //Si damos la entrada como buena
                    if (read) {
                        flexygo.pda.addLock();
                        //Se utiliza el objeto Flexygo para obtener los datos relacionados
                        let ObjectWhere = (item.tagName).toLowerCase() != "flx-text" ? `IdBulto = ${valorBusqueda}` : `CodBarras1 = '${valorBusqueda}'`;
                        let BultoEnt = new flexygo.obj.Entity(`SGA_PDA_BULTOS`, ObjectWhere);
                        BultoEnt.read();
                        //Carga de valores
                        if (BultoEnt.data.IdBulto.Value) {
                            //Lectura en los pagedefaults
                            auxdef.IdBulto = BultoEnt.data.IdBulto.Value;
                            //Si entra por texto hay que cargar el Id, en caso de existir un bulto con ese código. Si no existe el proceso lo creará al aceptar la lectura
                            if ((item.tagName).toLowerCase() == "flx-text") {
                                pbComboBulto.val(BultoEnt.data.IdBulto.Value);
                            }
                            //Carga el embalaje, en caso de existir
                            if (BultoEnt.data.IdEmbalaje.Value) {
                                //carga de dato
                                pbComboEmbalaje.val(BultoEnt.data.IdEmbalaje.Value);
                                //Foco al campo del artículo
                                pbCodigoArticulo[0].querySelector('input').focus();
                            }
                            else {
                                //Foco para selección manual
                                pbComboEmbalaje[0].querySelector('input').focus();
                            }
                        }
                        //Valor de búsqueda para evitar búsquedas redundantes
                        auxdef.valorBusqueda = valorBusqueda;
                        page.defaults = JSON.stringify(auxdef);
                        flexygo.pda.removeLock();
                    }
                }
            };
            //GENERAR BULTO: lectura de artículo para incluir como detalle del bulto
            generarbulto.LeerArticulo = (item, modName, modType, event) => {
                //Parámetros y campos
                let parametros = $(`.param`);
                let pbCodigo = $('flx-text[name = "pbCodigoArticulo"]');
                let pbCombo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbComboUnidades = $('flx-dbcombo[name = "pbComboUnidades"]');
                let pbCantidadStock = $('flx-text[name = "pbCantidadStock"]');
                let pbUnidadStock = $('flx-text[name = "pbUnidadStock"]');
                let pbStock = $('flx-text[name = "pbStock"]');
                let pbStockUbicacion = $('flx-text[name = "pbStockUbicacion"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                //Valor de búsqueda del campo de texto o del combo
                let valorBusqueda = ((item.tagName).toLowerCase() == "flx-text") ? pbCodigo.val() : pbCombo.val();
                if (!valorBusqueda) {
                    return;
                }
                ;
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Campo que indica si la lectura se ha llevado a cabo
                let read = false;
                //Si ha cambiado el valor del combo. Evitamos lanzar la búsqueda con el mismo valor.
                if (auxdef.valorBusqueda != valorBusqueda) {
                    //En caso de recibir parámetro con longitudes a tener en cuenta, y se trata del campo de texto, se verifica si se ha legeado al tamaño del parámetro
                    read = parametros ? (((item.tagName).toLowerCase() == "flx-text") ? flexygo.pda.readCode(parametros, valorBusqueda, event) : true) : true;
                }
                //Si damos la entrada como buena
                if (read) {
                    flexygo.pda.addLock();
                    let articulo = flexygo.pda.articulo.Buscar(valorBusqueda);
                    articulo.then(function (datos) {
                        //No encontrado
                        if (!datos.IdArticulo) {
                            flexygo.msg.warning("No se ha encontrado ningún artículo.");
                            flexygo.pda.generarbulto.LimpiarCampos();
                            return;
                        }
                        //Módulo con datos del artículo leído
                        let module = $('flx-module')[0];
                        let page = flexygo.history.get(module);
                        let modLectura = $(`[modulename=${modName}]${modType}`)[0];
                        modLectura.additionalWhere = `IdArticulo = '${datos.IdArticulo}'`;
                        modLectura.init();
                        //TRATAMOS LOTES
                        //Si recibimos lote interno lo cargamos y ocultamos el combo
                        if (datos.LoteInterno) {
                            pbLote.val(datos.LoteInterno);
                            pbLote.hide();
                        }
                        //Ocultamos o mostramos combo según artículo
                        if (!datos.RequiereLote) {
                            pbLote.hide();
                        }
                        else {
                            pbLote.show();
                            //si recibimos el lote lo cargamos
                            if (datos.Lote) {
                                pbLote.val(datos.Lote);
                            }
                        }
                        //TRATAMOS PROPIEDADES
                        //Ocultamos/Mostramos los combos y cargamos la propiedad recibida
                        datos.RequiereP1 ? pbComboP1.show() : pbComboP1.hide();
                        datos.RequiereP2 ? pbComboP2.show() : pbComboP2.hide();
                        if (datos.P1) {
                            pbComboP1.val(datos.P1);
                        }
                        ;
                        if (datos.P2) {
                            pbComboP2.val(datos.P2);
                        }
                        ;
                        //Valores de campos de búsqueda
                        if ((item.tagName).toLowerCase() == "flx-dbcombo") {
                            //Evento lanzado por el combo, se pone en el código el CodBarras asociado o IdArticulo si no tiene código
                            valorBusqueda = datos.IdArticulo;
                            pbCodigo.val(valorBusqueda);
                        }
                        else {
                            //Evento lanzado por el campo de texto, se establece el ID en el combo
                            pbCombo.val(datos.IdArticulo);
                        }
                        //Valor de búsqueda para no repetir acción si no cambia
                        auxdef.valorBusqueda = valorBusqueda;
                        page.defaults = JSON.stringify(auxdef);
                        //Se recupera el valor por defecto del tipo de unidad de artículo
                        let tipoUnidad = flexygo.pda.articulo.TipoUnidad(datos.IdArticulo, pbLote.val() ? pbLote.val() : "");
                        tipoUnidad.then(function (tipo) {
                            //Tipos de Unidades del artículo para conversiones
                            pbComboUnidades[0].additionalWhere = `IdArticulo = '${datos.IdArticulo}'`;
                            pbComboUnidades[0].refresh();
                            pbComboUnidades[0].querySelector("input").disabled = false;
                            if (tipo) {
                                pbComboUnidades.val(tipo);
                                pbUnidadStock.val(tipo);
                                pbCantidadStock.val(null);
                            }
                        });
                        tipoUnidad.catch(function (error) {
                            if (error && error != "") {
                                flexygo.msg.warning(error);
                                return;
                            }
                        });
                        //Cargar el stock. También devuelve el lote y las propiedades en caso de devolver un sólo registro de stock en la ubicación
                        let obtenerStock = flexygo.pda.ubicacion.ObtenerStockPicking(datos.IdArticulo, pbLote.val(), pbComboP1.val(), pbComboP2.val(), auxdef.IdUbicacionOrigen);
                        obtenerStock.then(function (stock) {
                            if (stock) {
                                if (stock.length == 1) {
                                    //Devuelve un único lote
                                    if (stock[0].Lote) {
                                        pbLote.val(stock[0].Lote);
                                    }
                                    //Devuelve una única P1
                                    if (stock[0].P1) {
                                        pbComboP1.val(stock[0].P1);
                                    }
                                    //Devuelve una única P2
                                    if (stock[0].P2) {
                                        pbComboP2.val(stock[0].P2);
                                    }
                                }
                                //Devuelve stock
                                const initialValue = 0;
                                const stockUbic = stock.reduce((previousValue, currentValue) => previousValue + currentValue.DifUbicBulto, initialValue);
                                if (stockUbic) {
                                    pbStockUbicacion.val(stockUbic);
                                }
                                //Focos
                                if (pbLote.attr("style") != 'display: none;' && !pbLote.val()) {
                                    pbLote[0].querySelector("input").focus();
                                }
                                else if (pbComboP1.attr("style") != 'display: none;' && !pbComboP1.val()) {
                                    pbComboP1[0].querySelector("input").focus();
                                }
                                else if (pbComboP2.attr("style") != 'display: none;' && !pbComboP2.val()) {
                                    pbComboP2[0].querySelector("input").focus();
                                }
                                else {
                                    pbCantidad[0].querySelector("input").focus();
                                }
                            }
                        });
                        obtenerStock.catch(function (error) { if (error && error != "") {
                            flexygo.msg.warning(error);
                        } });
                    });
                    articulo.catch(function (error) {
                        if (error && error != "") {
                            flexygo.msg.warning(error);
                            return;
                        }
                    });
                    flexygo.pda.removeLock();
                }
            };
            //GENERAR BULTO: combo de lotes. Efecto de pérdida de foco
            generarbulto.LeerLote = (item, event) => {
                //Parámetros y campos
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbStockUbicacion = $('flx-text[name = "pbStockUbicacion"]');
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Unidad del combo
                let lote = pbComboLote.val() ? pbComboLote.val() : ($('flx-dbcombo[name = "pbComboLote"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboLote"] li.selected')[0].dataset.value : null);
                flexygo.pda.addLock();
                //Cargar el stock. También devuelve el lote y las propiedades en caso de devolver un sólo registro de stock en la ubicación
                let lectura = flexygo.pda.ubicacion.ObtenerStockPicking(pbComboArticulo.val(), lote, pbComboP1.val(), pbComboP2.val(), auxdef.IdUbicacionOrigen);
                lectura.then(function (stock) {
                    if (stock) {
                        if (stock.length == 1) {
                            //Devuelve una única P1
                            if (stock[0].P1) {
                                pbComboP1.val(stock[0].P1);
                            }
                            //Devuelve una única P2
                            if (stock[0].P2) {
                                pbComboP2.val(stock[0].P2);
                            }
                        }
                        //Devuelve stock
                        const initialValue = 0;
                        const stockUbic = stock.reduce((previousValue, currentValue) => previousValue + currentValue.DifUbicBulto, initialValue);
                        if (stockUbic) {
                            pbStockUbicacion.val(stockUbic);
                        }
                        //Focos
                        if (pbComboLote.attr("style") != 'display: none;' && !pbComboLote.val()) {
                            pbComboLote[0].querySelector("input").focus();
                        }
                        else if (pbComboP1.attr("style") != 'display: none;' && !pbComboP1.val()) {
                            pbComboP1[0].querySelector("input").focus();
                        }
                        else if (pbComboP2.attr("style") != 'display: none;' && !pbComboP2.val()) {
                            pbComboP2[0].querySelector("input").focus();
                        }
                        else {
                            pbCantidad[0].querySelector("input").focus();
                        }
                    }
                    flexygo.pda.removeLock();
                });
                lectura.catch(function (error) { if (error && error != "") {
                    flexygo.msg.warning(error);
                } });
            };
            //GENERAR BULTO: combo de propiedades. Efecto de pérdida de foco
            generarbulto.LeerPropiedad = (item, event) => {
                //Parámetros y campos
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbStockUbicacion = $('flx-text[name = "pbStockUbicacion"]');
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                flexygo.pda.addLock();
                let P1 = pbComboP1.val() ? pbComboP1.val() : ($('flx-dbcombo[name = "pbComboP1"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboP1"] li.selected')[0].dataset.value : null);
                let P2 = pbComboP2.val() ? pbComboP2.val() : ($('flx-dbcombo[name = "pbComboP2"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboP2"] li.selected')[0].dataset.value : null);
                //Cargar el stock. También devuelve el lote y las propiedades en caso de devolver un sólo registro de stock en la ubicación
                let lectura = flexygo.pda.ubicacion.ObtenerStockPicking(pbComboArticulo.val(), pbComboLote.val(), P1, P2, auxdef.IdUbicacionOrigen);
                lectura.then(function (stock) {
                    if (stock) {
                        //Devuelve stock
                        const initialValue = 0;
                        const stockUbic = stock.reduce((previousValue, currentValue) => previousValue + currentValue.DifUbicBulto, initialValue);
                        if (stockUbic) {
                            pbStockUbicacion.val(stockUbic);
                        }
                        //Focos
                        if (pbComboLote.attr("style") != 'display: none;' && !pbComboLote.val()) {
                            pbComboLote[0].querySelector("input").focus();
                        }
                        else if (pbComboP1.attr("style") != 'display: none;' && !pbComboP1.val()) {
                            pbComboP1[0].querySelector("input").focus();
                        }
                        else if (pbComboP2.attr("style") != 'display: none;' && !pbComboP2.val()) {
                            pbComboP2[0].querySelector("input").focus();
                        }
                        else {
                            pbCantidad[0].querySelector("input").focus();
                        }
                    }
                    flexygo.pda.removeLock();
                });
                lectura.catch(function (error) { if (error && error != "") {
                    flexygo.msg.warning(error);
                } });
            };
            //GENERAR BULTO: introducción de cantidad leída y unidad de lectura
            generarbulto.LeerCantidad = (item, event) => {
                //Parámetros y campos
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboEmbalaje = $('flx-dbcombo[name = "pbComboEmbalaje"]');
                let pbComboUnidades = $('flx-dbcombo[name = "pbComboUnidades"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbCantidadStock = $('flx-text[name = "pbCantidadStock"]');
                //Unidad del combo
                let UnidadLectura = pbComboUnidades.val() ? pbComboUnidades.val() : ($('flx-dbcombo[name = "pbComboUnidades"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboUnidades"] li.selected')[0].dataset.value : null);
                flexygo.pda.addLock();
                //Conversión de unidades
                let lectura = flexygo.pda.articulo.ConvertirUnidades(pbComboArticulo.val(), pbComboLote.val(), pbComboEmbalaje.val(), UnidadLectura, pbCantidad.val() ? pbCantidad.val() : 0);
                lectura.then(function (datos) {
                    if (datos) {
                        pbCantidadStock.val(datos.Cantidad_Stock);
                        $('#btnConfirmarGenerarBulto').focus();
                    }
                    flexygo.pda.removeLock();
                });
                lectura.catch(function (error) { if (error && error != "") {
                    flexygo.msg.warning(error);
                } });
            };
            //GENERAR BULTO: limpieza de campos de la pantalla principal de lectura de artículo
            generarbulto.LimpiarCampos = () => {
                //Campos de artículo
                $("#CodBarras").val(null);
                $("#cboArticulos").val(null);
                //Módulo artículo seleccionado
                let modRefresh = $(`[modulename=SGA_PDA_m_ArticuloSeleccionado]flx-list`)[0];
                modRefresh.additionalWhere = "1 = 0";
                modRefresh.init();
                //Campos de proveedor
                $("#loteProv").val(null);
                $('#loteProv').hide();
                //Combos Propiedades
                $('#cboP1').hide();
                $('#cboP1').val(null);
                $('#cboP2').hide();
                $('#cboP2').val(null);
                //Campos de cantidades y tipos de unidad
                $("#cantidad").val(null);
                $("#cboUnidades").val(null);
                $("#cantidadStock").val(null);
                $("#unidadStock").val(null);
                $("#stock").val(null);
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                auxdef.valorBusqueda = "";
                page.defaults = JSON.stringify(auxdef);
                //Foco
                $("#CodBarras")[0].querySelector("input").focus();
            };
            //GENERAR BULTO: confirmar la lectura del artículo
            generarbulto.ConfirmarArticulo = (e) => {
                //Parámetros y campos
                let pbCodigoBulto = $('flx-text[name = "pbCodigoBulto"]');
                let pbComboBulto = $('flx-dbcombo[name = "pbComboBulto"]');
                let pbComboEmbalaje = $('flx-dbcombo[name = "pbComboEmbalaje"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                if (!pbComboEmbalaje.val()) {
                    flexygo.msg.warning("Selecciona un embalaje");
                    return;
                }
                if (!pbCantidad.val()) {
                    flexygo.msg.warning("Cantidad incorrecta");
                    return;
                }
                if (!pbComboArticulo.val()) {
                    flexygo.msg.warning("Articulo no encontrado");
                    return;
                }
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                flexygo.pda.addLock();
                var proc = new flexygo.Process('SGA_PDA_dll_Bulto_Generar', null, null);
                var params = [
                    { "Key": "IdBulto", "Value": pbComboBulto.val() },
                    { "Key": "CodigoBulto", "Value": pbCodigoBulto.val() },
                    { "Key": "IdUbicacion", "Value": auxdef.IdUbicacionOrigen },
                    { "Key": "IdArticulo", "Value": pbComboArticulo.val() },
                    { "Key": "IdEmbalaje", "Value": pbComboEmbalaje.val() },
                    { "Key": "Lote", "Value": pbComboLote.val() },
                    { "Key": "Cantidad", "Value": Number(pbCantidad.val()) },
                    { "Key": "P1", "Value": pbComboP1.val() },
                    { "Key": "P2", "Value": pbComboP2.val() }
                ];
                proc.run(params, function (response) {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                        else if (response.SuccessMessage) {
                            if (!pbComboBulto.val()) {
                                flexygo.msg.success("Bulto creado correctamente.");
                            }
                            if (response.Data.IdBulto) {
                                pbComboBulto.val(response.Data.IdBulto);
                            }
                            if (response.Data.CodigoBulto) {
                                pbCodigoBulto.val(response.Data.CodigoBulto);
                            }
                            flexygo.pda.generarbulto.LimpiarCampos();
                        }
                        flexygo.pda.removeLock();
                    }
                });
            };
        })(generarbulto = pda.generarbulto || (pda.generarbulto = {}));
    })(pda = flexygo.pda || (flexygo.pda = {}));
})(flexygo || (flexygo = {}));
//# sourceMappingURL=generarbulto.js.map