var flexygo;
(function (flexygo) {
    var pda;
    (function (pda) {
        var incidencia;
        (function (incidencia) {
            //GENÉRICO: El evento OnKeyUp se usa para no lanzar la acción del enter sobre los focos de botón. Es necesario un OnKeyDown sólo para el tabulador
            incidencia.readKeyTab = (e, funcname, params) => {
                if (e.keyCode == 9) {
                    e.preventDefault();
                    flexygo.pda.incidencia[funcname].apply(flexygo.pda.incidencia, params);
                }
                else {
                    return;
                }
            };
            //GENÉRICO: Lectura de carácteres de entrada y ejecución de la función cuando se recibe ENTER
            incidencia.readByCharacter = (e, funcname, params) => {
                if (e.keyCode == 13) {
                    flexygo.pda.incidencia[funcname].apply(flexygo.pda.incidencia, params);
                }
                else {
                    return;
                }
            };
            //GENÉRICO: Recibe una lista de campos para validar que exista en el page.defaults y lanza la carga de la incidencia con esos datos
            incidencia.preparaIncidencia = (e, campos) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Se buscan en los defaults los campos informados de incidencia
                let arrFields = campos.split(",");
                let llamada = true;
                arrFields.map((field) => {
                    if (!JSON.parse(page.defaults)[field]) {
                        llamada = false;
                    }
                });
                if (llamada) {
                    flexygo.pda.incidencia.Rellenar(e);
                }
                else {
                    flexygo.msg.warning("Datos insuficientes para la incidencia", null, null);
                }
            };
            //GENÉRICO: Rellenar la incidencia con los datos recibidos por el page.defaults
            incidencia.Rellenar = (e) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                flexygo.pda.addLock();
                let proc = new flexygo.Process('SGA_PDA_dll_Incidencia_Rellenar', null, null);
                let params = [
                    { 'Key': 'IdBulto', 'Value': auxdef.IdBulto },
                    { 'Key': 'IdTrabajo', 'Value': auxdef.IdTrabajo },
                    { 'Key': 'IdDocDetalle', 'Value': auxdef.IdDocDetalle },
                    { 'Key': 'IdOrdenCarga', 'Value': auxdef.IdOrdenCarga }
                ];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                        else if (response.SuccessMessage) {
                            auxdef.CodigoUbicacion = response.Data.CodigoUbicacion;
                            auxdef.CodigoBulto = response.Data.CodigoBulto;
                            page.defaults = JSON.stringify(auxdef);
                            flexygo.nav.openPageName('PDA_pg_Incidencias', '', '', page.defaults, 'main', false, e);
                        }
                    }
                });
            };
            //PÁGINA INCIDENCIAS
            //-----------------------------------------
            //INCIDENCIA: Inicializa el módulo de datos de incidencia. Cargado en el afterload
            incidencia.InicializaModulo = () => {
                //Carga de parámetros
                flexygo.pda.loadParametros($(".param"));
                //Campos de lectura de ubicación y bulto
                let pbCodigoUbicacion = $('flx-text[name = "pbCodigoUbicacion"]');
                let pbComboUbicacion = $('flx-dbcombo[name = "pbComboUbicacion"]');
                let pbCodigoBulto = $('flx-text[name = "pbCodigoBulto"]');
                let pbComboBulto = $('flx-dbcombo[name = "pbComboBulto"]');
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Precarga de datos de ubicación y bulto
                if (auxdef.CodigoUbicacion && auxdef.CodigoUbicacion != "") {
                    pbCodigoUbicacion.val(auxdef.CodigoUbicacion);
                    pbCodigoUbicacion.trigger("input");
                }
                if (auxdef.IdUbicacion && auxdef.IdUbicacion != "") {
                    pbComboUbicacion.val(auxdef.IdUbicacion);
                    pbComboUbicacion.trigger("change");
                }
                if (auxdef.CodigoBulto && auxdef.CodigoBulto != "") {
                    pbCodigoBulto.val(auxdef.CodigoBulto);
                    pbCodigoBulto.trigger("input");
                }
                if (auxdef.IdBulto && auxdef.IdBulto != 0) {
                    pbComboBulto.val(auxdef.IdBulto);
                    pbComboBulto.trigger("change");
                }
                //Foco automático al primer elemento disponible
                flexygo.pda.setAutomaticFocus(null);
            };
            //INCIDENCIA: Botón cancelar. Regresa a la página de origen
            incidencia.Cancelar = () => {
                //Flexygo captura el evento y va a la página anterior del hitorial
                window.history.back();
            };
            //INCIDENCIA: botón Aceptar. Guardar datos, si se marca maquina va al modulo maquina y desde alli guarda los datos con el page.defaults
            incidencia.Guardar = (e) => {
                //Campos de lectura de ubicación y bulto
                let pbComboUbicacion = $('flx-dbcombo[name = "pbComboUbicacion"]');
                let pbCodigoUbicacion = $('flx-dbcombo[name = "pbCodigoUbicacion"]');
                let pbComboBulto = $('flx-dbcombo[name = "pbComboBulto"]');
                let pbCodigoBulto = $('flx-dbcombo[name = "pbCodigoBulto"]');
                let pbComboIncidencia = $('flx-dbcombo[name = "pbComboIncidencia"]');
                let pbFechaIncidencia = $('flx-text[name = "pbFechaIncidencia"]');
                let pbHoraIncidencia = $('flx-text[name = "pbHoraIncidencia"]');
                let pbObservaciones = $('flx-textarea[name = "pbObservaciones"]');
                //Ubicación obligatoria
                if (!pbComboUbicacion.val()) {
                    flexygo.msg.warning("Indique una ubicación");
                    flexygo.pda.setAutomaticFocus(null);
                    return;
                }
                //Tipo de Incidencia Obligatoria
                if (!pbComboIncidencia.val()) {
                    flexygo.msg.warning("Indique un tipo de Incidencia");
                    return;
                }
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Datos del tipo de incidencia
                let TipoIncEnt = new flexygo.obj.Entity(`SGA_PDA_TIPOS_INCIDENCIA`, `IdDoc = '${pbComboIncidencia.val()}'`);
                TipoIncEnt.read();
                //Si el tipo de incidencia tiene el check de máquina hay que presentar el trabajo de la máquina para permitir introducir cantidades de rotura y regularizar el trabajo y el stock
                if (TipoIncEnt.data.Maquina) {
                    let MaqEnt = new flexygo.obj.Entity(`SGA_PDA_Trabajos_Almacen`);
                    let Cant = auxdef.IdTrabajo ? MaqEnt.getViewCount("SGA_PDA_v_Incidencia_Maquinas", `IdtrabajoAlm = ${auxdef.IdTrabajo} and IdMaquina = '${TipoIncEnt.data.maquina}'`) : 0;
                    if (Cant == 0) {
                        auxdef.TipoIncidenciaLect = TipoIncEnt.data.IdTipoInc.Value;
                        auxdef.TipoTareaLect = TipoIncEnt.data.IdTipoTarea.Value;
                        auxdef.CodUbicacionLect = pbCodigoUbicacion.val();
                        auxdef.CodBultoLect = pbCodigoBulto.val();
                        auxdef.FechaLect = pbFechaIncidencia.val().toISOString().slice(0, 10);
                        auxdef.HoraLect = pbHoraIncidencia.val();
                        auxdef.ObservacionesLect = pbObservaciones.val();
                        page.defaults = JSON.stringify(auxdef);
                        flexygo.nav.openPageName('PDA_pg_Incidencias_Maquina', null, `IdtrabajoAlm = ${auxdef.IdTrabajo} AND IdMaquina = '${flexygo.context["currentMaquina"]}'`, page.defaults, 'main', true, e);
                    }
                    else {
                        flexygo.msg.warning("No hay detalles asociados al trabajo.");
                    }
                }
                else {
                    flexygo.pda.incidencia.Aceptar(e, pbCodigoUbicacion.val(), pbCodigoBulto.val(), TipoIncEnt.data.IdTipoInc.Value, TipoIncEnt.data.IdTipoTarea.Value, pbFechaIncidencia.val().toISOString().slice(0, 10), pbHoraIncidencia.val(), pbObservaciones.val(), '');
                }
            };
            //INCIDENCIA LECTURA DE ROTURAS: introducción de la cantidad de rotura
            incidencia.Rotura = (e, event) => {
                //Foco
                flexygo.pda.setAutomaticFocus(e);
            };
            //INCIDENCIA LECTURA DE ROTURAS:guardardetalles de rotura modulo Incidencias_Maquinas
            incidencia.guardardetalles = (e) => {
                let str = "";
                let campos = $(".campos");
                for (var i = 0; i < campos.length; i++) {
                    if (campos[i].querySelector("input ").value != 0) {
                        str += `${campos[i].querySelector("#iddoc").innerText},${campos[i].querySelector("input ").value};`;
                    }
                }
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                flexygo.pda.incidencia.Aceptar(e, auxdef.CodigoUbicacion, auxdef.CodigoBulto, auxdef.TipoIncidenciaLect, auxdef.TipoTareaLect, auxdef.FechaLect, auxdef.HoraLect, auxdef.ObservacionesLect, str);
            };
            //INCIDENCIA: Aceptar la incidencia. Llamada desde las dos páginas de incidencias.
            incidencia.Aceptar = (e, CodUbicacion, CodBulto, TipoIncidencia, TipoTarea, FechaLect, HoraLect, Observaciones, Detalles) => {
                Observaciones = !Observaciones ? ' ' : Observaciones;
                Detalles = !Detalles ? ' ' : Detalles;
                flexygo.pda.addLock();
                let proc = new flexygo.Process('SGA_PDA_dll_Incidencia_Generar', null, null);
                let params = [
                    { 'Key': 'CodUbicacion', 'Value': CodUbicacion },
                    { 'Key': 'CodBulto', 'Value': CodBulto },
                    { 'Key': 'TipoIncidencia', 'Value': TipoIncidencia },
                    { 'Key': 'TipoTarea', 'Value': TipoTarea },
                    { 'Key': 'Fecha', 'Value': FechaLect },
                    { 'Key': 'Hora', 'Value': HoraLect },
                    { 'Key': 'Observaciones', 'Value': Observaciones },
                    { 'Key': 'Detalles', 'Value': Detalles }
                ];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                        else if (response.SuccessMessage) {
                            flexygo.msg.success("Incidencia guardada con exito", null, null);
                            //FALTA DESARROLLAR LA VUELTA AL ORIGEN DE LA INCIDENCIA, DE MOMENTO, SE LES MANDA A CASA
                            window.history.back();
                            //flexygo.nav.execProcess('GoHome', '', '', null, null, 'current', false, e);
                        }
                    }
                });
            };
        })(incidencia = pda.incidencia || (pda.incidencia = {}));
    })(pda = flexygo.pda || (flexygo.pda = {}));
})(flexygo || (flexygo = {}));
//# sourceMappingURL=incidencia.js.map