var flexygo;
(function (flexygo) {
    var pda;
    (function (pda) {
        var moverbulto;
        (function (moverbulto) {
            //GENÉRICO: El evento OnKeyUp se usa para no lanzar la acción del enter sobre los focos de botón. Es necesario un OnKeyDown sólo para el tabulador
            moverbulto.readKeyTab = (e, funcname, params) => {
                if (e.keyCode == 9) {
                    e.preventDefault();
                    flexygo.pda.moverbulto[funcname].apply(flexygo.pda.moverbulto, params);
                }
                else {
                    return;
                }
            };
            //GENÉRICO: Lectura de carácteres de entrada y ejecución de la función cuando se recibe ENTER
            moverbulto.readByCharacter = (e, funcname, params) => {
                if (e.keyCode == 13) {
                    flexygo.pda.moverbulto[funcname].apply(flexygo.pda.moverbulto, params);
                }
                else {
                    return;
                }
            };
            //BULTO LECTURA:  Carga inicial de la página de movimiento de bulto. Puede entrar con la lectura lanzada desde el botón Mover de Consulta - Bulto
            moverbulto.initMoverBulto = (e) => {
                //Parámetros
                let pbCodigo = $('flx-text[name = "pbCodigoBulto"]');
                flexygo.pda.loadParametros($(".param"));
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                if (auxdef.CodBarras1) {
                    pbCodigo.val(auxdef.CodBarras1);
                    pbCodigo.trigger("input");
                }
                flexygo.pda.setAutomaticFocus(null);
            };
            //BULTO LECTURA: Lectura del bulto a mover
            moverbulto.LeerBulto = (item, event) => {
                //Parámetros
                let params = $(`.param`);
                let pbCodigo = $('flx-text[name = "pbCodigoBulto"]');
                let pbCombo = $('flx-dbcombo[name = "pbComboBulto"]');
                //Valor de búsqueda del campo de texto o del combo
                let valorBusqueda = ((item.tagName).toLowerCase() == "flx-text") ? pbCodigo.val() : pbCombo.val();
                if (!valorBusqueda) {
                    return;
                }
                ;
                //Validamos multilectura
                let multilectura = flexygo.pda.moverbulto.ValidarMultilectura();
                multilectura.then(function () {
                    //Lanzamos lectura estándar
                    let lectura = flexygo.pda.bulto.LeerBultoCombo(item, event);
                    lectura.then(function (Datos) {
                        if (Datos) {
                            //Lanzamos validación del bulto
                            let validar = flexygo.pda.moverbulto.ValidarBulto();
                            validar.then(function (Validado) {
                                if (Validado && Validado == true) {
                                    //Lanzamos generación del trabajo de bulto completo de ubic del bulto a ubic de la máquina
                                    let mover = flexygo.pda.moverbulto.UbicarBulto(Datos.IdBulto);
                                    mover.then(function () {
                                        flexygo.pda.bulto.LimpiarBulto(true);
                                    });
                                    mover.catch(function (error) {
                                        if (error && error != "") {
                                            flexygo.pda.bulto.LimpiarBulto(true);
                                            flexygo.msg.warning(error);
                                        }
                                    });
                                }
                            });
                            validar.catch(function (error) {
                                if (error && error != "") {
                                    flexygo.pda.bulto.LimpiarBulto(false);
                                    flexygo.msg.warning(error);
                                }
                            });
                        }
                    });
                    lectura.catch(function (error) {
                        if (error && error != "") {
                            flexygo.msg.warning(error);
                        }
                        flexygo.pda.bulto.LimpiarBulto(false);
                    });
                });
                multilectura.catch(function (error) {
                    if (error && error != "") {
                        flexygo.msg.warning(error);
                    }
                    flexygo.pda.bulto.LimpiarBulto(false);
                });
            };
            //BULTO LECTURA: validación del bulto leído
            moverbulto.ValidarBulto = () => {
                let promesa = new Promise(function (resolve, reject) {
                    //Parámetros
                    let pbCodigo = $('flx-text[name = "pbCodigoBulto"]');
                    let pbCombo = $('flx-dbcombo[name = "pbComboBulto"]');
                    //Valor
                    let IdBulto = pbCombo.val();
                    //Valido el bulto
                    let proc = new flexygo.Process('SGA_PDA_dll_MoverBulto_Validar', null, null);
                    let params = [{ "Key": "IdBulto", "Value": IdBulto }];
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                flexygo.pda.removeLock();
                                return resolve(true);
                            }
                            if (response.LastException && response.LastException.Message) {
                                return reject(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                return reject(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                if (response.Data.Pregunta == 1) {
                                    flexygo.msg.confirm("El bulto pertenece al trabajo: " + response.Data.IdTrabajoAlm + "¿Desea continuar?", function (ret) {
                                        if (ret) {
                                            return resolve(true);
                                        }
                                        else {
                                            return resolve(false);
                                        }
                                    });
                                }
                                else {
                                    return resolve(true);
                                }
                            }
                            else {
                                return resolve(false);
                            }
                        }
                        else {
                            return reject("Proceso finalizado con errores.");
                        }
                    });
                });
                return promesa;
            };
            //BULTO LECTURA: validación del bulto leído
            moverbulto.ValidarMultilectura = () => {
                let promesa = new Promise(function (resolve, reject) {
                    //Recuperamos número de lectura actual
                    let Trabajos = new flexygo.obj.Entity(`SGA_PDA_Trabajo_Almacen`);
                    let Lecturas = Trabajos.getViewCount("SGA_PDA_v_MOVERBULTOLIST");
                    //si no hay lectura no es necesario validar nada
                    if (!Lecturas || Lecturas == 0) {
                        return resolve();
                    }
                    //Recuperamos parámetro
                    let Parametro = new flexygo.obj.Entity(`SGA_PDA_Configuracion`, `Parametro = 'Mover_Varios_Bultos'`);
                    Parametro.read();
                    //Si está a OFF no se permite más lecturas
                    if (Parametro.data.Valor.Value == "OFF" && Lecturas > 0) {
                        return reject("No puede mover más de un bulto a la vez.");
                    }
                    return resolve();
                });
                return promesa;
            };
            //BULTO LECTURA: generación del trabajo del bulto leído
            moverbulto.UbicarBulto = (IdBulto) => {
                let promesa = new Promise(function (resolve, reject) {
                    flexygo.pda.addLock();
                    let proc = new flexygo.Process('SGA_PDA_dll_MoverBulto_Ubicar', null, null);
                    let params = [{ "Key": "IdBulto", "Value": IdBulto }];
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                flexygo.pda.removeLock();
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                return resolve();
                            }
                            if (response.LastException && response.LastException.Message) {
                                return reject(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                return reject(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                //Refrescamos el módulo de lecturas
                                flexygo.pda.moverbulto.RefrescarLecturas();
                                return resolve();
                            }
                        }
                        else {
                            return reject("Proceso finalizado con errores.");
                        }
                    });
                });
                return promesa;
            };
            //BULTO LECTURA: refrescamos el módulo de lecturas
            moverbulto.RefrescarLecturas = () => {
                //Actualizar módulo de lecturas. Módulos con clase de módulo BultosMover
                $("flx-module.BultosMover").find('flx-list, flx-view').map(function (indice, modulo) {
                    let module = $(modulo)[0];
                    module.init();
                });
            };
            //BULTO LECTURA: Eliminar lectura seleccionada en el trabajo de mover varios bultos
            moverbulto.EliminarLecturaBulto = (e, IdTrabajo, IdBulto) => {
                //buscar en que ubicación está ese bulto
                let trabajo = !IdTrabajo.val() ? 0 : IdTrabajo.val();
                if (trabajo == 0) {
                    flexygo.msg.warning("Seleccione una lectura de Bulto");
                    return;
                }
                flexygo.pda.addLock();
                let UbicBulto = new flexygo.obj.Entity(`SGA_PDA_Trabajo_Almacen_Detalle`, `IdTrabajoAlm = ${IdTrabajo.val()}`);
                UbicBulto.read();
                //si encuentro el idUbicación debo mover ese bulto a el mismo sitio de donde está
                if (UbicBulto.data.IdBulto.Value) {
                    //debo identificar primero el codigo de ese idubicación
                    let Ubica = new flexygo.obj.Entity(`SGA_PDA_Ubicacion`, `IdUbicacion = '${UbicBulto.data.IdUbicacion.Value}'`);
                    Ubica.read();
                    let CodDestino = Ubica.data.Codigo.Value;
                    let proc = new flexygo.Process('SGA_PDA_dll_MoverBulto_Finalizar', null, null);
                    let params = [{ 'Key': 'CodUbicDestino', 'Value': CodDestino }, { 'Key': 'trabajo', 'Value': trabajo }];
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                flexygo.pda.removeLock();
                            }
                            if (response.LastException && response.LastException.Message) {
                                flexygo.msg.error(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                flexygo.msg.warning(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                flexygo.msg.success(flexygo.localization.translate('pda.procesook'));
                                flexygo.pda.moverbulto.RefrescarLecturas();
                            }
                        }
                    });
                }
            };
            //BULTO LECTURA: botón Mover
            moverbulto.SiguienteMoverBulto = (e) => {
                flexygo.pda.addLock();
                //Recuperamos la lista de trabajos de la misma vista que carga el módulo de lecturas
                let Trabajo = new flexygo.obj.Entity(`SGA_PDA_Trabajo_Almacen`);
                let trabajos = Trabajo.getView("SGA_PDA_v_MOVERBULTOLIST");
                //Si no hay lecturas no avanzamos
                if (trabajos.length == 0) {
                    flexygo.msg.warning("No hay ningún trabajo de bulto pendiente.");
                    return;
                }
                //String con los trabajos a mover
                const listaInicial = '';
                const listaTrabajos = trabajos.reduce((previousValue, currentValue) => previousValue + (previousValue == '' ? '' : ',') + currentValue.Trabajo, listaInicial);
                //Si hay trabajos se continúa
                if (listaTrabajos != "") {
                    flexygo.nav.openPageName('PDA_pg_MovBulto_Detalles_2', '', "Trabajo IN (" + listaTrabajos + ")", "null", 'main', false);
                }
                else {
                    flexygo.msg.warning("No hay ningún trabajo de bulto pendiente.", null, '');
                    return;
                }
            };
            //BULTO LECTURA: botón Incidencia
            moverbulto.IncidenciaBulto = (e) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Propiedades Hidden con el valor de la selección
                let IdTrabajo = $('#IdTrabajo').val();
                let IdBulto = $('#IdBulto').val();
                if (!IdBulto) {
                    flexygo.msg.warning("Seleccione un trabajo de bulto.");
                    return;
                }
                auxdef.IdTrabajo = IdTrabajo;
                auxdef.IdBulto = IdBulto;
                page.defaults = JSON.stringify(auxdef);
                flexygo.pda.incidencia.preparaIncidencia(e, "IdTrabajo,IdBulto");
            };
            //LECTURA UBICACIÓN DESTINO: Validar el trabajo finalizando
            moverbulto.FinalMoverBulto = (e, CodDetino, modName, ubicSel, pgn) => {
                let CodDestino = $(CodDetino).val();
                let trabajo;
                let modType = "flx-list";
                let module = $(`[modulename=${modName}]${modType}`)[0];
                let modUbicSel = $(`[modulename=${ubicSel}]${modType}`)[0];
                if (module.data.length == 1) {
                    trabajo = module.data[0].Trabajo;
                }
                else {
                    trabajo = 0;
                }
                if (CodDestino != modUbicSel.data[0].IdUbicacion && CodDestino != modUbicSel.data[0].Codigo) {
                    flexygo.msg.warning("Confirme la lectura del campo de Ubicación antes de finalizar el movimiento.");
                    return;
                }
                flexygo.pda.addLock();
                if (modUbicSel.data && modUbicSel.data.length > 0) {
                    let proc = new flexygo.Process('SGA_PDA_dll_MoverBulto_Finalizar', null, null);
                    let params = [
                        { 'Key': 'CodUbicDestino', 'Value': modUbicSel.data[0].Codigo },
                        { 'Key': 'trabajo', 'Value': trabajo }
                    ];
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                flexygo.pda.removeLock();
                            }
                            if (response.LastException && response.LastException.Message) {
                                flexygo.msg.error(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                flexygo.msg.warning(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                flexygo.msg.success(flexygo.localization.translate('pda.procesook'));
                                if (pgn) {
                                    flexygo.nav.openPageName(pgn, '', '', "null", 'main', false);
                                }
                                else {
                                    flexygo.pda.removeLock();
                                    flexygo.nav.execProcess('GoHome', '', '', null, null, 'current', false, e);
                                }
                            }
                        }
                    });
                }
                else {
                    flexygo.msg.warning("Introduzca una ubicación", null, '');
                }
            };
            //LECTURA UBICACIÓN DESTINO: botón Incidencia
            moverbulto.IncidenciaUbicacion = (e) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Propiedades de la lectura
                let pbComboUbicacion = $('flx-dbcombo[name = "pbComboUbicacion"]');
                //si no hay lectura se sale
                if (!pbComboUbicacion.val()) {
                    flexygo.msg.warning("Introduzca una ubicación.");
                    flexygo.pda.setAutomaticFocus(e);
                    return;
                }
                //Valores para la incidencia
                auxdef.IdUbicacion = pbComboUbicacion.val();
                page.defaults = JSON.stringify(auxdef);
                //Lanzamos incidencia
                flexygo.pda.incidencia.preparaIncidencia(e, "IdUbicacion");
            };
        })(moverbulto = pda.moverbulto || (pda.moverbulto = {}));
    })(pda = flexygo.pda || (flexygo.pda = {}));
})(flexygo || (flexygo = {}));
//# sourceMappingURL=moverbulto.js.map