/**
 * @namespace flexygo.pda.picking
 */
var flexygo;
(function (flexygo) {
    var pda;
    (function (pda) {
        var picking;
        (function (picking) {
            //GENÉRICO: El evento OnKeyUp se usa para no lanzar la acción del enter sobre los focos de botón. Es necesario un OnKeyDown sólo para el tabulador
            picking.readKeyTab = (e, funcname, params) => {
                if (e.keyCode == 9) {
                    e.preventDefault();
                    flexygo.pda.picking[funcname].apply(flexygo.pda.picking, params);
                }
                else {
                    return;
                }
            };
            //GENÉRICO: Leer carácter y lanzar función en caso de encontrarlo
            picking.readByCharacter = (e, funcname, params) => {
                if (e.keyCode == 13) {
                    flexygo.pda.picking[funcname].apply(flexygo.pda.picking, params);
                }
                else {
                    return;
                }
            };
            //LEER UBICACIÓN ORIGEN: evento de página para cargar trabajos pendientes
            picking.TrabajosPendientes = (e) => {
                let proc = new flexygo.Process('SGA_PDA_DameTrabajosPickingPendientes', null, null);
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                flexygo.pda.addLock();
                proc.run([], (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.confirm(response.WarningMessage, function (ret) {
                                let auxdef;
                                try {
                                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                                }
                                catch (e) {
                                    auxdef = {};
                                }
                                auxdef.IdUbicacion = response.Data.IdUbicacion;
                                auxdef.CodUbicacion = response.Data.CodUbicacion;
                                auxdef.IdTrabajo = response.Data.IdTrabajo;
                                page.defaults = JSON.stringify(auxdef);
                                if (ret) {
                                    //Cargar la descripción de las propiedades de los detalles del trabajo para mostrarlos en las lecturas
                                    let rellenarPropidades = flexygo.pda.trabajo.RellenarPropiedadesTemp(response.Data.IdTrabajo);
                                    rellenarPropidades.catch(function (error) { if (error && error != "") {
                                        flexygo.msg.warning(error);
                                    } });
                                    flexygo.nav.openPageName('SGA_PDA_pg_MoverPicking_LecturaArticulo', 'SGA_PDA_Ubicacion', `Idalmacen = ${flexygo.context.currentAlmacen} AND IdUbicacion = '${response.Data.IdUbicacion}'`, `{"IdUbicacionOrigen" : "${response.Data.IdUbicacion}","CodigoUbicacionOrigen":"${response.Data.CodUbicacion}","IdTrabajo": ${response.Data.IdTrabajo}, "LecturasLeidas": "3"}`, 'main', false, e);
                                }
                                else {
                                    flexygo.pda.removeLock();
                                    flexygo.pda.picking.UbicacionDestino(e);
                                }
                            });
                        }
                        flexygo.pda.removeLock();
                    }
                });
            };
            //LEER UBICACIÓN ORIGEN. Botón comenzar lectura
            picking.Comenzar = (e, selected) => {
                let module = $(`[modulename=${selected}]flx-list`)[0];
                let idUbicacion = module.data[0].IdUbicacion;
                let codUbic = module.data[0].Codigo;
                if (module.data && module.data.length > 0) {
                    flexygo.nav.openPageName('SGA_PDA_pg_MoverPicking_LecturaArticulo', 'SGA_PDA_Ubicacion', `Idalmacen = ${flexygo.context.currentAlmacen} AND IdUbicacion = '${idUbicacion}'`, `{"IdUbicacionOrigen" : "${idUbicacion}","CodigoUbicacionOrigen":"${codUbic}"}`, 'main', false, e);
                }
                else {
                    flexygo.msg.warning("Selecciona una ubicación de origen");
                }
            };
            //LEER ARTÍCULO PICKING: lectura de artículo para incluir como detalle del movimiento
            picking.LeerArticulo = (item, modName, modType, event) => {
                //Parámetros y campos
                let parametros = $(`.param`);
                let pbCodigo = $('flx-text[name = "pbCodigoArticulo"]');
                let pbCombo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbComboUnidades = $('flx-dbcombo[name = "pbComboUnidades"]');
                let pbCantidadStock = $('flx-text[name = "pbCantidadStock"]');
                let pbUnidadStock = $('flx-text[name = "pbUnidadStock"]');
                let pbStock = $('flx-text[name = "pbStock"]');
                let pbStockUbicacion = $('flx-text[name = "pbStockUbicacion"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                //Valor de búsqueda del campo de texto o del combo
                let valorBusqueda = ((item.tagName).toLowerCase() == "flx-text") ? pbCodigo.val() : pbCombo.val();
                if (!valorBusqueda) {
                    return;
                }
                ;
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Campo que indica si la lectura se ha llevado a cabo
                let read = false;
                //Si ha cambiado el valor del combo. Evitamos lanzar la búsqueda con el mismo valor.
                if (auxdef.valorBusqueda != valorBusqueda) {
                    //En caso de recibir parámetro con longitudes a tener en cuenta, y se trata del campo de texto, se verifica si se ha legeado al tamaño del parámetro
                    read = parametros ? (((item.tagName).toLowerCase() == "flx-text") ? flexygo.pda.readCode(parametros, valorBusqueda, event) : true) : true;
                }
                //Si damos la entrada como buena
                if (read) {
                    flexygo.pda.addLock();
                    let articulo = flexygo.pda.articulo.Buscar(valorBusqueda);
                    articulo.then(function (datos) {
                        //No encontrado
                        if (!datos.IdArticulo) {
                            flexygo.msg.warning("No se ha encontrado ningún artículo.");
                            flexygo.pda.generarbulto.LimpiarCampos();
                            return;
                        }
                        //Módulo con datos del artículo leído
                        let module = $('flx-module')[0];
                        let page = flexygo.history.get(module);
                        let modLectura = $(`[modulename=${modName}]${modType}`)[0];
                        modLectura.additionalWhere = `IdArticulo = '${datos.IdArticulo}'`;
                        modLectura.init();
                        //TRATAMOS LOTES
                        //Si recibimos lote interno lo cargamos y ocultamos el combo
                        if (datos.LoteInterno) {
                            pbLote.val(datos.LoteInterno);
                            pbLote.hide();
                        }
                        //Ocultamos o mostramos combo según artículo
                        if (!datos.RequiereLote) {
                            pbLote.hide();
                        }
                        else {
                            pbLote.show();
                            //si recibimos el lote lo cargamos
                            if (datos.Lote) {
                                pbLote.val(datos.Lote);
                            }
                        }
                        //TRATAMOS PROPIEDADES
                        //Ocultamos/Mostramos los combos y cargamos la propiedad recibida
                        datos.RequiereP1 ? pbComboP1.show() : pbComboP1.hide();
                        datos.RequiereP2 ? pbComboP2.show() : pbComboP2.hide();
                        if (datos.P1) {
                            pbComboP1.val(datos.P1);
                        }
                        ;
                        if (datos.P2) {
                            pbComboP2.val(datos.P2);
                        }
                        ;
                        //Valores de campos de búsqueda
                        if ((item.tagName).toLowerCase() == "flx-dbcombo") {
                            //Evento lanzado por el combo, se pone en el código el CodBarras asociado o IdArticulo si no tiene código
                            valorBusqueda = datos.IdArticulo;
                            pbCodigo.val(valorBusqueda);
                        }
                        else {
                            //Evento lanzado por el campo de texto, se establece el ID en el combo
                            pbCombo.val(datos.IdArticulo);
                        }
                        //Valor de búsqueda para no repetir acción si no cambia
                        auxdef.valorBusqueda = valorBusqueda;
                        page.defaults = JSON.stringify(auxdef);
                        //Se recupera el valor por defecto del tipo de unidad de artículo
                        let tipoUnidad = flexygo.pda.articulo.TipoUnidad(datos.IdArticulo, pbLote.val() ? pbLote.val() : "");
                        tipoUnidad.then(function (tipo) {
                            //Tipos de Unidades del artículo para conversiones
                            pbComboUnidades[0].additionalWhere = `IdArticulo = '${datos.IdArticulo}'`;
                            pbComboUnidades[0].refresh();
                            pbComboUnidades[0].querySelector("input").disabled = false;
                            if (tipo) {
                                pbComboUnidades.val(tipo);
                                pbUnidadStock.val(tipo);
                                pbCantidadStock.val(null);
                            }
                        });
                        tipoUnidad.catch(function (error) {
                            if (error && error != "") {
                                flexygo.msg.warning(error);
                                return;
                            }
                        });
                        //Cargar el stock. También devuelve el lote y las propiedades en caso de devolver un sólo registro de stock en la ubicación
                        let obtenerStock = flexygo.pda.ubicacion.ObtenerStock(datos.IdArticulo, pbLote.val(), pbComboP1.val(), pbComboP2.val(), auxdef.IdUbicacionOrigen);
                        obtenerStock.then(function (stock) {
                            if (stock) {
                                //Devuelve un único lote
                                if (stock.lote) {
                                    pbLote.val(stock.lote);
                                }
                                //Devuelve una única P1
                                if (stock.p1) {
                                    pbComboP1.val(stock.p1);
                                }
                                //Devuelve una única P2
                                if (stock.p2) {
                                    pbComboP2.val(stock.p2);
                                }
                                //Devuelve stock
                                if (stock.stock) {
                                    pbStockUbicacion.val(stock.stock);
                                }
                                //Focos
                                if (pbLote.attr("style") != 'display: none;' && !pbLote.val()) {
                                    pbLote[0].querySelector("input").focus();
                                }
                                else if (pbComboP1.attr("style") != 'display: none;' && !pbComboP1.val()) {
                                    pbComboP1[0].querySelector("input").focus();
                                }
                                else if (pbComboP2.attr("style") != 'display: none;' && !pbComboP2.val()) {
                                    pbComboP2[0].querySelector("input").focus();
                                }
                                else {
                                    pbCantidad[0].querySelector("input").focus();
                                }
                            }
                        });
                        obtenerStock.catch(function (error) { if (error && error != "") {
                            flexygo.msg.warning(error);
                        } });
                    });
                    articulo.catch(function (error) {
                        if (error && error != "") {
                            flexygo.msg.warning(error);
                            return;
                        }
                    });
                    flexygo.pda.removeLock();
                }
            };
            //LEER ARTÍCULO PICKING: combo de lotes. Efecto de pérdida de foco
            picking.LeerLote = (item, event) => {
                //Parámetros y campos
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbStockUbicacion = $('flx-text[name = "pbStockUbicacion"]');
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Unidad del combo
                let lote = pbComboLote.val() ? pbComboLote.val() : ($('flx-dbcombo[name = "pbComboLote"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboLote"] li.selected')[0].dataset.value : null);
                flexygo.pda.addLock();
                //Cargar el stock. También devuelve el lote y las propiedades en caso de devolver un sólo registro de stock en la ubicación
                let lectura = flexygo.pda.ubicacion.ObtenerStock(pbComboArticulo.val(), lote, pbComboP1.val(), pbComboP2.val(), auxdef.IdUbicacionOrigen);
                lectura.then(function (stock) {
                    if (stock) {
                        //Devuelve una única P1
                        if (stock.p1) {
                            pbComboP1.val(stock.p1);
                        }
                        //Devuelve una única P2
                        if (stock.p2) {
                            pbComboP2.val(stock.p2);
                        }
                        //Devuelve stock
                        if (stock.stock) {
                            pbStockUbicacion.val(stock.stock);
                        }
                        //Focos
                        if (pbComboLote.attr("style") != 'display: none;' && !pbComboLote.val()) {
                            pbComboLote[0].querySelector("input").focus();
                        }
                        else if (pbComboP1.attr("style") != 'display: none;' && !pbComboP1.val()) {
                            pbComboP1[0].querySelector("input").focus();
                        }
                        else if (pbComboP2.attr("style") != 'display: none;' && !pbComboP2.val()) {
                            pbComboP2[0].querySelector("input").focus();
                        }
                        else {
                            pbCantidad[0].querySelector("input").focus();
                        }
                    }
                    flexygo.pda.removeLock();
                });
                lectura.catch(function (error) { if (error && error != "") {
                    flexygo.msg.warning(error);
                } });
            };
            //LEER ARTÍCULO PICKING: combo de propiedades. Efecto de pérdida de foco
            picking.LeerPropiedad = (item, event) => {
                //Parámetros y campos
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbStockUbicacion = $('flx-text[name = "pbStockUbicacion"]');
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                flexygo.pda.addLock();
                let P1 = pbComboP1.val() ? pbComboP1.val() : ($('flx-dbcombo[name = "pbComboP1"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboP1"] li.selected')[0].dataset.value : null);
                let P2 = pbComboP2.val() ? pbComboP2.val() : ($('flx-dbcombo[name = "pbComboP2"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboP2"] li.selected')[0].dataset.value : null);
                //Cargar el stock. También devuelve el lote y las propiedades en caso de devolver un sólo registro de stock en la ubicación
                let lectura = flexygo.pda.ubicacion.ObtenerStock(pbComboArticulo.val(), pbComboLote.val(), P1, P2, auxdef.IdUbicacionOrigen);
                lectura.then(function (stock) {
                    if (stock) {
                        //Devuelve stock
                        if (stock.stock) {
                            pbStockUbicacion.val(stock.stock);
                        }
                        //Focos
                        if (pbComboLote.attr("style") != 'display: none;' && !pbComboLote.val()) {
                            pbComboLote[0].querySelector("input").focus();
                        }
                        else if (pbComboP1.attr("style") != 'display: none;' && !pbComboP1.val()) {
                            pbComboP1[0].querySelector("input").focus();
                        }
                        else if (pbComboP2.attr("style") != 'display: none;' && !pbComboP2.val()) {
                            pbComboP2[0].querySelector("input").focus();
                        }
                        else {
                            pbCantidad[0].querySelector("input").focus();
                        }
                    }
                    flexygo.pda.removeLock();
                });
                lectura.catch(function (error) { if (error && error != "") {
                    flexygo.msg.warning(error);
                } });
            };
            //LEER ARTÍCULO PICKING: introducción de cantidad leída y unidad de lectura
            picking.LeerCantidad = (item, event) => {
                //Parámetros y campos
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboEmbalaje = $('flx-dbcombo[name = "pbComboEmbalaje"]');
                let pbComboUnidades = $('flx-dbcombo[name = "pbComboUnidades"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbCantidadStock = $('flx-text[name = "pbCantidadStock"]');
                //Unidad del combo
                let UnidadLectura = pbComboUnidades.val() ? pbComboUnidades.val() : ($('flx-dbcombo[name = "pbComboUnidades"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboUnidades"] li.selected')[0].dataset.value : null);
                flexygo.pda.addLock();
                //Conversión de unidades
                let lectura = flexygo.pda.articulo.ConvertirUnidades(pbComboArticulo.val(), pbComboLote.val(), pbComboEmbalaje.val(), UnidadLectura, pbCantidad.val() ? pbCantidad.val() : 0);
                lectura.then(function (datos) {
                    if (datos) {
                        pbCantidadStock.val(datos.Cantidad_Stock);
                        $('#btnConfirmar').focus();
                    }
                    flexygo.pda.removeLock();
                });
                lectura.catch(function (error) { if (error && error != "") {
                    flexygo.msg.warning(error);
                } });
            };
            //LEER ARTÍCULO PICKING: limpieza de campos de la pantalla principal de lectura de artículo
            picking.LimpiarCampos = () => {
                //Campos de artículo
                $("#CodBarras").val(null);
                $("#cboArticulos").val(null);
                //Módulo artículo seleccionado
                let modRefresh = $(`[modulename=SGA_PDA_m_ArticuloSeleccionado]flx-list`)[0];
                modRefresh.additionalWhere = "1 = 0";
                modRefresh.init();
                //Campos de proveedor
                $("#loteProv").val(null);
                $('#loteProv').hide();
                //Combos Propiedades
                $('#cboP1').hide();
                $('#cboP1').val(null);
                $('#cboP2').hide();
                $('#cboP2').val(null);
                //Campos de cantidades y tipos de unidad
                $("#cantidad").val(null);
                $("#cboUnidades").val(null);
                $("#cantidadStock").val(null);
                $("#unidadStock").val(null);
                $("#stock").val(null);
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                auxdef.valorBusqueda = "";
                page.defaults = JSON.stringify(auxdef);
                //Contador
                flexygo.pda.loadBadgeValue($('#badge'), 'IdDocDetalle', 'VPDA_Picking_Entrada_Detalle', 'IdTrabajoAlm', 'IdTrabajo');
                //Foco
                $("#CodBarras")[0].querySelector("input").focus();
            };
            //LEER ARTÍCULO PICKING: botón confirmar la lectura del artículo
            picking.ConfirmarArticulo = (e) => {
                //Parámetros y campos
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                //Validaciones
                if (!pbCantidad.val()) {
                    flexygo.msg.warning("Cantidad incorrecta");
                    return;
                }
                if (!pbComboArticulo.val()) {
                    flexygo.msg.warning("Articulo no encontrado");
                    return;
                }
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                let CodigoUbicacionOrigen = JSON.parse(page.defaults).CodigoUbicacionOrigen;
                let IdTrabajo = JSON.parse(page.defaults).IdTrabajo ? JSON.parse(page.defaults).IdTrabajo : 0;
                flexygo.pda.addLock();
                let proc = new flexygo.Process('SGA_PDA_dll_ValidarEntradaPicking', null, null);
                let params = [
                    { 'Key': 'IdTrabajo', 'Value': IdTrabajo },
                    { 'Key': 'IdArticulo', 'Value': pbComboArticulo.val() },
                    { "Key": "CodBarras", "Value": '' },
                    { 'Key': 'Cantidad', 'Value': Number(pbCantidad.val()) },
                    { 'Key': 'CodUbicacion', 'Value': CodigoUbicacionOrigen },
                    { 'Key': 'Lote', 'Value': pbComboLote.val() ? pbComboLote.val() : '' },
                    { 'Key': 'CheckStockDisponible', 'Value': true },
                    { 'Key': 'P1', 'Value': pbComboP1.val() ? pbComboP1.val() : '' },
                    { 'Key': 'P2', 'Value': pbComboP2.val() ? pbComboP2.val() : '' }
                ];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            //No hay stock, se pregunta si se quiere regularizar
                            flexygo.msg.confirm(response.WarningMessage, function (ret) {
                                if (ret) {
                                    let params = [
                                        { 'Key': 'IdTrabajo', 'Value': IdTrabajo },
                                        { 'Key': 'IdArticulo', 'Value': pbComboArticulo.val() },
                                        { "Key": "CodBarras", "Value": '' },
                                        { 'Key': 'Cantidad', 'Value': Number(pbCantidad.val()) },
                                        { 'Key': 'CodUbicacion', 'Value': CodigoUbicacionOrigen },
                                        { 'Key': 'Lote', 'Value': pbComboLote.val() ? pbComboLote.val() : '' },
                                        { 'Key': 'CheckStockDisponible', 'Value': false },
                                        { 'Key': 'P1', 'Value': pbComboP1.val() ? pbComboP1.val() : '' },
                                        { 'Key': 'P2', 'Value': pbComboP2.val() ? pbComboP2.val() : '' }
                                    ];
                                    proc.run(params, (response) => {
                                        if (response) {
                                            if (response.JSCode) {
                                                var func = new Function(response.JSCode);
                                                func.call(response.JSCode);
                                                flexygo.pda.removeLock();
                                            }
                                            if (response.LastException && response.LastException.Message) {
                                                flexygo.msg.error(response.LastException.Message);
                                            }
                                            else if (response.WarningMessage) {
                                                flexygo.msg.warning(response.WarningMessage);
                                            }
                                            else if (response.SuccessMessage) {
                                                auxdef.IdTrabajo = response.Data.IdTrabajo;
                                                auxdef.IdDocDetalle = response.Data.IdDocDetalle;
                                                page.defaults = JSON.stringify(auxdef);
                                                flexygo.pda.picking.LimpiarCampos();
                                                flexygo.pda.removeLock();
                                            }
                                        }
                                    });
                                }
                            });
                        }
                        else if (response.SuccessMessage) {
                            auxdef.IdTrabajo = response.Data.IdTrabajo;
                            auxdef.IdDocDetalle = response.Data.IdDocDetalle;
                            page.defaults = JSON.stringify(auxdef);
                            flexygo.pda.picking.LimpiarCampos();
                            flexygo.pda.removeLock();
                        }
                    }
                });
            };
            //LEER ARTÍCULO PICKING: botón finalizar lecturas y pedir ubicación destino
            picking.UbicacionDestino = (e) => {
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let proc = new flexygo.Process('SGA_PDA_dll_MoverPicking_ProximoDetalleTrabajo', null, null);
                let idTrabajo = JSON.parse(page.defaults).IdTrabajo ? JSON.parse(page.defaults).IdTrabajo : 0;
                if (idTrabajo == 0) {
                    flexygo.msg.success("No hay trabajo para finalizar.");
                    flexygo.nav.execProcess('GoHome', '', '', null, null, 'current', false, e);
                }
                else {
                    flexygo.pda.addLock();
                    let params = [{ 'Key': 'IdTrabajo', 'Value': idTrabajo }];
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                flexygo.pda.removeLock();
                            }
                            if (response.LastException && response.LastException.Message) {
                                flexygo.msg.error(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                flexygo.msg.warning(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                let auxdef;
                                try {
                                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                                }
                                catch (e) {
                                    auxdef = {};
                                }
                                auxdef.IdDocDetalle = response.Data.IdDocDetalle;
                                page.defaults = JSON.stringify(auxdef);
                                flexygo.nav.openPageName('SGA_PDA_pg_MoverPicking_LecturaUbicacionDestino', 'SGA_PDA_Picking_Entrada_Detalle', `IdTrabajoAlm=${JSON.parse(page.defaults).IdTrabajo} AND IdDocDetalle = ${JSON.parse(page.defaults).IdDocDetalle}`, page.defaults, 'main', true, e);
                            }
                        }
                    });
                }
            };
            //UBICACIÓN DESTINO DETALLE: Botón Conf. valida si la ubicación introducida es la propuesta
            picking.ComprobarConfirmarDetalleEntrada = (e, selected) => {
                //Módulo con la información de la ubicación leída
                let modSelected = $(`[modulename=${selected}]flx-list`)[0];
                //Si tiene datos se valida ubicaciones
                if (modSelected.data && modSelected.data.length > 0) {
                    //Defaults de la página
                    let myModule = $('flx-module')[0];
                    let page = flexygo.history.get(myModule);
                    let auxdef;
                    try {
                        auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                    }
                    catch (e) {
                        auxdef = {};
                    }
                    //Siempre debería existir los valores, pero se valida por si acaso
                    if (!auxdef.IdTrabajo || !auxdef.IdDocDetalle) {
                        flexygo.msg.error("Se ha perdido la información del trabajo");
                        return;
                    }
                    //Leemos la ubicación propuesta del detalle
                    let Detalle = new flexygo.obj.Entity(`SGA_PDA_Picking_Entrada_Detalle`, `IdTrabajoAlm = ${auxdef.IdTrabajo} AND IdDocDetalle = ${auxdef.IdDocDetalle}`);
                    Detalle.read();
                    if (modSelected.data[0].IdUbicacion != Detalle.data.IdUbicacionDestino.Value) {
                        flexygo.msg.confirm("La ubicación no coincide ¿Desea continuar?", function (ret) {
                            if (!ret) {
                                modSelected.refresh();
                                modSelected.additionalWhere = "1 = 0";
                                modSelected.refresh();
                            }
                            else {
                                flexygo.pda.picking.ConfirmarDetalleEntrada(e, modSelected.data[0].Codigo, page, modSelected);
                            }
                        });
                    }
                    else {
                        flexygo.pda.picking.ConfirmarDetalleEntrada(e, Detalle.data.CodigoUbicacionDestino.Value, page, modSelected);
                    }
                }
                else {
                    flexygo.msg.warning("Selecciona una ubicación de destino");
                }
            };
            //UBICACIÓN DESTINO DETALLE: tras validar que la ubicación propuesta coincide con la leída, se lanza la confirmación del detalle
            picking.ConfirmarDetalleEntrada = (e, codUbic, page, modSelected) => {
                let IdDocDetalle = JSON.parse(page.defaults).IdDocDetalle ? JSON.parse(page.defaults).IdDocDetalle : 0;
                flexygo.pda.addLock();
                let proc = new flexygo.Process('SGA_PDA_dll_MoverPicking_ConfirmarDetalle_Entrada', null, null);
                let params = [{ 'Key': 'IdDocDetalle', 'Value': IdDocDetalle }, { "Key": "CodUbicacion", "Value": codUbic }];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                        else if (response.SuccessMessage) {
                            if (response.Data.Disponible == 0) {
                                flexygo.msg.confirm("Ubicación no está disponible según el sistema ¿Deseas continuar?", function (ret) {
                                    if (ret) {
                                        let auxdef;
                                        try {
                                            auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                                        }
                                        catch (e) {
                                            auxdef = {};
                                        }
                                        auxdef.CodUbicacionDestino = codUbic;
                                        page.defaults = JSON.stringify(auxdef);
                                        //TODO: PDA - OJO CUIDAO QUE FALTA EL CALCULOCAJAS POR SABER
                                        flexygo.nav.openPageName('SGA_PDA_pg_MoverPicking_ConfirmarPicking', 'SGA_PDA_Picking_Entrada_Detalle', `IdTrabajoAlm=${JSON.parse(page.defaults).IdTrabajo} AND IdDocDetalle = ${JSON.parse(page.defaults).IdDocDetalle}`, page.defaults, 'main', true, e);
                                    }
                                    else {
                                        modSelected.refresh();
                                        modSelected.additionalWhere = "1 = 0";
                                        modSelected.selected();
                                    }
                                });
                            }
                            else {
                                let auxdef;
                                try {
                                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                                }
                                catch (e) {
                                    auxdef = {};
                                }
                                auxdef.CodUbicacionDestino = codUbic;
                                page.defaults = JSON.stringify(auxdef);
                                //TODO: PDA - OJO CUIDAO QUE FALTA EL CALCULOCAJAS POR SABER
                                flexygo.nav.openPageName('SGA_PDA_pg_MoverPicking_ConfirmarPicking', 'SGA_PDA_Picking_Entrada_Detalle', `IdTrabajoAlm=${JSON.parse(page.defaults).IdTrabajo} AND IdDocDetalle = ${JSON.parse(page.defaults).IdDocDetalle}`, page.defaults, 'main', true, e);
                            }
                        }
                        flexygo.pda.removeLock();
                    }
                });
            };
            //UBICACIÓN DESTINO DETALLE: Botón Fin. Finaliza el trabajo de picking
            picking.Finalizar = (e) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Detalle del trabajo
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                flexygo.pda.addLock();
                let proc = new flexygo.Process('SGA_PDA_dll_MoverPicking_FinalizarPicking', null, null);
                let params = [{ "Key": "IdDocDetalle", "Value": IdDocDetalle }];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                        else if (response.SuccessMessage) {
                            flexygo.msg.success("Trabajo finalizado", null, null);
                            flexygo.nav.openPageName('syspage-generic-controlpanel', '', '', null, 'main', false, null);
                        }
                    }
                    flexygo.pda.removeLock();
                });
            };
            //UBICACIÓN DESTINO DETALLE: Botón Nª Ubic. Busca nueva ubicación propuesta para el trabajo
            picking.NuevaUbicacion = (e, refresh) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Detalle del trabajo
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                flexygo.pda.addLock();
                let proc = new flexygo.Process('SGA_PDA_dll_MoverPicking_BuscaNuevaUbicacion', null, null);
                let params = [{ "Key": "IdDocDetalle", "Value": IdDocDetalle }];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                        else if (response.SuccessMessage) {
                            //Si recibimos Detalle = 0 es que se ha actualizado la ubic del existente
                            auxdef.IdDocDetalle = response.Data.NuevoIdDocDetalle == 0 ? auxdef.IdDocDetalle : response.Data.NuevoIdDocDetalle;
                            page.defaults = JSON.stringify(auxdef);
                            let modRefresh = $(`[modulename=${refresh}]`)[0];
                            modRefresh.refresh();
                            flexygo.pda.removeLock();
                        }
                    }
                });
            };
            //UBICACIÓN DESTINO DETALLE: Botón Sig. Carga el siguiente detalle del trabajo
            picking.SiguienteDetalle = (e) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Detalle del trabajo
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                let oldIdDoc = IdDocDetalle;
                flexygo.pda.addLock();
                let proc = new flexygo.Process('SGA_PDA_dll_MoverPicking_ProximoDetalle_Entrada', null, null);
                let params = [{ 'Key': 'IdDocDetalle', 'Value': IdDocDetalle }];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                        else if (response.SuccessMessage) {
                            auxdef.IdDocDetalle = response.Data.IdDocDetalle;
                            page.defaults = JSON.stringify(auxdef);
                            if (oldIdDoc == JSON.parse(page.defaults).IdDocDetalle) {
                                flexygo.msg.warning("Es la última entrada de picking");
                            }
                            else {
                                flexygo.nav.openPageName('SGA_PDA_pg_MoverPicking_LecturaUbicacionDestino', 'SGA_PDA_Picking_Entrada_Detalle', `IdTrabajoAlm=${JSON.parse(page.defaults).IdTrabajo} AND IdDocDetalle = ${JSON.parse(page.defaults).IdDocDetalle}`, page.defaults, 'main', true, e);
                            }
                        }
                    }
                });
            };
            //CONFIRMAR PICKING: confirmación final del detalle de picking
            picking.confirmarPickingDestino = (e) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Detalle del trabajo
                let codUbicacion = auxdef.CodUbicacionDestino ? auxdef.CodUbicacionDestino : "";
                let idTrabajo = auxdef.IdTrabajo ? auxdef.IdTrabajo : 0;
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                let oldIdDoc = IdDocDetalle;
                flexygo.pda.addLock();
                //Leemos más datos del detalle
                let Detalle = new flexygo.obj.Entity(`SGA_PDA_Picking_Entrada_Detalle`, `IdTrabajoAlm = ${auxdef.IdTrabajo} AND IdDocDetalle = ${auxdef.IdDocDetalle}`);
                Detalle.read();
                //Lanzamos proceso
                let proc = new flexygo.Process('SGA_PDA_dll_MoverPicking_ConfirmarLecturaPickingDestino', null, null);
                let params = [
                    { "Key": "IdDocDetalle", "Value": IdDocDetalle },
                    { "Key": "CodUbicLectura", "Value": codUbicacion },
                    { "Key": "ArticuloBultoLectura", "Value": Detalle.data.Articulo.Value ? Detalle.data.Articulo.Value : '' },
                    { "Key": "LoteLectura", "Value": Detalle.data.LoteLectura.Value ? Detalle.data.LoteLectura.Value : '' },
                    { "Key": "CantidadLectura", "Value": Detalle.data.CantidadLectura.Value ? parseFloat(Detalle.data.CantidadLectura.Value) : 0 },
                    { "Key": "IdEmbalaje", "Value": "" },
                    { "Key": "Idtrabajo", "Value": idTrabajo }
                ];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                        else if (response.SuccessMessage) {
                            auxdef.IdDocDetalle = response.Data.IdDocDetalle;
                            page.defaults = JSON.stringify(auxdef);
                            if ((oldIdDoc == auxdef.IdDocDetalle || auxdef.IdDocDetalle == 0)) {
                                flexygo.msg.success("Trabajo realizado con éxito", null, null);
                                flexygo.nav.execProcess('GoHome', '', '', null, null, 'current', false, e);
                            }
                            else {
                                flexygo.nav.openPageName('SGA_PDA_pg_MoverPicking_LecturaUbicacionDestino', 'SGA_PDA_Picking_Entrada_Detalle', `IdTrabajoAlm=${JSON.parse(page.defaults).IdTrabajo} AND IdDocDetalle = ${JSON.parse(page.defaults).IdDocDetalle}`, page.defaults, 'main', true, e);
                            }
                        }
                    }
                });
            };
        })(picking = pda.picking || (pda.picking = {}));
    })(pda = flexygo.pda || (flexygo.pda = {}));
})(flexygo || (flexygo = {}));
//# sourceMappingURL=picking.js.map