var flexygo;
(function (flexygo) {
    var pda;
    (function (pda) {
        var preparacion;
        (function (preparacion) {
            //GENÉRICO: El evento OnKeyUp se usa para no lanzar la acción del enter sobre los focos de botón. Es necesario un OnKeyDown sólo para el tabulador
            preparacion.readKeyTab = (e, funcname, params) => {
                if (e.keyCode == 9) {
                    e.preventDefault();
                    flexygo.pda.preparacion[funcname].apply(flexygo.pda.preparacion, params);
                }
                else {
                    return;
                }
            };
            //GENÉRICO: Leer carácter y lanzar función en caso de encontrarlo
            preparacion.readByCharacter = (e, funcname, params) => {
                if (e.keyCode == 13) {
                    flexygo.pda.preparacion[funcname].apply(flexygo.pda.preparacion, params);
                }
                else {
                    return;
                }
            };
            //LISTA OC: Botón comenzar tras selección de órden de carga
            //          Llamadas varias a Comenzar (continuar tras una finalización previa) en flujo estándar de preparaciones.
            preparacion.Comenzar = (e, IdOrdenLect, IdDocDetalleLect, Seleccionado, IdTrabajoAlm) => {
                let pgn;
                let IdOrden = IdOrdenLect;
                let proc;
                let params;
                if (Seleccionado) {
                    proc = new flexygo.Process('SGA_PDA_dll_Preparacion_Comenzar', null, null);
                    params = [
                        { 'Key': 'IdOrden', 'Value': IdOrden },
                        { 'Key': 'IdDocDetalle', 'Value': IdDocDetalleLect }
                    ];
                }
                else {
                    proc = new flexygo.Process('SGA_PDA_dll_Preparacion_Continuar', null, null);
                    params = [
                        { 'Key': 'IdOrden', 'Value': IdOrden },
                        { 'Key': 'IdDocDetalle', 'Value': IdDocDetalleLect },
                        { 'Key': 'IdTrabajo', 'Value': IdTrabajoAlm ? IdTrabajoAlm : 0 }
                    ];
                }
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                if (IdOrden) {
                    flexygo.pda.addLock();
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                flexygo.pda.removeLock();
                            }
                            if (response.LastException && response.LastException.Message) {
                                flexygo.msg.error(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                flexygo.msg.warning(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                let auxdef;
                                try {
                                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                                }
                                catch (e) {
                                    auxdef = {};
                                }
                                auxdef.IdOrden = IdOrden;
                                auxdef.IdTrabajo = response.Data.IdTrabajo;
                                auxdef.IdDocDetalle = response.Data.IdDocDetalle;
                                auxdef.EsBulto = response.Data.EsBulto;
                                auxdef.BultoPicking = response.Data.IdBultoPicking;
                                auxdef.Estado = response.Data.IdEstado;
                                page.defaults = JSON.stringify(auxdef);
                                if (!Seleccionado && response.Data.IdDocDetalle == 0) {
                                    flexygo.msg.success("No existen más trabajos para esta orden.", null, null);
                                    flexygo.nav.openPageName('PDA_pg_Preparaciones', '', '', page.defaults, 'current', false);
                                }
                                else {
                                    let proc = new flexygo.Process('SGA_PDA_dll_Preparacion_Total', null, null);
                                    let params = [{ 'Key': 'IdOrden', 'Value': IdOrden }];
                                    proc.run(params, (response) => {
                                        if (response) {
                                            if (response.JSCode) {
                                                var func = new Function(response.JSCode);
                                                func.call(response.JSCode);
                                                flexygo.pda.removeLock();
                                            }
                                            if (response.LastException && response.LastException.Message) {
                                                flexygo.msg.error(response.LastException.Message);
                                            }
                                            else if (response.WarningMessage) {
                                                flexygo.msg.warning(response.WarningMessage);
                                            }
                                            else if (response.SuccessMessage) {
                                                if (response.Data.Cuenta > 1 && IdDocDetalleLect == 0) {
                                                    //varios trabajos para la misma orden
                                                    flexygo.nav.openPageName('PDA_pg_Preparaciones_por_Orden', '', `OrdenCarga = ${IdOrden}`, page.defaults, 'current', false);
                                                }
                                                else {
                                                    //picking
                                                    if (auxdef.Estado == 0 && !auxdef.EsBulto && auxdef.BultoPicking == 0) {
                                                        //cargar primero el bulto de picking si hay
                                                        let proc = new flexygo.Process('SGA_PDA_dll_VPDA_Bulto_Picking', null, null);
                                                        let params = [{ 'Key': 'IdTrabajoAlm', 'Value': auxdef.IdTrabajo }];
                                                        proc.run(params, (response) => {
                                                            if (response) {
                                                                if (response.JSCode) {
                                                                    var func = new Function(response.JSCode);
                                                                    func.call(response.JSCode);
                                                                    flexygo.pda.removeLock();
                                                                }
                                                                if (response.LastException && response.LastException.Message) {
                                                                    flexygo.msg.error(response.LastException.Message);
                                                                }
                                                                else if (response.WarningMessage) {
                                                                    flexygo.msg.warning(response.WarningMessage);
                                                                }
                                                                else if (response.SuccessMessage) {
                                                                    auxdef.CodBultoPicking = response.Data.CodBulto;
                                                                    auxdef.IdBultoPicking = response.Data.IdBulto;
                                                                    auxdef.IdEmbalaje = response.Data.IdEmbalaje;
                                                                    auxdef.DescripEmbalaje = response.Data.DescripEmbalaje;
                                                                    page.defaults = JSON.stringify(auxdef);
                                                                    let rellenarPropidades = flexygo.pda.trabajo.RellenarPropiedadesTemp(auxdef.IdTrabajo);
                                                                    rellenarPropidades.catch(function (error) { if (error && error != "") {
                                                                        flexygo.msg.warning(error);
                                                                    } });
                                                                    rellenarPropidades.then(function (error) {
                                                                        flexygo.nav.openPageName('PDA_pg_Preparacion_Picking_1', '', '', page.defaults, 'current', false);
                                                                    });
                                                                }
                                                            }
                                                        });
                                                    }
                                                    else if (auxdef.Estado == 0 && auxdef.EsBulto) {
                                                        //Comenzando la preparación del bulto
                                                        flexygo.nav.openPageName('PDA_pg_Preparacion_Detalles_1', '', `IdOrden = ${IdOrden} AND IdTrabajoAlm = ${auxdef.IdTrabajo}`, page.defaults, 'current', false);
                                                    }
                                                    else if (auxdef.Estado == 2 && auxdef.EsBulto) {
                                                        flexygo.nav.openPageName('PDA_pg_Preparacion_Detalles_3', 'SGA_PDA_Trabajos_Almacen_Detalle', 'IdDocDetalle = ' + auxdef.IdDocDetalle, page.defaults, 'current', false);
                                                    }
                                                    else if (auxdef.Estado == 2 && !auxdef.EsBulto) {
                                                        flexygo.pda.removeLock();
                                                        if (auxdef.IdDocDetalle == -1) {
                                                            flexygo.pda.preparacion.FinalizarTrabajoPicking(e);
                                                        }
                                                        else {
                                                            //OJO AQUI POSIBLE BUCLE INFINITO, EN LA ESTANDAR ESTA IGUAL
                                                            flexygo.pda.preparacion.Comenzar(e, IdOrden, auxdef.IdDocDetalle, false, 0);
                                                        }
                                                    }
                                                    else if (auxdef.Estado == 0 && !auxdef.EsBulto && !auxdef.LineasPickingMostradas) {
                                                        let rellenarPropidades = flexygo.pda.trabajo.RellenarPropiedadesTemp(auxdef.IdTrabajo);
                                                        rellenarPropidades.catch(function (error) { if (error && error != "") {
                                                            flexygo.msg.warning(error);
                                                        } });
                                                        rellenarPropidades.then(function (error) {
                                                            flexygo.nav.openPageName('PDA_pg_Preparacion_Picking_2', 'SGA_PDA_Trabajos_Almacen', 'IdTrabajoAlm = ' + auxdef.IdTrabajo, page.defaults, 'current', false);
                                                        });
                                                    }
                                                    else if (auxdef.Estado == 0 && !auxdef.EsBulto && auxdef.LineasPickingMostradas) {
                                                        let rellenarPropidades = flexygo.pda.trabajo.RellenarPropiedadesTemp(auxdef.IdTrabajo);
                                                        rellenarPropidades.catch(function (error) { if (error && error != "") {
                                                            flexygo.msg.warning(error);
                                                        } });
                                                        rellenarPropidades.then(function (error) {
                                                            flexygo.nav.openPageName('PDA_pg_Preparacion_Picking_3', 'SGA_PDA_Trabajos_Almacen', 'IdTrabajoAlm = ' + auxdef.IdTrabajo + ' AND IdDocDetalle = ' + auxdef.IdDocDetalle, page.defaults, 'current', false);
                                                        });
                                                    }
                                                    else if (response.Data.Cuenta > 0 && IdDocDetalleLect !== 0 && auxdef.Estado == 1 && !auxdef.EsBulto) {
                                                        let rellenarPropidades = flexygo.pda.trabajo.RellenarPropiedadesTemp(auxdef.IdTrabajo);
                                                        rellenarPropidades.catch(function (error) { if (error && error != "") {
                                                            flexygo.msg.warning(error);
                                                        } });
                                                        rellenarPropidades.then(function (error) {
                                                            flexygo.nav.openPageName('PDA_pg_Preparacion_Picking_2', 'SGA_PDA_Trabajos_Almacen', 'IdTrabajoAlm = ' + auxdef.IdTrabajo, page.defaults, 'current', false);
                                                        });
                                                    }
                                                }
                                            }
                                        }
                                    });
                                }
                            }
                        }
                    });
                }
                else {
                    flexygo.msg.warning("No se ha seleccionado registro", null, '');
                }
            };
            //BULTO - UBICACIÓN ORIGEN: Botón confirmar ubicación
            preparacion.ConfirmarUbicacionOrigenBulto = (e, CodUbicLect, IdUbicLect, modname, pgn) => {
                let module2 = $(`[modulename=${modname}]flx-list`)[0];
                let CodUbic = $(CodUbicLect).val();
                let CodUbicDoc = module2.data[0].CodigoUbicacion;
                let IdBulto = module2.data[0].IdBulto;
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                if (CodUbic && CodUbicDoc) {
                    let auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                    if (CodUbic != CodUbicDoc) {
                        flexygo.msg.confirm('La ubicación indicada no coincide con la del trabajo. ¿Desea continuar?', function (ret) {
                            if (ret) {
                                auxdef.UbicacionLectura = CodUbic;
                                auxdef.UbicacionTrabajo = CodUbicDoc;
                                page.defaults = JSON.stringify(auxdef);
                                flexygo.nav.openPageName(pgn, 'SGA_PDA_Bulto', 'IdBulto = ' + IdBulto, page.defaults, 'current', false);
                            }
                            else {
                                flexygo.pda.ubicacion.LimpiarUbicacion();
                            }
                        });
                    }
                    else {
                        auxdef.UbicacionLectura = CodUbic;
                        auxdef.UbicacionTrabajo = CodUbicDoc;
                        page.defaults = JSON.stringify(auxdef);
                        flexygo.nav.openPageName(pgn, 'SGA_PDA_Bulto', 'IdBulto = ' + IdBulto, page.defaults, 'current', false);
                    }
                }
                else {
                    flexygo.msg.warning("Indique Ubicación");
                    CodUbicLect[0].querySelector('input').focus();
                    CodUbicLect[0].querySelector('input').select();
                }
            };
            //BULTO - BULTO: Botón confirmar bulto
            preparacion.ConfirmarBulto = (e, CodBultoLect, IdBultoLect, modname, pgn) => {
                let module2 = $(`[modulename=${modname}]flx-list`)[0];
                let CodBulto = $(CodBultoLect).val();
                let CodBultoDoc = module2.data[0].CodBarras1;
                let IdBultoDoc = module2.data[0].IdBulto;
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let proc = new flexygo.Process('SGA_PDA_dll_Bulto_CoincideContenido', null, null);
                let IdDocDetalle = JSON.parse(page.defaults).IdDocDetalle ? JSON.parse(page.defaults).IdDocDetalle : 0;
                let UbicacionLectura = JSON.parse(page.defaults).UbicacionLectura ? JSON.parse(page.defaults).UbicacionLectura : "";
                let UbicacionTrabajo = JSON.parse(page.defaults).UbicacionTrabajo ? JSON.parse(page.defaults).UbicacionTrabajo : "";
                let idTrabajo = JSON.parse(page.defaults).IdTrabajo ? JSON.parse(page.defaults).IdTrabajo : 0;
                let oldIdDoc = IdDocDetalle;
                let Coincideubicacion = UbicacionLectura == UbicacionTrabajo ? true : false;
                let Coincidebulto = CodBulto == CodBultoDoc ? true : false;
                let Ok = false;
                let params = [{ "Key": "CodBulto1", "Value": CodBulto }, { "Key": "CodBulto2", "Value": CodBultoDoc }];
                if (CodBulto && CodBultoDoc) {
                    if (CodBulto != CodBultoDoc) {
                        flexygo.msg.confirm('"El bulto no coincide.¿Desea continuar?"', function (ret) {
                            if (ret) {
                                flexygo.pda.addLock();
                                proc.run(params, (response) => {
                                    if (response) {
                                        if (response.JSCode) {
                                            var func = new Function(response.JSCode);
                                            func.call(response.JSCode);
                                            flexygo.pda.removeLock();
                                        }
                                        if (response.LastException && response.LastException.Message) {
                                            flexygo.msg.error(response.LastException.Message);
                                        }
                                        else if (response.WarningMessage) {
                                            flexygo.msg.warning(response.WarningMessage);
                                        }
                                        else if (response.SuccessMessage) {
                                            let auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                                            page.defaults = JSON.stringify(auxdef);
                                            //primero válido que los bultos coincidan
                                            let Coincidecontenido = response.Data.Coincide == 1 ? true : false;
                                            //bloque de comparaciones
                                            if (Coincideubicacion && Coincidebulto) {
                                                //Ok
                                                Ok = true;
                                            }
                                            else {
                                                if (Coincideubicacion) {
                                                    if (Coincidecontenido) {
                                                        //'OK. La stored cambiará el bulto del trabajo
                                                        Ok = true;
                                                    }
                                                    else {
                                                        flexygo.msg.warning("Lectura no válida. No coincide contenido.");
                                                        CodBultoLect.val(null);
                                                        IdBultoLect.val(null);
                                                        CodBultoLect[0].querySelector('input').focus();
                                                        CodBultoLect[0].querySelector('input').select();
                                                    }
                                                }
                                                else {
                                                    //No coincide el bulto y no coincide la ubicacion
                                                    if (Coincidecontenido) {
                                                        //'OK
                                                        Ok = true;
                                                    }
                                                    else {
                                                        flexygo.msg.warning("Lectura no válida. No coincide bulto, ni contenido ni ubicación.");
                                                        CodBultoLect.val(null);
                                                        IdBultoLect.val(null);
                                                        CodBultoLect[0].querySelector('input').focus();
                                                        CodBultoLect[0].querySelector('input').select();
                                                    }
                                                }
                                            }
                                            //fin bloque de comparaciones
                                        }
                                    }
                                });
                                flexygo.pda.removeLock();
                            }
                            else {
                                CodBultoLect.val(null);
                                IdBultoLect.val(null);
                                CodBultoLect[0].querySelector('input').focus();
                                CodBultoLect[0].querySelector('input').select();
                            }
                        });
                    }
                    else {
                        //no hace falta evaluar si coincide el contenido es el mismo bulto
                        let Coincidecontenido = true;
                        //bloque de comparaciones
                        if (Coincideubicacion && Coincidebulto) {
                            //Ok
                            Ok = true;
                        }
                        else {
                            if (Coincideubicacion) {
                                if (Coincidecontenido) {
                                    //'OK. La stored cambiará el bulto del trabajo
                                    Ok = true;
                                }
                                else {
                                    flexygo.msg.warning("Lectura no válida. No coincide contenido.");
                                    CodBultoLect.val(null);
                                    IdBultoLect.val(null);
                                    CodBultoLect[0].querySelector('input').focus();
                                    CodBultoLect[0].querySelector('input').select();
                                }
                            }
                            else {
                                //No coincide el bulto y no coincide la ubicacion
                                if (Coincidecontenido) {
                                    //'OK
                                    Ok = true;
                                }
                                else {
                                    flexygo.msg.warning("Lectura no válida. No coincide bulto, ni contenido ni ubicación.");
                                    CodBultoLect.val(null);
                                    IdBultoLect.val(null);
                                    CodBultoLect[0].querySelector('input').focus();
                                    CodBultoLect[0].querySelector('input').select();
                                }
                            }
                        }
                        //fin bloque de comparaciones
                    }
                    if (Ok) {
                        //ejecutar el proceso de confirmar lectura
                        proc = new flexygo.Process('SGA_PDA_dll_Trabajo_ConfirmaLecturaBulto', null, null);
                        params = [
                            { "Key": "IdDocDetalle", "Value": IdDocDetalle },
                            { "Key": "CodBulto", "Value": CodBulto },
                            { "Key": "CodUbicacion", "Value": UbicacionLectura }
                        ];
                        flexygo.pda.addLock();
                        proc.run(params, (response) => {
                            if (response) {
                                if (response.JSCode) {
                                    var func = new Function(response.JSCode);
                                    func.call(response.JSCode);
                                    flexygo.pda.removeLock();
                                }
                                if (response.LastException && response.LastException.Message) {
                                    flexygo.msg.error(response.LastException.Message);
                                }
                                else if (response.WarningMessage) {
                                    flexygo.msg.warning(response.WarningMessage);
                                }
                                else if (response.SuccessMessage) {
                                    flexygo.pda.removeLock();
                                    let auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                                    page.defaults = JSON.stringify(auxdef);
                                    flexygo.nav.openPageName(pgn, 'SGA_PDA_Trabajos_Almacen_Detalle', 'IdDocDetalle = ' + IdDocDetalle, page.defaults, 'current', false);
                                }
                            }
                        });
                    }
                }
                else {
                    flexygo.msg.warning("Introduzca una lectura");
                }
            };
            //BULTO - BULTO: Botón incidencia bulto
            preparacion.IncidenciaBulto = (e, IdBultoLect) => {
                let IdBulto = IdBultoLect.val();
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                if (IdBulto) {
                    let auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                    auxdef.IdBulto = IdBulto;
                    page.defaults = JSON.stringify(auxdef);
                    flexygo.pda.incidencia.preparaIncidencia(e, "IdBulto");
                }
                else {
                    flexygo.msg.warning("Indique Bulto");
                }
            };
            //BULTO - UBICACIÓN DESTINO: Botón Finalizar
            preparacion.FinalizarBulto = (e, CodUbicLect, IdUbicLect, modname) => {
                let module2 = $(`[modulename=${modname}]flx-list`)[0];
                let CodUbic = $(CodUbicLect).val();
                let CodUbicDoc = module2.data[0].CodigoUbicacionDestino;
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let proc = new flexygo.Process('SGA_PDA_dll_Trabajo_Traspaso_Validar', null, null);
                let idTrabajo = JSON.parse(page.defaults).IdTrabajo ? JSON.parse(page.defaults).IdTrabajo : 0;
                let IdDocDetalle = JSON.parse(page.defaults).IdDocDetalle ? JSON.parse(page.defaults).IdDocDetalle : 0;
                let IdOrden = JSON.parse(page.defaults).IdOrden ? JSON.parse(page.defaults).IdOrden : 0;
                let params = [{ "Key": "idTrabajo", "Value": idTrabajo }, { "Key": "CodUbicLect", "Value": CodUbic }];
                if (CodUbic && CodUbicDoc) {
                    if (CodUbic != CodUbicDoc) {
                        flexygo.msg.confirm('La ubicación no coincide.¿Desea continuar?"', function (ret) {
                            if (ret) {
                                flexygo.pda.addLock();
                                proc.run(params, (response) => {
                                    if (response) {
                                        if (response.JSCode) {
                                            var func = new Function(response.JSCode);
                                            func.call(response.JSCode);
                                            flexygo.pda.removeLock();
                                        }
                                        if (response.LastException && response.LastException.Message) {
                                            flexygo.msg.error(response.LastException.Message);
                                        }
                                        else if (response.WarningMessage) {
                                            flexygo.msg.warning(response.WarningMessage);
                                        }
                                        else if (response.SuccessMessage) {
                                            let auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                                            page.defaults = JSON.stringify(auxdef);
                                            flexygo.pda.preparacion.Comenzar(e, IdOrden, IdDocDetalle, false, 0);
                                        }
                                    }
                                });
                                flexygo.pda.removeLock();
                            }
                            else {
                                flexygo.pda.ubicacion.LimpiarUbicacion();
                            }
                        });
                    }
                    else {
                        flexygo.pda.addLock();
                        proc.run(params, (response) => {
                            if (response) {
                                if (response.JSCode) {
                                    var func = new Function(response.JSCode);
                                    func.call(response.JSCode);
                                    flexygo.pda.removeLock();
                                }
                                if (response.LastException && response.LastException.Message) {
                                    flexygo.msg.error(response.LastException.Message);
                                }
                                else if (response.WarningMessage) {
                                    flexygo.msg.warning(response.WarningMessage);
                                }
                                else if (response.SuccessMessage) {
                                    let auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                                    page.defaults = JSON.stringify(auxdef);
                                    flexygo.pda.preparacion.Comenzar(e, IdOrden, IdDocDetalle, false, 0);
                                }
                            }
                        });
                    }
                }
                else {
                    flexygo.msg.warning("Indique Ubicación");
                    CodUbicLect[0].querySelector('input').focus();
                    CodUbicLect[0].querySelector('input').select();
                }
            };
            //PICKING - BULTO PICKING: Carga inicial del módulo de embalaje
            preparacion.InicializarModuloEmbalaje = () => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Parámetros
                let IdTrabajo = auxdef.IdTrabajo ? auxdef.IdTrabajo : 0;
                let CodBultoPicking = auxdef.CodBultoPicking ? auxdef.CodBultoPicking : 0;
                let IdBultoPicking = auxdef.IdBultoPicking ? auxdef.IdBultoPicking : 0;
                let IdEmbalaje = auxdef.IdEmbalaje ? auxdef.IdEmbalaje : 0;
                if (IdBultoPicking != 0) {
                    $("#CodBarras1").val(CodBultoPicking);
                    $("#cboBulto").val(IdBultoPicking);
                }
                if (IdEmbalaje != "") {
                    $("#cboEmbalaje").val(IdEmbalaje);
                }
                else {
                    $("#cboEmbalaje").val("");
                }
            };
            //PICKING - BULTO PICKING: Leer bulto picking. 
            preparacion.LeerBultoPicking = (item, event) => {
                //Parámetros
                let params = $(`.param`);
                let pbCodigo = $('flx-text[name = "pbCodigoBulto"]');
                let pbCombo = $('flx-dbcombo[name = "pbComboBulto"]');
                let pbComboEmbalaje = $('flx-dbcombo[name = "pbComboEmbalaje"]');
                //Valor de búsqueda del campo de texto o del combo
                let valorBusqueda = ((item.tagName).toLowerCase() == "flx-text") ? pbCodigo.val() : pbCombo.val();
                if (!valorBusqueda) {
                    return;
                }
                ;
                //Lanzamos lectura estándar
                let lectura = flexygo.pda.bulto.LeerBultoCombo(item, event);
                lectura.then(function (Datos) {
                    if (Datos) {
                        //Lanzamos validación del bulto
                        let validar = flexygo.pda.preparacion.EmbalajeBultoPicking();
                        validar.then(function (IdEmbalaje) {
                            if (IdEmbalaje && IdEmbalaje != 0) {
                                pbComboEmbalaje.val(IdEmbalaje);
                            }
                        });
                        validar.catch(function (error) {
                            if (error && error != "") {
                                pbComboEmbalaje.val(null);
                                flexygo.msg.warning(error);
                            }
                        });
                    }
                });
                lectura.catch(function (error) {
                    if (error && error != "") {
                        flexygo.msg.warning(error);
                    }
                    flexygo.pda.preparacion.LimpiarBultoPicking();
                });
            };
            //PICKING - BULTO PICKING: recupera el embalaje
            preparacion.EmbalajeBultoPicking = () => {
                let promesa = new Promise(function (resolve, reject) {
                    //Parámetros
                    let pbCodigo = $('flx-text[name = "pbCodigoBulto"]');
                    let pbCombo = $('flx-dbcombo[name = "pbComboBulto"]');
                    //Valor
                    let IdBulto = pbCombo.val();
                    //Valido el bulto
                    let proc = new flexygo.Process('SGA_PDA_dll_Embalaje_Bulto', null, null);
                    let params = [{ 'Key': 'IdBulto', 'Value': IdBulto }];
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                flexygo.pda.removeLock();
                                return resolve(0);
                            }
                            if (response.LastException && response.LastException.Message) {
                                return reject(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                return reject(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                return resolve(response.Data ? response.Data.IdEmbalaje : 0);
                            }
                            return reject("No se ha encontrado embalaje.");
                        }
                        else {
                            return reject("Proceso finalizado con errores.");
                        }
                    });
                });
                return promesa;
            };
            //PICKING - BULTO PICKING: Botón de limpieza del campo de texto de bulto, combo y módulos con datos.
            preparacion.LimpiarBultoPicking = () => {
                //Controles
                let params = $(`.param`);
                let pbCodigo = $('flx-text[name = "pbCodigoBulto"]');
                let pbCombo = $('flx-dbcombo[name = "pbComboBulto"]');
                let pbComboEmbalaje = $('flx-dbcombo[name = "pbComboEmbalaje"]');
                //Campos de ubicación
                pbCodigo.val(null);
                pbComboEmbalaje.val(null);
                //Filtro del combo
                pbCombo[0].additionalWhere = `IdAlmacen = '${flexygo.context.currentAlmacen}' AND IdEstado = 0`;
                pbCombo[0].refresh();
                pbCombo.val(null);
                //Encontramos módulos a visualizar y los limpiamos
                $("flx-module.LecturaBultoDatos").find('flx-list, flx-view').map(function (indice, modulo) {
                    let module = $(modulo)[0];
                    module.additionalWhere = "1 = 0";
                    module.init();
                });
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                auxdef.valorBusqueda = "";
                page.defaults = JSON.stringify(auxdef);
                //Foco
                pbCodigo[0].querySelector("input").focus();
            };
            //PICKING - BULTO PICKING: Botón comenzar picking
            preparacion.ComenzarPicking = (e, CodBultoLect, IdBultoLect, CodEmbalajeLect) => {
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let CodBulto = CodBultoLect.val();
                let IdBulto = IdBultoLect.val();
                let CodEmbalaje = CodEmbalajeLect.val();
                let IdTrabajo = JSON.parse(page.defaults).IdTrabajo ? JSON.parse(page.defaults).IdTrabajo : 0;
                let proc = new flexygo.Process('SGA_PDA_dll_trabajo_estabbultopicking', null, null);
                let params = [
                    { 'Key': 'IdTrabajo', 'Value': IdTrabajo },
                    { 'Key': 'IdBulto', 'Value': IdBulto },
                    { 'Key': 'CodEmbalaje', 'Value': CodEmbalaje }
                ];
                flexygo.pda.addLock();
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                        else if (response.SuccessMessage) {
                            flexygo.nav.openPageName('PDA_pg_Preparacion_Picking_2', 'SGA_PDA_Trabajos_Almacen', 'IdTrabajoAlm = ' + IdTrabajo, page.defaults, 'current', true);
                        }
                    }
                });
            };
            //PICKING DETALLES: Botón reordenar detalles
            preparacion.ReordenarDetalles = (e) => {
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let idTrabajo = JSON.parse(page.defaults).IdTrabajo ? JSON.parse(page.defaults).IdTrabajo : 0;
                if (idTrabajo) {
                    flexygo.pda.addLock();
                    //Reordenar 
                    let proc = new flexygo.Process('SGA_PDA_dll_trabajo_reordenar', null, null);
                    let params = [{ 'Key': 'idTrabajo', 'Value': idTrabajo }];
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                            }
                            if (response.LastException && response.LastException.Message) {
                                flexygo.msg.error(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                flexygo.msg.warning(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                flexygo.msg.success("Trabajos reordenados con éxito.");
                            }
                        }
                    });
                }
            };
            //PICKING DETALLES: Botón comenzar
            preparacion.ComenzarDetalle = (e, IdDocDetalle) => {
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let IdTrabajo = JSON.parse(page.defaults).IdTrabajo ? JSON.parse(page.defaults).IdTrabajo : 0;
                if (IdDocDetalle) {
                    let auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                    auxdef.IdDocDetalle = IdDocDetalle;
                    page.defaults = JSON.stringify(auxdef);
                    let pgn = 'PDA_pg_Preparacion_Picking_3';
                    flexygo.nav.openPageName(pgn, 'SGA_PDA_Trabajos_Almacen', 'IdTrabajoAlm = ' + IdTrabajo + ' AND IdDocDetalle = ' + IdDocDetalle, page.defaults, 'current', false);
                }
                else {
                    flexygo.msg.warning("No se ha seleccionado registro", null, '');
                }
            };
            //PICKING - UBICACIÓN ORIGEN: Botón Siguiente. Pasa a siguiente detalle del trabajo
            preparacion.SiguienteDetallePicking = (e) => {
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let IdDocDetalle = JSON.parse(page.defaults).IdDocDetalle ? JSON.parse(page.defaults).IdDocDetalle : 0;
                if (IdDocDetalle) {
                    let proc = new flexygo.Process('SGA_PDA_dll_trabajo_sigdetallesalida', null, null);
                    let params = [{ 'Key': 'IdDocDetalle', 'Value': IdDocDetalle }];
                    flexygo.pda.addLock();
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                flexygo.pda.removeLock();
                            }
                            if (response.LastException && response.LastException.Message) {
                                flexygo.msg.error(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                flexygo.msg.warning(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                if (response.Data.IdDocDetalle != IdDocDetalle) {
                                    flexygo.pda.preparacion.ComenzarDetalle(e, response.Data.IdDocDetalle);
                                }
                                else {
                                    flexygo.msg.warning("Esta es la última linea de picking.");
                                }
                                flexygo.pda.removeLock();
                                $('#CodUbic input').focus();
                                $('#CodUbic input').select();
                            }
                        }
                        flexygo.pda.removeLock();
                    });
                }
            };
            //PICKING - UBICACIÓN ORIGEN: Botón Finalizar Picking. Finaliza el trabajo de picking
            preparacion.FinalizarTrabajoPicking = (e) => {
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let IdTrabajo = JSON.parse(page.defaults).IdTrabajo ? JSON.parse(page.defaults).IdTrabajo : 0;
                if (IdTrabajo) {
                    let proc = new flexygo.Process('SGA_PDA_dll_IdAlmacen_IdUbicacion', null, null);
                    let params = [{ 'Key': 'IdTrabajo', 'Value': IdTrabajo }];
                    flexygo.pda.addLock();
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                flexygo.pda.removeLock();
                            }
                            if (response.LastException && response.LastException.Message) {
                                flexygo.msg.error(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                flexygo.msg.warning(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                let auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                                auxdef.IdAlmacenDestino = response.Data.IdAlmacenDestino;
                                auxdef.IdUbicacionDestino = response.Data.IdUbicacionDestino;
                                let donde = "IdAlmacen = " + auxdef.IdAlmacenDestino + " AND IdUbicacion = '" + auxdef.IdUbicacionDestino + "'";
                                flexygo.pda.removeLock();
                                page.defaults = JSON.stringify(auxdef);
                                let pgn = 'PDA_pg_Preparacion_Picking_Fin';
                                flexygo.nav.openPageName(pgn, 'SGA_PDA_Almacenes', donde, page.defaults, 'current', true);
                            }
                        }
                        flexygo.pda.removeLock();
                    });
                }
                else {
                    flexygo.msg.warning("error en datos", null, '');
                }
            };
            //PICKING - UBICACIÓN ORIGEN: Botón Confirmar Ubicación. 
            preparacion.ConfirmarUbicacion = (e, modNameSel, modNameOri, pgn) => {
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let IdDocDetalle = JSON.parse(page.defaults).IdDocDetalle ? JSON.parse(page.defaults).IdDocDetalle : 0;
                let modSelected = $(`[modulename=${modNameSel}]flx-list`)[0];
                let modOrigen = $(`[modulename=${modNameOri}]flx-list`)[0];
                if (modSelected.data && modOrigen.data) {
                    flexygo.pda.addLock();
                    let CodUbicacion = modSelected.data[0].Codigo;
                    let IdUbicacion = modSelected.data[0].IdUbicacion;
                    let CodUbicOrigen = modOrigen.data[0].CodigoUbicacion;
                    if (CodUbicacion != CodUbicOrigen) {
                        flexygo.msg.confirm('La ubicación no coincide.¿Desea continuar?', function (ret) {
                            if (ret) {
                                let auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                                auxdef.UbicacionLectura = CodUbicacion;
                                auxdef.IdUbicacionLectura = IdUbicacion;
                                auxdef.UbicacionTrabajo = CodUbicOrigen;
                                let donde = "IdDocDetalle = " + IdDocDetalle;
                                //Verificamos si existen bultos en la ubicación para pedir selección en la siguiente página
                                let consulta = `IdUbicacion = '${IdUbicacion}' AND IdEstado IN (2,3)`;
                                consulta += modOrigen.data[0].Articulo ? ` AND IdArticulo = '${modOrigen.data[0].Articulo}'` : '';
                                consulta += modOrigen.data[0].NumLote ? ` AND Lote = '${modOrigen.data[0].NumLote}'` : '';
                                consulta += modOrigen.data[0].P1 ? ` AND P1 = '${modOrigen.data[0].P1}'` : '';
                                consulta += modOrigen.data[0].P2 ? ` AND P2 = '${modOrigen.data[0].P2}'` : '';
                                var obj = new flexygo.obj.Entity('SGA_PDA_Bulto');
                                let lista = obj.getView("SGA_PDA_v_Bulto_Detalles", 0, 10000, consulta, "", null);
                                if (lista.length > 0) {
                                    auxdef.Bultos = lista;
                                }
                                page.defaults = JSON.stringify(auxdef);
                                flexygo.nav.openPageName(pgn, 'SGA_PDA_Almacenes', donde, page.defaults, 'current', false);
                            }
                            else {
                                flexygo.pda.ubicacion.LimpiarUbicacion();
                                return;
                            }
                        });
                    }
                    else {
                        let auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                        auxdef.UbicacionLectura = CodUbicacion;
                        auxdef.IdUbicacionLectura = IdUbicacion;
                        auxdef.UbicacionTrabajo = CodUbicOrigen;
                        let donde = "IdDocDetalle = " + IdDocDetalle;
                        //Verificamos si existen bultos en la ubicación para pedir selección en la siguiente página
                        let consulta = `IdUbicacion = '${IdUbicacion}' AND IdEstado IN (2,3)`;
                        consulta += modOrigen.data[0].Articulo ? ` AND IdArticulo = '${modOrigen.data[0].Articulo}'` : '';
                        consulta += modOrigen.data[0].NumLote ? ` AND Lote = '${modOrigen.data[0].NumLote}'` : '';
                        consulta += modOrigen.data[0].P1 ? ` AND P1 = '${modOrigen.data[0].P1}'` : '';
                        consulta += modOrigen.data[0].P2 ? ` AND P2 = '${modOrigen.data[0].P2}'` : '';
                        var obj = new flexygo.obj.Entity('SGA_PDA_Bulto');
                        let lista = obj.getView("SGA_PDA_v_Bulto_Detalles", 0, 10000, consulta, "", null);
                        if (lista.length > 0) {
                            auxdef.Bultos = lista;
                        }
                        page.defaults = JSON.stringify(auxdef);
                        flexygo.nav.openPageName(pgn, 'SGA_PDA_Almacenes', donde, page.defaults, 'current', false);
                    }
                }
                else {
                    flexygo.msg.warning("Indique Ubicación", null, '');
                }
            };
            //PICKING - ARTÍCULO: carga inicial de los datos de la página. Lanzado en el Afterload del módulo que muestra los datos del trabajo
            preparacion.CargarDatosTrabajoDetalle = (e, modName) => {
                let module = $('flx-module')[0];
                let page = flexygo.history.get(module);
                let modSelected = $(`[modulename=${modName}]flx-list`)[0];
                let CodUbicLeida = JSON.parse(page.defaults).UbicacionLectura ? JSON.parse(page.defaults).UbicacionLectura : 0;
                let CodUbicIni = JSON.parse(page.defaults).UbicacionTrabajo ? JSON.parse(page.defaults).UbicacionTrabajo : 0;
                let IdDocDetalle = JSON.parse(page.defaults).IdDocDetalle ? JSON.parse(page.defaults).IdDocDetalle : 0;
                let IdOrden = JSON.parse(page.defaults).IdOrden ? JSON.parse(page.defaults).IdOrden : 0;
                //Valido el estado del detalle para redirecciones con el botón volver atrás
                if (IdDocDetalle) {
                    let TrabajoDetalle = new flexygo.obj.Entity(`SGA_PDA_Trabajo_Almacen_Detalle`, `IdDoc = ${IdDocDetalle}`);
                    TrabajoDetalle.read();
                    if (TrabajoDetalle.data.IdEstado.Value && TrabajoDetalle.data.IdEstado.Value != 0) {
                        flexygo.msg.warning("El detalle del trabajo ya se ha confirmado.", null, '');
                        //Volvemos a selección de Trabajo
                        flexygo.nav.openPageName('PDA_pg_Preparaciones_por_Orden', '', `OrdenCarga = ${IdOrden}`, page.defaults, 'current', true);
                        return;
                    }
                }
                let proc = new flexygo.Process('SGA_PDA_ubicacion_bultoliquidar', null, null);
                let params = [{ 'Key': 'IdDocDetalle', 'Value': IdDocDetalle }, { 'Key': 'CodUbicacion', 'Value': CodUbicLeida }];
                flexygo.pda.addLock();
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                        else if (response.SuccessMessage) {
                            let auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                            auxdef.LiquidarBultoV = response.Data.LiquidarBulto;
                            if (response.Data.LiquidarBulto) {
                                $('#liqbulto').val(response.Data.CodBultoLiquidar);
                            }
                            else {
                                $('flx-text[id="liqbulto"]').hide();
                                $('label[id="lblliqbulto"]').hide();
                                $('#liqbulto').val(null);
                            }
                            auxdef.IdBultoLiquidar = response.Data.IdBultoLiquidar;
                            page.defaults = JSON.stringify(auxdef);
                            if (modSelected.data) {
                                let module = $('flx-module')[0];
                                let page = flexygo.history.get(module);
                                if (JSON.parse(page.defaults).Bultos) {
                                    flexygo.pda.preparacion.PrepararLecturaBulto(JSON.parse(page.defaults).Bultos);
                                }
                                else {
                                    $('#CodBarras input').focus();
                                }
                                flexygo.pda.removeLock();
                            }
                        }
                    }
                });
            };
            //PICKING - ARTÍCULO: carga los datos del bulto y, en caso de ser único, no lo muestra.
            preparacion.PrepararLecturaBulto = (Bultos) => {
                $("#contBulto").removeClass("hidden");
                let cboBulto = $("#cboBulto")[0];
                Bultos.map((bulto, i) => {
                    cboBulto.additionalWhere += i == 0 ? `  AND IdBulto = ${bulto.IdBulto} ` : `OR IdBulto = ${bulto.IdBulto} `;
                });
                cboBulto.refresh();
                if (Bultos.length == 1) {
                    $('#CodBarras1').find('input').focus();
                    $("#CodBarras1").val(Bultos[0].CodBarras1);
                    $("#CodBarras1").find('input').trigger('input');
                    $('#contArticulo').find('input').focus();
                }
                else {
                    $("#contArticulo").addClass("hidden");
                    $("#contPropiedades").addClass("hidden");
                    $("#contCantidad").addClass("hidden");
                    $('#CodBarras1 input').focus();
                    $('#CodBarras1 input').select();
                }
            };
            //PICKING - ARTÍCULO: lectura del bulto sobre el que se va a realizar el picking del artículo
            preparacion.LeerBultoArticulo = (lectura) => {
                //Parámetros
                let parametros = $(`.param`);
                //Campo que indica si la lectura se ha llevado a cabo
                let read = false;
                //Valor de búsqueda del campo de texto o del combo
                let valorBusqueda = lectura.val();
                if (!valorBusqueda) {
                    return;
                }
                ;
                //En caso de recibir parámetro con longitudes a tener en cuenta, y se trata del campo de texto, se verifica si se ha llegado al tamaño del parámetro
                read = parametros ? (((lectura.prop("tagName")).toLowerCase() == "flx-text") ? flexygo.pda.readCode(parametros, valorBusqueda, event) : true) : true;
                //Si damos la entrada como buena
                if (read) {
                    flexygo.pda.addLock();
                    let module = $('flx-module')[0];
                    let page = flexygo.history.get(module);
                    let bultoEnt = new flexygo.obj.Entity(`SGA_PDA_Bulto`, `${(lectura.prop("tagName")).toLowerCase() == "flx-dbcombo" ? "IdBulto" : "CodBarras1"} = '${lectura.val()}'`);
                    bultoEnt.read();
                    if (bultoEnt.data.IdBulto.Value) {
                        let cboBulto = $("#cboBulto")[0];
                        //El idBulto debe de existir en el combo
                        if (cboBulto.additionalWhere.includes(bultoEnt.data.IdBulto.Value)) {
                            if ((lectura.prop("tagName")).toLowerCase() == "flx-dbcombo") {
                                $("#CodBarras1").val(bultoEnt.data.CodBarras1.Value);
                            }
                            else {
                                $("#cboBulto").val(bultoEnt.data.IdBulto.Value);
                            }
                            let obj = new flexygo.obj.Entity('SGA_PDA_Bulto');
                            let lista = obj.getView("SGA_PDA_v_Bulto_Detalles", 0, 10000, `IdBulto = ${bultoEnt.data.IdBulto.Value}`, "", null);
                            let obj2 = new flexygo.obj.Entity('SGA_PDA_Trabajo_Almacen_Detalle');
                            let lista2 = obj2.getView("SGA_PDA_v_Picking_Detalle_3", 0, 10000, `IdDocDetalle = ${JSON.parse(page.defaults).IdDocDetalle}`, "", null);
                            //DESCOMENTAR PARA PERSONALIZAR. Precargamos las propiedades del bulto
                            //if (lista.length == 1) {
                            //    $("#cboP1").val(lista[0].P1);
                            //    $("#cboP2").val(lista[0].P2);
                            //}
                            $("#cantidad").val(lista2[0].Cantidad);
                            $("#contArticulo").removeClass("hidden");
                            $("#contPropiedades").removeClass("hidden");
                            $("#contCantidad").removeClass("hidden");
                            $("#contArticulo input").focus();
                            flexygo.pda.removeLock();
                        }
                        else {
                            flexygo.msg.warning("No es posible hacer picking de un bulto en una ubicación diferente a la del trabajo.");
                        }
                    }
                    else {
                        flexygo.msg.warning("Bulto no encontrado");
                    }
                }
            };
            //PICKING - ARTÍCULO: lectura de artículo 
            preparacion.LeerArticulo = (item, event) => {
                //Parámetros y campos
                let parametros = $(`.param`);
                let pbCodigo = $('flx-text[name = "pbCodigoArticulo"]');
                let pbCombo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbComboUnidades = $('flx-dbcombo[name = "pbComboUnidades"]');
                let pbCantidadStock = $('flx-text[name = "pbCantidadStock"]');
                let pbUnidadStock = $('flx-text[name = "pbUnidadStock"]');
                let pbStock = $('flx-text[name = "pbStock"]');
                let pbStockUbicacion = $('flx-text[name = "pbStockUbicacion"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                //Valor de búsqueda del campo de texto o del combo
                let valorBusqueda = ((item.tagName).toLowerCase() == "flx-text") ? pbCodigo.val() : pbCombo.val();
                if (!valorBusqueda) {
                    return;
                }
                ;
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                //Campo que indica si la lectura se ha llevado a cabo
                let read = false;
                //Si ha cambiado el valor del combo. Evitamos lanzar la búsqueda con el mismo valor.
                if (auxdef.valorBusqueda != valorBusqueda) {
                    //En caso de recibir parámetro con longitudes a tener en cuenta, y se trata del campo de texto, se verifica si se ha legeado al tamaño del parámetro
                    read = parametros ? (((item.tagName).toLowerCase() == "flx-text") ? flexygo.pda.readCode(parametros, valorBusqueda, event) : true) : true;
                }
                //Si damos la entrada como buena
                if (read) {
                    flexygo.pda.addLock();
                    //Búsqueda por CodBarras. Puede devolver datos como lote y propiedades
                    let articulo = flexygo.pda.articulo.Buscar(valorBusqueda);
                    articulo.then(function (datos) {
                        //TRATAMOS ARTÍCULO
                        //----------------------------------
                        //No encontrado
                        if (!datos.IdArticulo) {
                            flexygo.msg.warning("No se ha encontrado ningún artículo.");
                            flexygo.pda.preparacion.LimpiarCampos();
                            return;
                        }
                        //Validamos contra trabajo pasando los datos de la lectura por CodBarras. Puede devolver lote y propiedades.
                        let loteValidar = datos.LoteInterno ? datos.LoteInterno : (datos.Lote ? datos.Lote : "");
                        let detalleTrabajo = flexygo.pda.trabajo.ValidarLecturaPicking(IdDocDetalle, datos.IdArticulo, loteValidar, datos.P1 ? datos.P1 : "", datos.P2 ? datos.P2 : "", 0);
                        detalleTrabajo.then(function (DetalleTrabajo) {
                            //Valores de campos de búsqueda
                            if ((item.tagName).toLowerCase() == "flx-dbcombo") {
                                //Evento lanzado por el combo, se pone en el código el CodBarras asociado o IdArticulo si no tiene código
                                valorBusqueda = datos.IdArticulo;
                                pbCodigo.val(valorBusqueda);
                            }
                            else {
                                //Evento lanzado por el campo de texto, se establece el ID en el combo
                                pbCombo.val(datos.IdArticulo);
                            }
                            //TRATAMOS LOTES
                            //----------------------------------
                            //Si recibimos lote interno lo cargamos y ocultamos el combo
                            if (datos.LoteInterno) {
                                pbLote.val(datos.LoteInterno);
                                pbLote.hide();
                            }
                            //Ocultamos o mostramos combo
                            if (!datos.RequiereLote) {
                                pbLote.hide();
                            }
                            else {
                                pbLote.show();
                                //Si recibimos el lote desde la lectura lo cargamos
                                if (datos.Lote) {
                                    pbLote.val(datos.Lote);
                                }
                                else if (DetalleTrabajo.data.NumLote.Value) {
                                    //Cargamos el lote del trabajo
                                    pbLote.val(DetalleTrabajo.data.NumLote.Value);
                                }
                            }
                            //TRATAMOS PROPIEDADES
                            //----------------------------------
                            //Ocultamos/Mostramos los combos y cargamos la propiedad recibida
                            datos.RequiereP1 ? pbComboP1.show() : pbComboP1.hide();
                            datos.RequiereP2 ? pbComboP2.show() : pbComboP2.hide();
                            if (datos.RequiereP1 && datos.P1) {
                                pbComboP1.val(datos.P1);
                            }
                            ;
                            if (datos.RequiereP2 && datos.P2) {
                                pbComboP2.val(datos.P2);
                            }
                            ;
                            //DESCOMENTAR PARA PERSONALIZAR. Precargamos las propiedades del trabajo
                            //if (DetalleTrabajo.data.P1.Value && !pbComboP1.val()) {
                            //    pbComboP1.val(DetalleTrabajo.data.P1.Value);
                            //}
                            //if (DetalleTrabajo.data.P2.Value && !pbComboP2.val()) {
                            //    pbComboP2.val(DetalleTrabajo.data.P2.Value);
                            //}
                            //TRATAMOS BULTO A LIQUIDAR
                            //----------------------------------
                            //En la carga del módulo se recupera el bulto a liquidar que se consumirá. Lo mostramos en caso de ser necesario
                            if ($('#liqbulto').val() && $('#contBulto')[0].classList.contains("hidden")) {
                                $('#contBulto')[0].classList.remove("hidden");
                            }
                            //TRATAMOS CANTIDAD
                            //----------------------------------
                            //Precargamos la cantidad de lectura
                            if (DetalleTrabajo.data.Cantidad.Value) {
                                pbCantidad.val(DetalleTrabajo.data.Cantidad.Value);
                            }
                            //TRATAMOS UNIDADES POR DEFECTO
                            //----------------------------------
                            //Se recupera el valor por defecto del tipo de unidad de artículo
                            let tipoUnidad = flexygo.pda.articulo.TipoUnidad(datos.IdArticulo, pbLote.val() ? pbLote.val() : "");
                            tipoUnidad.then(function (tipo) {
                                //Tipos de Unidades del artículo para conversiones
                                pbComboUnidades[0].additionalWhere = `IdArticulo = '${datos.IdArticulo}'`;
                                pbComboUnidades[0].refresh();
                                pbComboUnidades[0].querySelector("input").disabled = false;
                                if (tipo) {
                                    pbComboUnidades.val(tipo);
                                    pbUnidadStock.val(tipo);
                                    pbCantidadStock.val(null);
                                }
                            });
                            tipoUnidad.catch(function (error) {
                                if (error && error != "") {
                                    flexygo.msg.warning(error);
                                    return;
                                }
                            });
                            //TRATAMOS STOCK DE UBICACIÓN
                            //----------------------------------
                            //Cargar el stock. También devuelve el lote y las propiedades en caso de devolver un sólo registro de stock en la ubicación
                            let obtenerStock = flexygo.pda.ubicacion.ObtenerStock(datos.IdArticulo, pbLote.val(), pbComboP1.val(), pbComboP2.val(), auxdef.IdUbicacionLectura);
                            obtenerStock.then(function (stock) {
                                if (stock) {
                                    //Devuelve stock
                                    if (stock.stock) {
                                        pbStockUbicacion.val(stock.stock);
                                    }
                                    //Focos
                                    if (pbLote.attr("style") != 'display: none;' && !pbLote.val()) {
                                        pbLote[0].querySelector("input").focus();
                                    }
                                    else if (pbComboP1.attr("style") != 'display: none;' && !pbComboP1.val()) {
                                        pbComboP1[0].querySelector("input").focus();
                                    }
                                    else if (pbComboP2.attr("style") != 'display: none;' && !pbComboP2.val()) {
                                        pbComboP2[0].querySelector("input").focus();
                                    }
                                    else {
                                        pbCantidad[0].querySelector("input").focus();
                                    }
                                }
                            });
                            obtenerStock.catch(function (error) { if (error && error != "") {
                                flexygo.msg.warning(error);
                            } });
                            //Valor de búsqueda para no repetir acción si no cambia
                            auxdef.valorBusqueda = valorBusqueda;
                            page.defaults = JSON.stringify(auxdef);
                        });
                        detalleTrabajo.catch(function (error) {
                            if (error && error != "") {
                                flexygo.msg.warning(error);
                                flexygo.pda.preparacion.LimpiarCampos();
                                return;
                            }
                        });
                    });
                    articulo.catch(function (error) {
                        if (error && error != "") {
                            flexygo.msg.warning(error);
                            return;
                        }
                    });
                    flexygo.pda.removeLock();
                }
            };
            //PICKING - ARTÍCULO: combo de lotes. Efecto de pérdida de foco
            preparacion.LeerLote = (item, event) => {
                //Parámetros y campos
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbStockUbicacion = $('flx-text[name = "pbStockUbicacion"]');
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Datos
                let lote = pbComboLote.val() ? pbComboLote.val() : ($('flx-dbcombo[name = "pbComboLote"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboLote"] li.selected')[0].dataset.value : null);
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                let IdUbicacionOrigen = auxdef.IdUbicacionOrigen ? auxdef.IdUbicacionOrigen : 0;
                let IdArticulo = pbComboArticulo.val() ? pbComboArticulo.val() : "";
                let P1 = pbComboP1.val() ? pbComboP1.val() : "";
                let P2 = pbComboP2.val() ? pbComboP2.val() : "";
                if (!lote) {
                    return;
                }
                flexygo.pda.addLock();
                //Validamos contra trabajo pasando los datos de la lectura por CodBarras. Puede devolver lote y propiedades.
                let detalleTrabajo = flexygo.pda.trabajo.ValidarLecturaPicking(IdDocDetalle, IdArticulo, lote, P1, P2, 0);
                detalleTrabajo.then(function (DetalleTrabajo) {
                    //Cargar el stock. También devuelve el lote y las propiedades en caso de devolver un sólo registro de stock en la ubicación
                    let lectura = flexygo.pda.ubicacion.ObtenerStock(IdArticulo, lote, P1, P2, IdUbicacionOrigen);
                    lectura.then(function (stock) {
                        if (stock) {
                            //Devuelve stock
                            if (stock.stock) {
                                pbStockUbicacion.val(stock.stock);
                            }
                            //Focos
                            if (pbComboLote.attr("style") != 'display: none;' && !pbComboLote.val()) {
                                pbComboLote[0].querySelector("input").focus();
                            }
                            else if (pbComboP1.attr("style") != 'display: none;' && !pbComboP1.val()) {
                                pbComboP1[0].querySelector("input").focus();
                            }
                            else if (pbComboP2.attr("style") != 'display: none;' && !pbComboP2.val()) {
                                pbComboP2[0].querySelector("input").focus();
                            }
                            else {
                                pbCantidad[0].querySelector("input").focus();
                            }
                        }
                        flexygo.pda.removeLock();
                    });
                    lectura.catch(function (error) { if (error && error != "") {
                        flexygo.msg.warning(error);
                    } });
                });
                detalleTrabajo.catch(function (error) {
                    if (error && error != "") {
                        flexygo.msg.warning(error);
                        flexygo.pda.preparacion.LimpiarCampos();
                        return;
                    }
                });
            };
            //PICKING - ARTÍCULO: combo de propiedades. Efecto de pérdida de foco
            preparacion.LeerPropiedad = (item, event) => {
                //Parámetros y campos
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbStockUbicacion = $('flx-text[name = "pbStockUbicacion"]');
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Datos
                let lote = pbComboLote.val() ? pbComboLote.val() : ($('flx-dbcombo[name = "pbComboLote"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboLote"] li.selected')[0].dataset.value : null);
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                let IdUbicacionOrigen = auxdef.IdUbicacionOrigen ? auxdef.IdUbicacionOrigen : 0;
                let IdArticulo = pbComboArticulo.val() ? pbComboArticulo.val() : "";
                let P1 = pbComboP1.val() ? pbComboP1.val() : ($('flx-dbcombo[name = "pbComboP1"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboP1"] li.selected')[0].dataset.value : null);
                let P2 = pbComboP2.val() ? pbComboP2.val() : ($('flx-dbcombo[name = "pbComboP2"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboP2"] li.selected')[0].dataset.value : null);
                flexygo.pda.addLock();
                //Validamos contra trabajo pasando los datos de la lectura por CodBarras. Puede devolver lote y propiedades.
                let detalleTrabajo = flexygo.pda.trabajo.ValidarLecturaPicking(IdDocDetalle, IdArticulo, lote, P1, P2, 0);
                detalleTrabajo.then(function (DetalleTrabajo) {
                    //Cargar el stock. También devuelve el lote y las propiedades en caso de devolver un sólo registro de stock en la ubicación
                    let lectura = flexygo.pda.ubicacion.ObtenerStock(IdArticulo, lote, P1, P2, IdUbicacionOrigen);
                    lectura.then(function (stock) {
                        if (stock) {
                            //Devuelve stock
                            if (stock.stock) {
                                pbStockUbicacion.val(stock.stock);
                            }
                            //Focos
                            if (pbComboLote.attr("style") != 'display: none;' && !pbComboLote.val()) {
                                pbComboLote[0].querySelector("input").focus();
                            }
                            else if (pbComboP1.attr("style") != 'display: none;' && !pbComboP1.val() && !P1) {
                                pbComboP1[0].querySelector("input").focus();
                            }
                            else if (pbComboP2.attr("style") != 'display: none;' && !pbComboP2.val() && !P2) {
                                pbComboP2[0].querySelector("input").focus();
                            }
                            else {
                                pbCantidad[0].querySelector("input").focus();
                            }
                        }
                        flexygo.pda.removeLock();
                    });
                    lectura.catch(function (error) {
                        if (error && error != "") {
                            flexygo.msg.warning(error);
                        }
                    });
                });
                detalleTrabajo.catch(function (error) {
                    if (error && error != "") {
                        flexygo.msg.warning(error);
                        flexygo.pda.preparacion.LimpiarCampos();
                        return;
                    }
                });
            };
            //PICKING - ARTÍCULO: introducción de cantidad leída y unidad de lectura
            preparacion.LeerCantidad = (item, event) => {
                //Parámetros y campos
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboEmbalaje = $('flx-dbcombo[name = "pbComboEmbalaje"]');
                let pbComboUnidades = $('flx-dbcombo[name = "pbComboUnidades"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbCantidadStock = $('flx-text[name = "pbCantidadStock"]');
                //Unidad del combo
                let UnidadLectura = pbComboUnidades.val() ? pbComboUnidades.val() : ($('flx-dbcombo[name = "pbComboUnidades"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboUnidades"] li.selected')[0].dataset.value : null);
                flexygo.pda.addLock();
                //Conversión de unidades
                let lectura = flexygo.pda.articulo.ConvertirUnidades(pbComboArticulo.val(), pbComboLote.val(), pbComboEmbalaje.val(), UnidadLectura, pbCantidad.val() ? pbCantidad.val() : 0);
                lectura.then(function (datos) {
                    if (datos) {
                        pbCantidadStock.val(datos.Cantidad_Stock);
                        $('#btnConfirmar').focus();
                    }
                    flexygo.pda.removeLock();
                });
                lectura.catch(function (error) { if (error && error != "") {
                    flexygo.msg.warning(error);
                } });
            };
            //PICKING - ARTÍCULO: limpieza de campos de la pantalla principal de lectura de artículo
            preparacion.LimpiarCampos = () => {
                //Campos de artículo
                $("#CodBarras").val(null);
                $("#cboArticulos").val(null);
                //Campos de proveedor
                $("#loteProv").val(null);
                $('#loteProv').hide();
                //Combos Propiedades
                $('#cboP1').hide();
                $('#cboP1').val(null);
                $('#cboP2').hide();
                $('#cboP2').val(null);
                //Campos de cantidades y tipos de unidad
                $("#cantidad").val(null);
                $("#cboUnidades").val(null);
                $("#cantidadStock").val(null);
                $("#unidadStock").val(null);
                $("#stock").val(null);
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                auxdef.valorBusqueda = "";
                page.defaults = JSON.stringify(auxdef);
                //Contador
                flexygo.pda.loadBadgeValue($('#badge'), 'IdDocDetalle', 'VPDA_Picking_Detalle', 'IdTrabajoAlm', 'IdTrabajo');
                //Foco
                $("#CodBarras")[0].querySelector("input").focus();
            };
            //PICKING - ARTÍCULO: limpia el filtro de bulto sin eliminar el additional-where
            preparacion.LimpiarFiltroBulto = (item, modName, modType, pageDefaults) => {
                let arrItems = item.split(",");
                let Max = arrItems.length;
                for (var i = 0; i < Max; i++) {
                    if ($(arrItems[i])[0].tagName == "FLX-DBCOMBO") {
                        $(arrItems[i] + " ul li").removeClass("selected");
                    }
                    $(arrItems[i]).val(null);
                }
                $(arrItems[0]).find("input").focus();
                if (modName) {
                    let arrmodName = modName.split(",");
                    let Max2 = arrmodName.length;
                    for (var i = 0; i < Max2; i++) {
                        let module = $(`[modulename=${arrmodName[i]}]${modType}`)[0];
                        module.additionalWhere = "1 = 0";
                        module.init();
                    }
                }
                if (pageDefaults) {
                    let arrDefaults = pageDefaults.split(",");
                    let Max3 = arrDefaults.length;
                    let myModule = $('flx-module')[0];
                    let page = flexygo.history.get(myModule);
                    let auxdef = {};
                    try {
                        auxdef = JSON.parse(page.defaults);
                    }
                    catch (e) {
                        auxdef = {};
                    }
                    if (auxdef) {
                        for (var i = 0; i < Max3; i++) {
                            auxdef[arrDefaults[i]] = '';
                        }
                        page.defaults = JSON.stringify(auxdef);
                    }
                }
            };
            //PICKING - ARTÍCULO: botón confirmar lectura
            preparacion.FinalizarLecturaArticulo = (e) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Datos
                let pbComboBulto = $('flx-dbcombo[name = "pbComboBulto"]');
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let IdUbicacionLectura = auxdef.IdUbicacionLectura ? auxdef.IdUbicacionLectura : 0;
                let revisaBulto = (!$('#contBulto')[0].classList.contains("hidden") || pbComboBulto.val());
                let BultoLiquidar = 0;
                //Validamos datos de interfaz
                if (!pbComboArticulo.val()) {
                    flexygo.msg.warning("Introduzca el artículo", null, '');
                    return;
                }
                if (pbComboLote.attr("style") != 'display: none;' && !pbComboLote.val()) {
                    flexygo.msg.warning("Introduzca el lote", null, '');
                    return;
                }
                if (pbComboP1.attr("style") != 'display: none;' && !pbComboP1.val()) {
                    flexygo.msg.warning("Introduzca la propiedad 1", null, '');
                    return;
                }
                if (pbComboP2.attr("style") != 'display: none;' && !pbComboP2.val()) {
                    flexygo.msg.warning("Introduzca la propiedad 2", null, '');
                    return;
                }
                if (!pbCantidad.val()) {
                    flexygo.msg.warning("Introduzca la cantidad", null, '');
                    return;
                }
                //Comprobamos si tenemos visible el campo de bulto en cuyo caso DEBERÍA haber uno introducido
                if (revisaBulto && !pbComboBulto.val()) {
                    flexygo.msg.warning("Introduzca un código de bulto.", null, '');
                    return;
                }
                flexygo.pda.addLock();
                //Se valida que el bulto cumpla con las condiciones necesaria para ser seleccionado
                if (revisaBulto) {
                    //Verificamos si existen bultos en la ubicación 
                    let consulta = `IdEstado IN (2,3) AND IdArticulo = '${pbComboArticulo.val()}' AND IdUbicacion = '${IdUbicacionLectura}' AND Cantidad >= ${pbCantidad.val()}`;
                    consulta += pbComboLote.val() ? ` AND ISNULL(Lote,'') = '${pbComboLote.val()}'` : '';
                    consulta += pbComboP1.val() ? ` AND ISNULL(P1,'') = '${pbComboP1.val()}'` : '';
                    consulta += pbComboP2.val() ? ` AND ISNULL(P2,'') = '${pbComboP2.val()}'` : '';
                    consulta += pbComboBulto.val() ? ` AND IdBulto = ${pbComboBulto.val()}` : '';
                    let Bulto = new flexygo.obj.Entity('SGA_PDA_Bulto');
                    let Bultos = Bulto.getView("SGA_PDA_v_Bulto_Detalles", 0, 10000, consulta, "", null);
                    if (Bultos.length == 0) {
                        flexygo.msg.warning("El código de bulto introducido no es válido.", null, '');
                        return;
                    }
                    BultoLiquidar = pbComboBulto.val();
                }
                flexygo.pda.preparacion.FinalizarPickingArticulo(e, BultoLiquidar);
            };
            //PICKING - ARTÍCULO: revisa si la lectura de picking es correcta y da el siguiente detalle en caso de existir
            preparacion.FinalizarPickingArticulo = (e, IdBulto) => {
                //Parámetros y campos
                let parametros = $(`.param`);
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbCodigoArticulo = $('flx-text[name = "pbCodigoArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Datos
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                let CodUbicLeida = auxdef.UbicacionLectura ? auxdef.UbicacionLectura : 0;
                let IdTrabajo = auxdef.IdTrabajo ? auxdef.IdTrabajo : 0;
                flexygo.pda.addLock();
                //Validamos contra trabajo 
                let detalleTrabajo = flexygo.pda.trabajo.ValidarLecturaPicking(IdDocDetalle, pbComboArticulo.val(), pbComboLote.val(), pbComboP1.val(), pbComboP2.val(), pbCantidad.val());
                detalleTrabajo.then(function (DetalleTrabajo) {
                    let proc = new flexygo.Process('SGA_PDA_dll_trabajo_conflectpicking', null, null);
                    let params = [
                        { 'Key': 'IdDocDetalle', 'Value': IdDocDetalle },
                        { 'Key': 'CodUbicLectura', 'Value': CodUbicLeida },
                        { 'Key': 'CodBarrasLectura', 'Value': pbCodigoArticulo.val() ? pbCodigoArticulo.val() : "" },
                        { 'Key': 'ArticuloBultoLectura', 'Value': pbComboArticulo.val() },
                        { 'Key': 'LoteLectura', 'Value': pbComboLote.val() },
                        { 'Key': 'P1Lectura', 'Value': pbComboP1.val() ? pbComboP1.val() : "" },
                        { 'Key': 'CantidadLectura', 'Value': pbCantidad.val() },
                        { 'Key': 'IdBultoLiquidar', 'Value': IdBulto },
                        { 'Key': 'IdTrabajo', 'Value': IdTrabajo }
                    ];
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                flexygo.pda.removeLock();
                            }
                            if (response.LastException && response.LastException.Message) {
                                flexygo.msg.error(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                flexygo.msg.warning(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                //están todos recogidos se debe pedir la ubicación destino
                                if (response.Data.TodosRecogidos != 0) {
                                    flexygo.pda.removeLock();
                                    flexygo.pda.preparacion.FinalizarTrabajoPicking(e);
                                }
                                else {
                                    let proc = new flexygo.Process('SGA_PDA_dll_siguientes_pickingsalida', null, null);
                                    let params = [
                                        { 'Key': 'IdTrabajoAlm', 'Value': IdTrabajo },
                                        { 'Key': 'IdDoc', 'Value': 0 },
                                        { 'Key': 'IdDocSiguiente', 'Value': 0 },
                                        { 'Key': 'CodigoUbic', 'Value': "" }
                                    ];
                                    proc.run(params, (response) => {
                                        if (response) {
                                            if (response.JSCode) {
                                                var func = new Function(response.JSCode);
                                                func.call(response.JSCode);
                                                flexygo.pda.removeLock();
                                            }
                                            if (response.LastException && response.LastException.Message) {
                                                flexygo.msg.error(response.LastException.Message);
                                            }
                                            else if (response.WarningMessage) {
                                                flexygo.msg.warning(response.WarningMessage);
                                            }
                                            else if (response.SuccessMessage) {
                                                let lIdDocSiguiente = response.Data.IdDocSiguiente;
                                                if (lIdDocSiguiente > 0) {
                                                    //se vuelve a buscar el proximo detalle, pasandole el lIdDocSiguiente
                                                    let proc = new flexygo.Process('SGA_PDA_dll_siguientes_pickingsalida', null, null);
                                                    let params = [
                                                        { 'Key': 'IdTrabajoAlm', 'Value': -1 },
                                                        { 'Key': 'IdDoc', 'Value': lIdDocSiguiente },
                                                        { 'Key': 'IdDocSiguiente', 'Value': 0 },
                                                        { 'Key': 'CodigoUbic', 'Value': "" }
                                                    ];
                                                    proc.run(params, (response) => {
                                                        if (response) {
                                                            if (response.JSCode) {
                                                                var func = new Function(response.JSCode);
                                                                func.call(response.JSCode);
                                                                flexygo.pda.removeLock();
                                                            }
                                                            if (response.LastException && response.LastException.Message) {
                                                                flexygo.msg.error(response.LastException.Message);
                                                                flexygo.nav.openPageName('PDA_pg_Preparacion_Picking_3', 'SGA_PDA_Trabajos_Almacen', 'IdTrabajoAlm = ' + IdTrabajo + ' AND IdDocDetalle = ' + IdDocDetalle, page.defaults, 'current', true);
                                                            }
                                                            else if (response.WarningMessage) {
                                                                flexygo.msg.warning(response.WarningMessage);
                                                                flexygo.nav.openPageName('PDA_pg_Preparacion_Picking_3', 'SGA_PDA_Trabajos_Almacen', 'IdTrabajoAlm = ' + IdTrabajo + ' AND IdDocDetalle = ' + IdDocDetalle, page.defaults, 'current', true);
                                                            }
                                                            else if (response.SuccessMessage) {
                                                                if (CodUbicLeida == response.Data.CodigoUbic) {
                                                                    auxdef.IdDocDetalle = lIdDocSiguiente;
                                                                    page.defaults = JSON.stringify(auxdef);
                                                                    flexygo.nav.openPageName('PDA_pg_Preparacion_Picking_4', 'SGA_PDA_Trabajos_Almacen', 'IdTrabajoAlm = ' + IdTrabajo + ' AND IdDocDetalle = ' + lIdDocSiguiente, page.defaults, 'current', true);
                                                                }
                                                                else {
                                                                    auxdef.IdDocDetalle = lIdDocSiguiente;
                                                                    page.defaults = JSON.stringify(auxdef);
                                                                    flexygo.nav.openPageName('PDA_pg_Preparacion_Picking_3', 'SGA_PDA_Trabajos_Almacen', 'IdTrabajoAlm = ' + IdTrabajo + ' AND IdDocDetalle = ' + lIdDocSiguiente, page.defaults, 'current', true);
                                                                }
                                                            }
                                                        }
                                                    });
                                                }
                                                else {
                                                    flexygo.nav.openPageName('PDA_pg_Preparacion_Picking_3', 'SGA_PDA_Trabajos_Almacen', 'IdTrabajoAlm = ' + IdTrabajo + ' AND IdDocDetalle = ' + IdDocDetalle, page.defaults, 'current', true);
                                                }
                                            }
                                        }
                                    });
                                    return;
                                }
                            }
                        }
                    });
                });
                detalleTrabajo.catch(function (error) {
                    if (error && error != "") {
                        flexygo.msg.warning(error);
                        return;
                    }
                });
            };
            //PICKING - UBICACIÓN DESTINO: Incidencia ubicación
            preparacion.IncidenciaUbicacion = (e) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                let IdOrden = auxdef.IdOrden ? auxdef.IdOrden : 0;
                let IdTrabajo = auxdef.IdTrabajo ? auxdef.IdTrabajo : 0;
                if (IdOrden) {
                    auxdef.IdOrdenCarga = IdOrden;
                    auxdef.IdTrabajo = IdTrabajo;
                    page.defaults = JSON.stringify(auxdef);
                    flexygo.pda.incidencia.Rellenar(e);
                }
                else {
                    flexygo.msg.warning("Indique Bulto");
                }
            };
            //PICKING - UBICACIÓN DESTINO: Confirmar ubicación y finalizar picking
            preparacion.ConfirmarUbicacionDestinoPicking = (e) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Parámetros
                let pbCodigoUbicacion = $('flx-text[name = "pbCodigoUbicacion"]');
                let pbComboUbicacion = $('flx-dbcombo[name = "pbComboUbicacion"]');
                let IdOrden = auxdef.IdOrden ? auxdef.IdOrden : 0;
                flexygo.pda.addLock();
                //Si no tiene datos no se ha introducido la ubicación
                if (!pbComboUbicacion.val()) {
                    flexygo.msg.warning("No ha introducido una Ubicación");
                    return;
                }
                //Encontramos módulos con datos
                let CodUbicacion;
                $("flx-module.LecturaUbicacionDatos").find('flx-list, flx-view').map(function (indice, modulo) {
                    if (!CodUbicacion) {
                        let module = $(modulo)[0];
                        CodUbicacion = module.data[0] ? (module.data[0].Codigo ? module.data[0].Codigo : "") : "";
                    }
                });
                //Si no encontramos lanzamos búsqueda por objeto
                if (!CodUbicacion) {
                    let Ubicacion = new flexygo.obj.Entity(`SGA_PDA_Ubicacion`, `IdAlmacen = ${flexygo.context.currentAlmacen} AND IdUbicacion = '${pbComboUbicacion.val()}'`);
                    Ubicacion.read();
                    CodUbicacion = Ubicacion.data.Codigo.Value;
                }
                let proc = new flexygo.Process('SGA_PDA_dll_Trabajo_Picking_Validar', null, null);
                let params = [
                    { 'Key': 'CodUbicacion', 'Value': CodUbicacion },
                    { 'Key': 'IdOrden', 'Value': IdOrden }
                ];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                        else if (response.SuccessMessage) {
                            flexygo.pda.preparacion.Comenzar(e, IdOrden, 0, false, 0);
                        }
                    }
                    flexygo.pda.removeLock();
                });
            };
        })(preparacion = pda.preparacion || (pda.preparacion = {}));
    })(pda = flexygo.pda || (flexygo.pda = {}));
})(flexygo || (flexygo = {}));
//# sourceMappingURL=preparacion.js.map