var flexygo;
(function (flexygo) {
    var pda;
    (function (pda) {
        var trabajo;
        (function (trabajo) {
            trabajo.RellenarPropiedadesTemp = (IdTrabajo) => {
                let promesa = new Promise(function (resolve, reject) {
                    //Lanzar carga de descripción de artículos con lotes para el trabajo. Necesario para mostrar las descripciones en las lecturas.
                    let proc = new flexygo.Process('SGA_PDA_dll_RellenaTablaTemporalPropiedadesTrabajo', null, null);
                    let params = [{ 'Key': 'IdTrabajo', 'Value': IdTrabajo }];
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                return resolve();
                            }
                            if (response.LastException && response.LastException.Message) {
                                return reject(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                return reject(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                return resolve();
                            }
                        }
                    });
                });
                return promesa;
            };
            trabajo.ValidarLecturaPicking = (IdDocDetalle, IdArticulo, Lote, P1, P2, Cantidad) => {
                let promesa = new Promise(function (resolve, reject) {
                    //No debería pasar, se valida por si en algún punto del flujo se hubiera perdido el IdDocDetalle
                    if (!IdDocDetalle) {
                        return reject('No se ha recibido el detalle del trabajo');
                    }
                    //Detalle del trabajo
                    let DetalleTrabajo = new flexygo.obj.Entity(`SGA_PDA_Trabajo_Almacen_Detalle`, `IdDoc = ${IdDocDetalle}`);
                    DetalleTrabajo.read();
                    if (!DetalleTrabajo) {
                        return reject('No se ha podido recuperar el detalle del trabajo');
                    }
                    //Artículo 
                    if (IdArticulo && DetalleTrabajo.data.IdArticulo && DetalleTrabajo.data.IdArticulo.Value != IdArticulo) {
                        return reject(flexygo.string.format('El artículo introducido {0} no coincide con el artículo del trabajo {1}', IdArticulo, DetalleTrabajo.data.IdArticulo.Value));
                    }
                    //Lote
                    if (Lote && DetalleTrabajo.data.NumLote && DetalleTrabajo.data.NumLote.Value != Lote) {
                        return reject(flexygo.string.format('El Lote recuperado {0} no coincide con el lote del trabajo {1}', Lote, DetalleTrabajo.data.NumLote.Value));
                    }
                    //P1
                    if (P1 && DetalleTrabajo.data.P1 && DetalleTrabajo.data.P1.Value != P1) {
                        return reject(flexygo.string.format('La propiedad recuperada {0} no coincide con la propiedad del trabajo {1}', P1, DetalleTrabajo.data.P1.Value));
                    }
                    ;
                    //P2
                    if (P2 && DetalleTrabajo.data.P2 && DetalleTrabajo.data.P2.Value != P2) {
                        return reject(flexygo.string.format('La propiedad P2 recuperada {0} no coincide con la propiedad del trabajo {1}', P2, DetalleTrabajo.data.P2.Value));
                    }
                    ;
                    //Cantidad
                    if (Cantidad && DetalleTrabajo.data.Cantidad) {
                        if (Cantidad > DetalleTrabajo.data.Cantidad.Value) {
                            return reject(flexygo.string.format('La cantidad leída {0} supera a la cantidad del trabajo {1}', Cantidad.toString(), DetalleTrabajo.data.Cantidad.Value));
                        }
                        if (Cantidad == 0) {
                            return reject(flexygo.string.format('La cantidad leída {0} tiene que ser mayor que cero.', Cantidad.toString()));
                        }
                    }
                    ;
                    return resolve(DetalleTrabajo);
                });
                return promesa;
            };
        })(trabajo = pda.trabajo || (pda.trabajo = {}));
    })(pda = flexygo.pda || (flexygo.pda = {}));
})(flexygo || (flexygo = {}));
//# sourceMappingURL=trabajo.js.map