var flexygo;
(function (flexygo) {
    var pda;
    (function (pda) {
        var traspaso;
        (function (traspaso) {
            //GENÉRICO: El evento OnKeyUp se usa para no lanzar la acción del enter sobre los focos de botón. Es necesario un OnKeyDown sólo para el tabulador
            traspaso.readKeyTab = (e, funcname, params) => {
                if (e.keyCode == 9) {
                    e.preventDefault();
                    flexygo.pda.traspaso[funcname].apply(flexygo.pda.traspaso, params);
                }
                else {
                    return;
                }
            };
            //GENÉRICO: Leer carácter y lanzar función en caso de encontrarlo
            traspaso.readByCharacter = (e, funcname, params) => {
                if (e.keyCode == 13) {
                    flexygo.pda.traspaso[funcname].apply(flexygo.pda.traspaso, params);
                }
                else {
                    return;
                }
            };
            //SELECCIÓN TRABAJO: botón comenzar y continaur en flujo de trabajos
            traspaso.Continuar = (e, IdTrabajoAlm, IdDocDetalle) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                if (!IdTrabajoAlm) {
                    flexygo.msg.warning("No se ha seleccionado un trabajo.", null, '');
                    return;
                }
                flexygo.pda.addLock();
                let proc = new flexygo.Process('SGA_PDA_dll_Traspaso_Continuar', null, null);
                let params = [{ 'Key': 'IdTrabajoAlm', 'Value': IdTrabajoAlm }, { 'Key': 'IdDocDetalle', 'Value': IdDocDetalle }];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                        else if (response.SuccessMessage) {
                            auxdef.IdTrabajo = response.Data.IdTrabajo;
                            auxdef.IdDocDetalle = response.Data.IdDocDetalle;
                            page.defaults = JSON.stringify(auxdef);
                            if (response.Data.IdDocDetalle == 0) {
                                //Si hay más trabajos debe llevarme al siguiente, no al home
                                let objeto = new flexygo.obj.Entity(`SGA_PDA_Trabajo_Almacen`);
                                objeto.read();
                                let trabajos = objeto.getView("SGA_PDA_v_Trabajos_Traspasos", 0, 500, null, "", null);
                                if (trabajos.legth > 0) {
                                    flexygo.pda.removeLock();
                                    flexygo.pda.traspaso.Continuar(e, trabajos[0].IdTrabajo, null);
                                }
                                else {
                                    flexygo.msg.success("Trabajo realizado con éxito", null, null);
                                    flexygo.nav.execProcess('GoHome', '', '', null, null, 'current', false, e);
                                }
                            }
                            else {
                                if (response.Data.EsBulto && response.Data.IdEstado == 0) {
                                    //Está comenzando el trabajo
                                    flexygo.nav.openPageName('PDA_pg_Traspaso_Detalles', 'SGA_PDA_Trabajos_Almacen_Detalle', 'IdDocDetalle = ' + response.Data.IdDocDetalle, page.defaults, 'current', false);
                                }
                                else if (response.Data.EsBulto && response.Data.IdEstado == 2) {
                                    //El trabajo ya ha comenzado
                                    flexygo.nav.openPageName('PDA_pg_Traspaso_Detalles_3', 'SGA_PDA_Trabajos_Almacen_Detalle', 'IdDocDetalle = ' + response.Data.IdDocDetalle, page.defaults, 'current', false);
                                }
                                else if (!response.Data.EsBulto && response.Data.IdEstado == 2 && response.Data.IdDocDetalle == -1) {
                                    //Están todos recogidos
                                    flexygo.pda.traspaso.FinalizarPicking(e);
                                }
                                else {
                                    //Picking
                                    //Cargar la descripción de las propiedades de los detalles del trabajo para mostrarlos en las lecturas
                                    let rellenarPropidades = flexygo.pda.trabajo.RellenarPropiedadesTemp(IdTrabajoAlm);
                                    rellenarPropidades.catch(function (error) { if (error && error != "") {
                                        flexygo.msg.warning(error);
                                    } });
                                    flexygo.nav.openPageName('PDA_pg_Traspaso_Picking_2', 'SGA_PDA_Trabajos_Almacen_Detalle', 'IdDocDetalle = ' + auxdef.IdDocDetalle, page.defaults, 'current', false);
                                }
                            }
                        }
                    }
                    flexygo.pda.removeLock();
                });
            };
            //LECTURA UBICACIÓN ORIGEN BULTO: botón comenzar pasa a validación del bulto
            traspaso.Comenzar = (e, modDatos, modLectura, pgn) => {
                //Módulo con la información de la ubicación leída
                let Datos = $(`[modulename=${modDatos}]flx-list`)[0];
                let Lectura = $(`[modulename=${modLectura}]flx-list`)[0];
                //Parámetros
                let pbCodigo = $('flx-text[name = "pbCodigoUbicacion"]');
                let pbCombo = $('flx-dbcombo[name = "pbComboUbicacion"]');
                //Si no tiene datos no se ha introducido la ubicación
                if (!Lectura.data || Lectura.data.length == 0) {
                    flexygo.msg.warning("No ha introducido una Ubicación");
                    pbCodigo[0].querySelector('input').focus();
                    return;
                }
                flexygo.pda.addLock();
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                auxdef.valorBusqueda = "";
                //Verificamos trabajo y detalle, la vuelta atrás puede hacer que tenga valores erróneos
                if (Datos.data[0].IdTrabajoAlm != auxdef.IdTrabajo || Datos.data[0].IdDocDetalle != auxdef.IdDocDetalle) {
                    flexygo.msg.warning("Los datos internos de trabajo y detalle no coinciden con los actuales. Vuelva a seleccionar el trabajo.");
                    flexygo.nav.openPageName('PDA_pg_Traspaso', '', '', '', 'current', true);
                    return;
                }
                //Si no coincide la ubicación leída
                if (Datos.data[0].IdUbicacion != Lectura.data[0].IdUbicacion) {
                    flexygo.msg.confirm('La ubicación indicada no coincide con la del trabajo. ¿Desea continuar?', function (ret) {
                        if (!ret) {
                            flexygo.pda.ubicacion.LimpiarUbicacion();
                            return;
                        }
                        else {
                            //Datos adicionales
                            let IdBulto = Datos.data[0].IdBulto;
                            auxdef.CodUbicLect = Lectura.data[0].Codigo;
                            page.defaults = JSON.stringify(auxdef);
                            flexygo.nav.openPageName(pgn, 'SGA_PDA_Bulto', 'IdBulto = ' + IdBulto, page.defaults, 'current', false);
                        }
                    });
                }
                else {
                    //Datos adicionales
                    let IdBulto = Datos.data[0].IdBulto;
                    auxdef.CodUbicLect = Lectura.data[0].Codigo;
                    page.defaults = JSON.stringify(auxdef);
                    flexygo.nav.openPageName(pgn, 'SGA_PDA_Bulto', 'IdBulto = ' + IdBulto, page.defaults, 'current', false);
                }
            };
            //LECTURA UBICACIÓN ORIGEN BULTO: botón siguiente da siguiente detalle
            //LECTURA ARTICULO PICKING: botón siguiente da siguiente detalle
            traspaso.Siguiente = (e) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Datos de trabajo y detalle actuales
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                let IdTrabajo = auxdef.IdTrabajo ? auxdef.IdTrabajo : 0;
                flexygo.pda.addLock();
                let proc = new flexygo.Process('SGA_PDA_dll_Traspaso_Continuar', null, null);
                let params = [{ 'Key': 'IdTrabajoAlm', 'Value': IdTrabajo }, { 'Key': 'IdDocDetalle', 'Value': IdDocDetalle }];
                proc.run(params, (response) => {
                    if (response) {
                        if (response.JSCode) {
                            var func = new Function(response.JSCode);
                            func.call(response.JSCode);
                            flexygo.pda.removeLock();
                        }
                        if (response.LastException && response.LastException.Message) {
                            flexygo.msg.error(response.LastException.Message);
                        }
                        else if (response.WarningMessage) {
                            flexygo.msg.warning(response.WarningMessage);
                        }
                        else if (response.SuccessMessage) {
                            if (IdDocDetalle != response.Data.IdDocDetalle) {
                                flexygo.pda.removeLock();
                                flexygo.pda.traspaso.Continuar(e, IdTrabajo, IdDocDetalle);
                            }
                            else {
                                flexygo.msg.info("Este es el último trabajo de este cliente. Opción cancelada.", null, null);
                            }
                        }
                    }
                });
            };
            //LECTURA BULTO: botón incidencia
            traspaso.IncidenciaBulto = (e) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Propiedades de la lectura
                let pbComboBulto = $('flx-dbcombo[name = "pbComboBulto"]');
                //si no hay lectura se sale
                if (!pbComboBulto.val()) {
                    flexygo.msg.warning("Introduzca un bulto.");
                    flexygo.pda.setAutomaticFocus(e);
                    return;
                }
                //Valores para la incidencia
                auxdef.IdBulto = pbComboBulto.val();
                page.defaults = JSON.stringify(auxdef);
                //Lanzamos incidencia
                flexygo.pda.incidencia.preparaIncidencia(e, "IdBulto,IdDocDetalle");
            };
            //LECTURA BULTO: botón confirmar la lectura
            traspaso.Confirmar = (e, modDatos, modLectura, pgn) => {
                //Módulo con la información de la ubicación leída
                let Datos = $(`[modulename=${modDatos}]flx-list`)[0];
                let Lectura = $(`[modulename=${modLectura}]flx-list`)[0];
                //Parámetros
                let pbCodigo = $('flx-text[name = "pbCodigoBulto"]');
                let pbCombo = $('flx-dbcombo[name = "pbComboBulto"]');
                //Si no tiene datos no se ha introducido el bulto
                if (!Lectura.data || Lectura.data.length == 0) {
                    flexygo.msg.warning("No ha introducido un bulto.");
                    pbCodigo[0].querySelector('input').focus();
                    return;
                }
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Datos adicionales
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                let CodUbicLect = auxdef.CodUbicLect ? auxdef.CodUbicLect : "";
                let proc = new flexygo.Process('SGA_PDA_dll_Trabajo_Traspaso_ConfirmaLecturaBulto', null, null);
                let params = [
                    { "Key": "IdDocDetalle", "Value": IdDocDetalle },
                    { "Key": "CodUbicLect", "Value": CodUbicLect },
                    { "Key": "CodBultoLect", "Value": Lectura.data[0].CodBarras1 }
                ];
                //Si no coincide el bulto leído
                if (Datos.data[0].IdBulto != Lectura.data[0].IdBulto) {
                    flexygo.msg.confirm('El bulto no coincide.¿Desea continuar?', function (ret) {
                        if (!ret) {
                            flexygo.pda.bulto.LimpiarBulto(true);
                            pbCodigo[0].querySelector('input').focus();
                            return;
                        }
                        else {
                            flexygo.pda.addLock();
                            proc.run(params, (response) => {
                                if (response) {
                                    if (response.JSCode) {
                                        var func = new Function(response.JSCode);
                                        func.call(response.JSCode);
                                        flexygo.pda.removeLock();
                                    }
                                    if (response.LastException && response.LastException.Message) {
                                        flexygo.msg.error(response.LastException.Message);
                                    }
                                    else if (response.WarningMessage) {
                                        flexygo.msg.warning(response.WarningMessage);
                                    }
                                    else if (response.SuccessMessage) {
                                        page.defaults = JSON.stringify(auxdef);
                                        flexygo.nav.openPageName(pgn, 'SGA_PDA_Trabajos_Almacen_Detalle', 'IdDocDetalle = ' + IdDocDetalle, page.defaults, 'current', false);
                                    }
                                }
                            });
                        }
                    });
                }
                else {
                    flexygo.pda.addLock();
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                flexygo.pda.removeLock();
                            }
                            if (response.LastException && response.LastException.Message) {
                                flexygo.msg.error(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                flexygo.msg.warning(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                page.defaults = JSON.stringify(auxdef);
                                flexygo.nav.openPageName(pgn, 'SGA_PDA_Trabajos_Almacen_Detalle', 'IdDocDetalle = ' + IdDocDetalle, page.defaults, 'current', false);
                            }
                        }
                    });
                }
            };
            //LECTURA BULTO UBICACIÓN DESTINO: botón finalizar
            //LECTURA ARTICULO PICKING: botón finalizar
            traspaso.Finalizar = (e, modDatos, modLectura) => {
                //Módulo con la información de la ubicación leída
                let Datos = $(`[modulename=${modDatos}]flx-list`)[0];
                let Lectura = $(`[modulename=${modLectura}]flx-list`)[0];
                //Parámetros
                let pbCodigo = $('flx-text[name = "pbCodigoUbicacion"]');
                let pbCombo = $('flx-dbcombo[name = "pbComboUbicacion"]');
                //Si no tiene datos no se ha introducido la ubicación
                if (!Lectura.data || Lectura.data.length == 0) {
                    flexygo.msg.warning("No ha introducido una Ubicación");
                    pbCodigo[0].querySelector('input').focus();
                    return;
                }
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Datos adicionales
                let idTrabajo = auxdef.IdTrabajo ? auxdef.IdTrabajo : 0;
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                let proc = new flexygo.Process('SGA_PDA_dll_Trabajo_Traspaso_Validar', null, null);
                let params = [{ "Key": "idTrabajo", "Value": idTrabajo }, { "Key": "CodUbicLect", "Value": Lectura.data[0].Codigo }];
                //Si no coincide la ubicación leída
                if (Datos.data[0].CodigoUbicacionDestino != Lectura.data[0].Codigo) {
                    flexygo.msg.confirm('La ubicación indicada no coincide con la del trabajo. ¿Desea continuar?', function (ret) {
                        if (!ret) {
                            flexygo.pda.ubicacion.LimpiarUbicacion();
                            return;
                        }
                        else {
                            flexygo.pda.addLock();
                            proc.run(params, (response) => {
                                if (response) {
                                    if (response.JSCode) {
                                        var func = new Function(response.JSCode);
                                        func.call(response.JSCode);
                                        flexygo.pda.removeLock();
                                    }
                                    if (response.LastException && response.LastException.Message) {
                                        flexygo.msg.error(response.LastException.Message);
                                    }
                                    else if (response.WarningMessage) {
                                        flexygo.msg.warning(response.WarningMessage);
                                    }
                                    else if (response.SuccessMessage) {
                                        page.defaults = JSON.stringify(auxdef);
                                        flexygo.pda.traspaso.Continuar(e, idTrabajo, IdDocDetalle);
                                    }
                                }
                            });
                        }
                    });
                }
                else {
                    flexygo.pda.addLock();
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                flexygo.pda.removeLock();
                            }
                            if (response.LastException && response.LastException.Message) {
                                flexygo.msg.error(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                flexygo.msg.warning(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                page.defaults = JSON.stringify(auxdef);
                                flexygo.pda.traspaso.Continuar(e, idTrabajo, IdDocDetalle);
                            }
                        }
                    });
                }
            };
            //LECTURA UBICACIÓN DESTINO: botón Incidencia
            traspaso.IncidenciaUbicacion = (e) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Propiedades de la lectura
                let pbComboUbicacion = $('flx-dbcombo[name = "pbComboUbicacion"]');
                //si no hay lectura se sale
                if (!pbComboUbicacion.val()) {
                    flexygo.msg.warning("Introduzca una ubicación.");
                    flexygo.pda.setAutomaticFocus(e);
                    return;
                }
                //Valores para la incidencia
                auxdef.IdUbicacion = pbComboUbicacion.val();
                page.defaults = JSON.stringify(auxdef);
                //Lanzamos incidencia
                flexygo.pda.incidencia.preparaIncidencia(e, "IdUbicacion");
            };
            //LECTURA UBICACIÓN ORIGEN PICKING: inicializa el módulo con datos
            traspaso.IniUbicOrigenPicking = (e, modNameLect) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                let IdTrabajo = auxdef.IdTrabajo ? auxdef.IdTrabajo : 0;
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                let modType = 'flx-list';
                let modName = $(`[modulename=${modNameLect}]${modType}`)[0];
                modName.additionalWhere = "IdTrabajoAlm = " + IdTrabajo + " AND IdDocDetalle = " + IdDocDetalle;
                modName.refresh();
            };
            //LECTURA UBICACIÓN ORIGEN PICKING: botón para finalizar el trabajo de picking
            traspaso.FinalizarPicking = (e) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                let IdTrabajo = auxdef.IdTrabajo ? auxdef.IdTrabajo : 0;
                flexygo.nav.openPageName('PDA_pg_Traspaso_Picking_1', 'SGA_PDA_Trabajos_Almacen_Detalle', 'IdTrabajoAlm = ' + IdTrabajo, page.defaults, 'current', false);
            };
            //LECTURA UBICACIÓN ORIGEN PICKING: botón confirmar
            traspaso.ConfirmarUbicacionPicking = (e, CodUbicLect, IdUbicLect, modNameSel, modNameOri, pgn) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                let modSelected = $(`[modulename=${modNameSel}]flx-list`)[0];
                let modOrigen = $(`[modulename=${modNameOri}]flx-list`)[0];
                if (modSelected.data && modSelected.data.length > 0 && modOrigen.data && modOrigen.data.length > 0) {
                    flexygo.pda.addLock();
                    let CodUbicacion = modSelected.data[0].Codigo;
                    let IdUbicacion = modSelected.data[0].IdUbicacion;
                    let CodUbicOrigen = modOrigen.data[0].CodigoUbicacion;
                    if (CodUbicacion != CodUbicOrigen) {
                        flexygo.msg.confirm('La ubicación no coincide.¿Desea continuar?', function (ret) {
                            if (ret) {
                                let auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                                auxdef.UbicacionLectura = CodUbicacion;
                                auxdef.IdUbicacionLectura = IdUbicacion;
                                auxdef.UbicacionTrabajo = CodUbicOrigen;
                                let donde = "IdDocDetalle = " + IdDocDetalle;
                                page.defaults = JSON.stringify(auxdef);
                                flexygo.nav.openPageName(pgn, 'SGA_PDA_Almacenes', donde, page.defaults, 'current', true);
                            }
                            else {
                                flexygo.pda.ubicacion.LimpiarUbicacion();
                            }
                        });
                    }
                    else {
                        let auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                        auxdef.UbicacionLectura = CodUbicacion;
                        auxdef.IdUbicacionLectura = IdUbicacion;
                        auxdef.UbicacionTrabajo = CodUbicOrigen;
                        let donde = "IdDocDetalle = " + IdDocDetalle;
                        var obj = new flexygo.obj.Entity('SGA_PDA_Bulto');
                        let lista = obj.getView("SGA_PDA_v_Bulto_List", 0, 10000, `IdUbicacion = '${IdUbicacion}' AND IdEstado IN (2,3)`, "", null);
                        if (lista.length > 0) {
                            auxdef.Bultos = lista;
                        }
                        flexygo.pda.removeLock();
                        page.defaults = JSON.stringify(auxdef);
                        flexygo.nav.openPageName(pgn, 'SGA_PDA_Almacenes', donde, page.defaults, 'current', false);
                    }
                }
                else {
                    flexygo.msg.warning("Indique Ubicación", null, '');
                }
            };
            //LECTURA ARTÍCULO PICKING: carga los datos iniciales del trabajo
            traspaso.CargarDatosTrabajo = () => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Parámetros
                let CodUbicLeida = auxdef.UbicacionLectura ? auxdef.UbicacionLectura : 0;
                let CodUbicIni = auxdef.UbicacionTrabajo ? auxdef.UbicacionTrabajo : 0;
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                //Limpia el valor de búsqueda por si se recarga la página
                auxdef.valorBusqueda = "";
                //Cargar bulto a liquidar en caso de ser necesario
                let bultoLiquidar = flexygo.pda.bulto.BultoLiquidar(IdDocDetalle, CodUbicLeida);
                bultoLiquidar.then(function (datos) {
                    if (datos) {
                        auxdef.LiquidarBultoV = datos.LiquidarBulto;
                        page.defaults = JSON.stringify(auxdef);
                        if (datos.LiquidarBulto) {
                            $('#liqbulto').val(datos.CodBultoLiquidar);
                            $('#codbulto').val(datos.CodBultoLiquidar);
                        }
                        else {
                            $('#liqbulto').val(null);
                            $('#codbulto').val(null);
                        }
                        flexygo.pda.removeLock();
                    }
                });
                bultoLiquidar.catch(function (error) { if (error && error != "") {
                    flexygo.msg.warning(error);
                } });
            };
            //LECTURA ARTÍCULO PICKING: lectura de artículo 
            traspaso.LeerArticulo = (item, event) => {
                //Parámetros y campos
                let parametros = $(`.param`);
                let pbCodigo = $('flx-text[name = "pbCodigoArticulo"]');
                let pbCombo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbComboUnidades = $('flx-dbcombo[name = "pbComboUnidades"]');
                let pbCantidadStock = $('flx-text[name = "pbCantidadStock"]');
                let pbUnidadStock = $('flx-text[name = "pbUnidadStock"]');
                let pbStock = $('flx-text[name = "pbStock"]');
                let pbStockUbicacion = $('flx-text[name = "pbStockUbicacion"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                //Valor de búsqueda del campo de texto o del combo
                let valorBusqueda = ((item.tagName).toLowerCase() == "flx-text") ? pbCodigo.val() : pbCombo.val();
                if (!valorBusqueda) {
                    return;
                }
                ;
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                //Campo que indica si la lectura se ha llevado a cabo
                let read = false;
                //Si ha cambiado el valor del combo. Evitamos lanzar la búsqueda con el mismo valor.
                if (auxdef.valorBusqueda != valorBusqueda) {
                    //En caso de recibir parámetro con longitudes a tener en cuenta, y se trata del campo de texto, se verifica si se ha legeado al tamaño del parámetro
                    read = parametros ? (((item.tagName).toLowerCase() == "flx-text") ? flexygo.pda.readCode(parametros, valorBusqueda, event) : true) : true;
                }
                //Si damos la entrada como buena
                if (read) {
                    flexygo.pda.addLock();
                    //Búsqueda por CodBarras. Puede devolver datos como lote y propiedades
                    let articulo = flexygo.pda.articulo.Buscar(valorBusqueda);
                    articulo.then(function (datos) {
                        //TRATAMOS ARTÍCULO
                        //----------------------------------
                        //No encontrado
                        if (!datos.IdArticulo) {
                            flexygo.msg.warning("No se ha encontrado ningún artículo.");
                            flexygo.pda.traspaso.LimpiarCampos();
                            return;
                        }
                        //Validamos contra trabajo pasando los datos de la lectura por CodBarras. Puede devolver lote y propiedades.
                        let loteValidar = datos.LoteInterno ? datos.LoteInterno : (datos.Lote ? datos.Lote : "");
                        let detalleTrabajo = flexygo.pda.trabajo.ValidarLecturaPicking(IdDocDetalle, datos.IdArticulo, loteValidar, datos.P1 ? datos.P1 : "", datos.P2 ? datos.P2 : "", 0);
                        detalleTrabajo.then(function (DetalleTrabajo) {
                            //Valores de campos de búsqueda
                            if ((item.tagName).toLowerCase() == "flx-dbcombo") {
                                //Evento lanzado por el combo, se pone en el código el CodBarras asociado o IdArticulo si no tiene código
                                valorBusqueda = datos.IdArticulo;
                                pbCodigo.val(valorBusqueda);
                            }
                            else {
                                //Evento lanzado por el campo de texto, se establece el ID en el combo
                                pbCombo.val(datos.IdArticulo);
                            }
                            //TRATAMOS LOTES
                            //----------------------------------
                            //Si recibimos lote interno lo cargamos y ocultamos el combo
                            if (datos.LoteInterno) {
                                pbLote.val(datos.LoteInterno);
                                pbLote.hide();
                            }
                            //Ocultamos o mostramos combo
                            if (!datos.RequiereLote) {
                                pbLote.hide();
                            }
                            else {
                                pbLote.show();
                                //Si recibimos el lote desde la lectura lo cargamos
                                if (datos.Lote) {
                                    pbLote.val(datos.Lote);
                                }
                                else if (DetalleTrabajo.data.NumLote.Value) {
                                    //Cargamos el lote del trabajo
                                    pbLote.val(DetalleTrabajo.data.NumLote.Value);
                                }
                            }
                            //TRATAMOS PROPIEDADES
                            //----------------------------------
                            //Ocultamos/Mostramos los combos y cargamos la propiedad recibida
                            datos.RequiereP1 ? pbComboP1.show() : pbComboP1.hide();
                            datos.RequiereP2 ? pbComboP2.show() : pbComboP2.hide();
                            if (datos.RequiereP1 && datos.P1) {
                                pbComboP1.val(datos.P1);
                            }
                            ;
                            if (datos.RequiereP2 && datos.P2) {
                                pbComboP2.val(datos.P2);
                            }
                            ;
                            //DESCOMENTAR PARA PERSONALIZAR. Precargamos las propiedades del trabajo
                            //if (DetalleTrabajo.data.P1.Value && !pbComboP1.val()) {
                            //    pbComboP1.val(DetalleTrabajo.data.P1.Value);
                            //}
                            //if (DetalleTrabajo.data.P2.Value && !pbComboP2.val()) {
                            //    pbComboP2.val(DetalleTrabajo.data.P2.Value);
                            //}
                            //TRATAMOS BULTO A LIQUIDAR
                            //----------------------------------
                            //En la carga del módulo se recupera el bulto a liquidar que se consumirá. Lo mostramos en caso de ser necesario
                            if ($('#liqbulto').val() && $('#contBulto')[0].classList.contains("hidden")) {
                                $('#contBulto')[0].classList.remove("hidden");
                            }
                            //TRATAMOS CANTIDAD
                            //----------------------------------
                            //Precargamos la cantidad de lectura
                            if (DetalleTrabajo.data.Cantidad.Value) {
                                pbCantidad.val(DetalleTrabajo.data.Cantidad.Value);
                            }
                            //TRATAMOS UNIDADES POR DEFECTO
                            //----------------------------------
                            //Se recupera el valor por defecto del tipo de unidad de artículo
                            let tipoUnidad = flexygo.pda.articulo.TipoUnidad(datos.IdArticulo, pbLote.val() ? pbLote.val() : "");
                            tipoUnidad.then(function (tipo) {
                                //Tipos de Unidades del artículo para conversiones
                                pbComboUnidades[0].additionalWhere = `IdArticulo = '${datos.IdArticulo}'`;
                                pbComboUnidades[0].refresh();
                                pbComboUnidades[0].querySelector("input").disabled = false;
                                if (tipo) {
                                    pbComboUnidades.val(tipo);
                                    pbUnidadStock.val(tipo);
                                    pbCantidadStock.val(null);
                                }
                            });
                            tipoUnidad.catch(function (error) {
                                if (error && error != "") {
                                    flexygo.msg.warning(error);
                                    return;
                                }
                            });
                            //TRATAMOS STOCK DE UBICACIÓN
                            //----------------------------------
                            //Cargar el stock. También devuelve el lote y las propiedades en caso de devolver un sólo registro de stock en la ubicación
                            let obtenerStock = flexygo.pda.ubicacion.ObtenerStock(datos.IdArticulo, pbLote.val(), pbComboP1.val(), pbComboP2.val(), auxdef.IdUbicacionLectura);
                            obtenerStock.then(function (stock) {
                                if (stock) {
                                    //Devuelve stock
                                    if (stock.stock) {
                                        pbStockUbicacion.val(stock.stock);
                                    }
                                    //Focos
                                    if (pbLote.attr("style") != 'display: none;' && !pbLote.val()) {
                                        pbLote[0].querySelector("input").focus();
                                    }
                                    else if (pbComboP1.attr("style") != 'display: none;' && !pbComboP1.val()) {
                                        pbComboP1[0].querySelector("input").focus();
                                    }
                                    else if (pbComboP2.attr("style") != 'display: none;' && !pbComboP2.val()) {
                                        pbComboP2[0].querySelector("input").focus();
                                    }
                                    else {
                                        pbCantidad[0].querySelector("input").focus();
                                    }
                                }
                            });
                            obtenerStock.catch(function (error) { if (error && error != "") {
                                flexygo.msg.warning(error);
                            } });
                            //Valor de búsqueda para no repetir acción si no cambia
                            auxdef.valorBusqueda = valorBusqueda;
                            page.defaults = JSON.stringify(auxdef);
                        });
                        detalleTrabajo.catch(function (error) {
                            if (error && error != "") {
                                flexygo.msg.warning(error);
                                flexygo.pda.traspaso.LimpiarCampos();
                                return;
                            }
                        });
                    });
                    articulo.catch(function (error) {
                        if (error && error != "") {
                            flexygo.msg.warning(error);
                            return;
                        }
                    });
                    flexygo.pda.removeLock();
                }
            };
            //LECTURA ARTÍCULO PICKING:: combo de lotes. Efecto de pérdida de foco
            traspaso.LeerLote = (item, event) => {
                //Parámetros y campos
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbStockUbicacion = $('flx-text[name = "pbStockUbicacion"]');
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Datos
                let lote = pbComboLote.val() ? pbComboLote.val() : ($('flx-dbcombo[name = "pbComboLote"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboLote"] li.selected')[0].dataset.value : null);
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                let IdUbicacionOrigen = auxdef.IdUbicacionOrigen ? auxdef.IdUbicacionOrigen : 0;
                let IdArticulo = pbComboArticulo.val() ? pbComboArticulo.val() : "";
                let P1 = pbComboP1.val() ? pbComboP1.val() : "";
                let P2 = pbComboP2.val() ? pbComboP2.val() : "";
                if (!lote) {
                    return;
                }
                flexygo.pda.addLock();
                //Validamos contra trabajo pasando los datos de la lectura por CodBarras. Puede devolver lote y propiedades.
                let detalleTrabajo = flexygo.pda.trabajo.ValidarLecturaPicking(IdDocDetalle, IdArticulo, lote, P1, P2, 0);
                detalleTrabajo.then(function (DetalleTrabajo) {
                    //Cargar el stock. También devuelve el lote y las propiedades en caso de devolver un sólo registro de stock en la ubicación
                    let lectura = flexygo.pda.ubicacion.ObtenerStock(IdArticulo, lote, P1, P2, IdUbicacionOrigen);
                    lectura.then(function (stock) {
                        if (stock) {
                            //Devuelve stock
                            if (stock.stock) {
                                pbStockUbicacion.val(stock.stock);
                            }
                            //Focos
                            if (pbComboLote.attr("style") != 'display: none;' && !pbComboLote.val()) {
                                pbComboLote[0].querySelector("input").focus();
                            }
                            else if (pbComboP1.attr("style") != 'display: none;' && !pbComboP1.val()) {
                                pbComboP1[0].querySelector("input").focus();
                            }
                            else if (pbComboP2.attr("style") != 'display: none;' && !pbComboP2.val()) {
                                pbComboP2[0].querySelector("input").focus();
                            }
                            else {
                                pbCantidad[0].querySelector("input").focus();
                            }
                        }
                        flexygo.pda.removeLock();
                    });
                    lectura.catch(function (error) { if (error && error != "") {
                        flexygo.msg.warning(error);
                    } });
                });
                detalleTrabajo.catch(function (error) {
                    if (error && error != "") {
                        flexygo.msg.warning(error);
                        flexygo.pda.traspaso.LimpiarCampos();
                        return;
                    }
                });
            };
            //LECTURA ARTÍCULO PICKING: combo de propiedades. Efecto de pérdida de foco
            traspaso.LeerPropiedad = (item, event) => {
                //Parámetros y campos
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbStockUbicacion = $('flx-text[name = "pbStockUbicacion"]');
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Datos
                let lote = pbComboLote.val() ? pbComboLote.val() : ($('flx-dbcombo[name = "pbComboLote"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboLote"] li.selected')[0].dataset.value : null);
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                let IdUbicacionOrigen = auxdef.IdUbicacionOrigen ? auxdef.IdUbicacionOrigen : 0;
                let IdArticulo = pbComboArticulo.val() ? pbComboArticulo.val() : "";
                let P1 = pbComboP1.val() ? pbComboP1.val() : ($('flx-dbcombo[name = "pbComboP1"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboP1"] li.selected')[0].dataset.value : null);
                let P2 = pbComboP2.val() ? pbComboP2.val() : ($('flx-dbcombo[name = "pbComboP2"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboP2"] li.selected')[0].dataset.value : null);
                flexygo.pda.addLock();
                //Validamos contra trabajo pasando los datos de la lectura por CodBarras. Puede devolver lote y propiedades.
                let detalleTrabajo = flexygo.pda.trabajo.ValidarLecturaPicking(IdDocDetalle, IdArticulo, lote, P1, P2, 0);
                detalleTrabajo.then(function (DetalleTrabajo) {
                    //Cargar el stock. También devuelve el lote y las propiedades en caso de devolver un sólo registro de stock en la ubicación
                    let lectura = flexygo.pda.ubicacion.ObtenerStock(IdArticulo, lote, P1, P2, IdUbicacionOrigen);
                    lectura.then(function (stock) {
                        if (stock) {
                            //Devuelve stock
                            if (stock.stock) {
                                pbStockUbicacion.val(stock.stock);
                            }
                            //Focos
                            if (pbComboLote.attr("style") != 'display: none;' && !pbComboLote.val()) {
                                pbComboLote[0].querySelector("input").focus();
                            }
                            else if (pbComboP1.attr("style") != 'display: none;' && !pbComboP1.val() && !P1) {
                                pbComboP1[0].querySelector("input").focus();
                            }
                            else if (pbComboP2.attr("style") != 'display: none;' && !pbComboP2.val() && !P2) {
                                pbComboP2[0].querySelector("input").focus();
                            }
                            else {
                                pbCantidad[0].querySelector("input").focus();
                            }
                        }
                        flexygo.pda.removeLock();
                    });
                    lectura.catch(function (error) {
                        if (error && error != "") {
                            flexygo.msg.warning(error);
                        }
                    });
                });
                detalleTrabajo.catch(function (error) {
                    if (error && error != "") {
                        flexygo.msg.warning(error);
                        flexygo.pda.traspaso.LimpiarCampos();
                        return;
                    }
                });
            };
            //LECTURA ARTÍCULO PICKING: introducción de cantidad leída y unidad de lectura
            traspaso.LeerCantidad = (item, event) => {
                //Parámetros y campos
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboEmbalaje = $('flx-dbcombo[name = "pbComboEmbalaje"]');
                let pbComboUnidades = $('flx-dbcombo[name = "pbComboUnidades"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                let pbCantidadStock = $('flx-text[name = "pbCantidadStock"]');
                //Unidad del combo
                let UnidadLectura = pbComboUnidades.val() ? pbComboUnidades.val() : ($('flx-dbcombo[name = "pbComboUnidades"] li.selected')[0] ? $('flx-dbcombo[name = "pbComboUnidades"] li.selected')[0].dataset.value : null);
                flexygo.pda.addLock();
                //Conversión de unidades
                let lectura = flexygo.pda.articulo.ConvertirUnidades(pbComboArticulo.val(), pbComboLote.val(), pbComboEmbalaje.val(), UnidadLectura, pbCantidad.val() ? pbCantidad.val() : 0);
                lectura.then(function (datos) {
                    if (datos) {
                        pbCantidadStock.val(datos.Cantidad_Stock);
                        $('#btnConfirmar').focus();
                    }
                    flexygo.pda.removeLock();
                });
                lectura.catch(function (error) { if (error && error != "") {
                    flexygo.msg.warning(error);
                } });
            };
            //LECTURA ARTÍCULO PICKING: limpieza de campos de la pantalla principal de lectura de artículo
            traspaso.LimpiarCampos = () => {
                //Campos de artículo
                $("#CodBarras").val(null);
                $("#cboArticulos").val(null);
                //Campos de proveedor
                $("#loteProv").val(null);
                $('#loteProv').hide();
                //Campos de bulto a liquidar
                if (!$('#contBulto')[0].classList.contains("hidden")) {
                    $('#contBulto')[0].classList.add("hidden");
                }
                $('#codbulto').val(null);
                $('#liqbulto').val(null);
                //Combos Propiedades
                $('#cboP1').hide();
                $('#cboP1').val(null);
                $('#cboP2').hide();
                $('#cboP2').val(null);
                //Campos de cantidades y tipos de unidad
                $("#cantidad").val(null);
                $("#cboUnidades").val(null);
                $("#cantidadStock").val(null);
                $("#unidadStock").val(null);
                $("#stock").val(null);
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                auxdef.valorBusqueda = "";
                page.defaults = JSON.stringify(auxdef);
                //Contador
                flexygo.pda.loadBadgeValue($('#badge'), 'IdDocDetalle', 'VPDA_Traspaso_Detalle', 'IdTrabajoAlm', 'IdTrabajo');
                //Foco
                $("#CodBarras")[0].querySelector("input").focus();
            };
            //LECTURA ARTÍCULO PICKING: botón para finalizar lectura de picking
            traspaso.FinalizarLecturaArticulo = (e, CodBarras, cboArticulos, cantidadLect, loteProv, codbulto, modName) => {
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Módulo
                let modSelected = $(`[modulename=${modName}]flx-list`)[0];
                //Datos
                let CodUbicLeida = auxdef.UbicacionLectura ? auxdef.UbicacionLectura : 0;
                let LiquidarBultoV = auxdef.LiquidarBultoV ? auxdef.LiquidarBultoV : 0;
                let codbarras1V = auxdef.codbarras1V ? auxdef.codbarras1V : "";
                let revisaBulto = false;
                let cantidad = cantidadLect.val();
                //Comprobamos si tenemos visible el campo de bulto en cuyo caso DEBERÍA haber uno introducido
                if (codbarras1V == "") {
                    revisaBulto = false;
                }
                else {
                    if (codbulto) {
                        revisaBulto = true;
                    }
                    else {
                        flexygo.msg.warning("Introduzca un código de bulto.", null, '');
                        revisaBulto = false;
                        return;
                    }
                }
                if (revisaBulto) {
                    let BultoEnt = new flexygo.obj.Entity(`SGA_PDA_Bulto`, "CodBarras1 = '" + codbulto.val() + "'");
                    BultoEnt.read();
                    if (BultoEnt.data.IdBulto.Value) {
                        flexygo.pda.addLock();
                        //Comprobamos si tenemos ESE bulto donde toca
                        let proc = new flexygo.Process('SGA_PDA_dll_TotalBultos', null, null);
                        let params = [
                            { 'Key': 'IdArticulo', 'Value': modSelected.data[0].Articulo },
                            { 'Key': 'CodUbicacion', 'Value': CodUbicLeida },
                            { 'Key': 'Cantidad', 'Value': cantidad },
                            { 'Key': 'Lote', 'Value': loteProv.val() ? loteProv.val() : "" },
                            { 'Key': 'IdBulto', 'Value': BultoEnt.data.IdBulto.Value }
                        ];
                        proc.run(params, (response) => {
                            if (response) {
                                if (response.JSCode) {
                                    var func = new Function(response.JSCode);
                                    func.call(response.JSCode);
                                    flexygo.pda.removeLock();
                                }
                                if (response.LastException && response.LastException.Message) {
                                    flexygo.msg.error(response.LastException.Message);
                                }
                                else if (response.WarningMessage) {
                                    flexygo.msg.warning(response.WarningMessage);
                                }
                                else if (response.SuccessMessage) {
                                    if (response.Data.TotalBultos != 0) {
                                        flexygo.pda.addLock();
                                        flexygo.pda.traspaso.FinalizarPickingArticulo(e, BultoEnt.data.IdBulto.Value);
                                    }
                                    else {
                                        flexygo.msg.warning("El código de bulto introducido no es válido.", null, '');
                                    }
                                }
                            }
                        });
                    }
                    else {
                        flexygo.msg.warning("El código de bulto introducido no es válido.", null, '');
                    }
                }
                else {
                    flexygo.pda.addLock();
                    flexygo.pda.traspaso.FinalizarPickingArticulo(e, 0);
                }
            };
            //LECTURA ARTÍCULO PICKING: revisa si la lectura de picking es correcta y da el siguiente detalle en caso de existir
            traspaso.FinalizarPickingArticulo = (e, IdBulto) => {
                //Parámetros y campos
                let parametros = $(`.param`);
                let pbComboArticulo = $('flx-dbcombo[name = "pbComboArticulo"]');
                let pbCodigoArticulo = $('flx-text[name = "pbCodigoArticulo"]');
                let pbComboLote = $('flx-dbcombo[name = "pbComboLote"]');
                let pbComboP1 = $('flx-dbcombo[name = "pbComboP1"]');
                let pbComboP2 = $('flx-dbcombo[name = "pbComboP2"]');
                let pbCantidad = $('flx-text[name = "pbCantidad"]');
                //Validamos datos de interfaz
                if (!pbComboArticulo.val()) {
                    flexygo.msg.warning("Introduzca el artículo", null, '');
                    return;
                }
                if (pbComboLote.attr("style") != 'display: none;' && !pbComboLote.val()) {
                    flexygo.msg.warning("Introduzca el lote", null, '');
                    return;
                }
                if (pbComboP1.attr("style") != 'display: none;' && !pbComboP1.val()) {
                    flexygo.msg.warning("Introduzca la propiedad 1", null, '');
                    return;
                }
                if (pbComboP2.attr("style") != 'display: none;' && !pbComboP2.val()) {
                    flexygo.msg.warning("Introduzca la propiedad 2", null, '');
                    return;
                }
                if (!pbCantidad.val()) {
                    flexygo.msg.warning("Introduzca la cantidad", null, '');
                    return;
                }
                //Defaults de la página
                let myModule = $('flx-module')[0];
                let page = flexygo.history.get(myModule);
                let auxdef;
                try {
                    auxdef = JSON.parse(page.defaults) ? JSON.parse(page.defaults) : {};
                }
                catch (e) {
                    auxdef = {};
                }
                //Datos
                let IdDocDetalle = auxdef.IdDocDetalle ? auxdef.IdDocDetalle : 0;
                let CodUbicLeida = auxdef.UbicacionLectura ? auxdef.UbicacionLectura : 0;
                let IdTrabajo = auxdef.IdTrabajo ? auxdef.IdTrabajo : 0;
                flexygo.pda.addLock();
                //Validamos contra trabajo 
                let detalleTrabajo = flexygo.pda.trabajo.ValidarLecturaPicking(IdDocDetalle, pbComboArticulo.val(), pbComboLote.val(), pbComboP1.val(), pbComboP2.val(), pbCantidad.val());
                detalleTrabajo.then(function (DetalleTrabajo) {
                    let proc = new flexygo.Process('SGA_PDA_dll_trabajo_conflectpicking', null, null);
                    let params = [
                        { 'Key': 'IdDocDetalle', 'Value': IdDocDetalle },
                        { 'Key': 'CodUbicLectura', 'Value': CodUbicLeida },
                        { 'Key': 'CodBarrasLectura', 'Value': pbCodigoArticulo.val() ? pbCodigoArticulo.val() : "" },
                        { 'Key': 'ArticuloBultoLectura', 'Value': pbComboArticulo.val() },
                        { 'Key': 'LoteLectura', 'Value': pbComboLote.val() },
                        { 'Key': 'P1Lectura', 'Value': pbComboP1.val() ? pbComboP1.val() : "" },
                        { 'Key': 'CantidadLectura', 'Value': pbCantidad.val() },
                        { 'Key': 'IdBultoLiquidar', 'Value': IdBulto },
                        { 'Key': 'IdTrabajo', 'Value': IdTrabajo }
                    ];
                    proc.run(params, (response) => {
                        if (response) {
                            if (response.JSCode) {
                                var func = new Function(response.JSCode);
                                func.call(response.JSCode);
                                flexygo.pda.removeLock();
                            }
                            if (response.LastException && response.LastException.Message) {
                                flexygo.msg.error(response.LastException.Message);
                            }
                            else if (response.WarningMessage) {
                                flexygo.msg.warning(response.WarningMessage);
                            }
                            else if (response.SuccessMessage) {
                                //están todos recogidos se debe pedir la ubicación destino
                                if (response.Data.TodosRecogidos != 0) {
                                    flexygo.pda.removeLock();
                                    flexygo.pda.traspaso.FinalizarPicking(e);
                                }
                                else {
                                    flexygo.pda.removeLock();
                                    flexygo.pda.traspaso.Continuar(e, IdTrabajo, IdDocDetalle);
                                    return;
                                }
                            }
                        }
                    });
                });
                detalleTrabajo.catch(function (error) {
                    if (error && error != "") {
                        flexygo.msg.warning(error);
                        return;
                    }
                });
            };
        })(traspaso = pda.traspaso || (pda.traspaso = {}));
    })(pda = flexygo.pda || (flexygo.pda = {}));
})(flexygo || (flexygo = {}));
//# sourceMappingURL=traspaso.js.map